
; (FREZCHEM works until SA=0.3 g/kg for sure. O.25g/kg has different eutectic - works until 240.15 or -33deg... dunno why)
;
;==================================================================================================
; Declare arrays
;==================================================================================================
;
i_correct_conservation = 1       ; impose mass conservation or not

N_T        = 363                 ; number of temperatures 40 for 1K steps, 363 for 0.1 K steps
N_S        = 41                  ; number of initial bulk salinities (41)
;
N_solute   = 21                  ; number of species in solution
N_solid    = 101                 ; number of species in solid minerals
c_name_solute = STRARR(N_solute) ; name of species in solution
c_name_solid  = STRARR(N_solid)  ; name of species in solid minerals
conc_solute   = DBLARR(N_solute,N_T,N_S) ; solution concentration array (these are molalities, mol X per kg H2O - not per kg solution)
conc_solid    = DBLARR(N_solid ,N_T,N_S) ; solid mineral concentration array (units???)
zc = '   '                       ; dummy character string
;
zf_temp    = DBLARR(7)           ; temperature dummy array
;
temp           = DBLARR(N_T)     ; temperature (K)
ionic_strength = DBLARR(N_T,N_S) ; ionic strength (?)
rho            = DBLARR(N_T,N_S) ; density (kg/L?)
Phi            = DBLARR(N_T,N_S) ; osmotic coefficient (what is that?)
M_H2O_liq      = DBLARR(N_T,N_S) ; water mass fraction (g/kg)
M_Ice          = DBLARR(N_T,N_S) ; ice mass fraction (g/kg)
Pres           = DBLARR(N_T,N_S) ; pressure (bars)
 
pH             = DBLARR(N_T,N_S) ; pH
nit            = LONARR(N_T,N_S) ; number of iterations to achieve convergence

;==================================================================================================
; Identify files to read
;==================================================================================================

OPENR, 10, 'output_file_list.txt'

file_name = STRARR(N_S)

SA        = DBLARR(N_S)

FOR i_S = 0, N_S - 1 DO BEGIN

   PRINT
   READF, 10, zc                                          &   PRINT, ' zc = ', zc
   file_name(i_S) = zc

   zaaa    = STRSPLIT( zc, 'S_', /EXTRACT)                &   PRINT, ' zaaa = ', zaaa

   zbbb    = STRSPLIT( zaaa(1),'.txt', /EXTRACT )         &   PRINT, ' zbbb = ', zbbb

   SA(i_S) = FLOAT( zbbb(0) ) ; + FLOAT( zbbb(1) ) * 0.01D  
   PRINT, ' S_A = ', SA(i_S)

   PRINT, ' file_name : ', file_name(i_S)

   PRINT

ENDFOR

CLOSE, 10

; correct salinity writing format bug
SA(WHERE(SA LE 0.)) = 0.3

;==================================================================================================
; Reading loop
;==================================================================================================

FOR i_S = 0, N_S - 1 DO BEGIN
   
   OPENR, 10, file_name(i_S)
   
   READF, 10, zc & PRINT, ' line 1 : ', zc
   zaaa = STRSPLIT(zc,/EXTRACT)
   
   FOR i_T = 0, N_T - 1 DO BEGIN
   
      PRINT, ' Temperature iteration : ', i_T
      
      WHILE ( zaaa(0) NE 'TITLE:') DO BEGIN
         READF, 10, zc & PRINT, ' line x : ', zc
         zaaa = STRSPLIT(zc,/EXTRACT)
      ENDWHILE
   
      READF, 10, zc & PRINT, ' line 3 : ', zc
      READF, 10, zc & PRINT, ' line 4 : ', zc
   
      ; Extract temperature array
      READF, 10, zf_temp & PRINT, ' line 5 : ', zf_temp
      temp(i_T)           = zf_temp(0) & PRINT, temp(i_T)
      ionic_strength(i_T,i_S) = zf_temp(1) & PRINT, ionic_strength(i_T, i_S)
      rho           (i_T,i_S) = zf_temp(2) & PRINT, rho(i_T, i_S)
      phi           (i_T,i_S) = zf_temp(3) & PRINT, phi(i_T, i_S)
      M_H2O_liq     (i_T,i_S) = zf_temp(4) & PRINT, M_H2O_liq(i_T, i_S)
      M_Ice         (i_T,i_S) = zf_temp(5) & PRINT, M_Ice(i_T, i_S)
      Pres          (i_T,i_S) = zf_temp(6) & PRINT, Pres(i_T, i_S)
   
      READF, 10, zc & PRINT, ' line 6 : ', zc
      READF, 10, zc & PRINT, ' line 7 : ', zc
      READF, 10, zc & PRINT, ' line 8 : ', zc
      
      ; Read solute concentration array
      FOR i_solute = 0, N_solute - 1 DO BEGIN
         PRINT, ' i_solute *** ', i_solute
         READF, 10, zc & zaaa = strsplit(zc,/EXTRACT)
         c_name_solute(i_solute) = zaaa(0)
         conc_solute(i_solute,i_T,i_S) = FLOAT(zaaa(2))
         PRINT, ' c_name_solute ', c_name_solute(i_solute), ' conc_solute     ', conc_solute(i_solute,i_T,i_S) & PRINT
      ENDFOR
      
      READF, 10, zc & PRINT, ' line 30 : ', zc
      READF, 10, zc & PRINT, ' line 31 : ', zc
      READF, 10, zc & PRINT, ' line 32 : ', zc
      READF, 10, zc & PRINT, ' line 33 : ', zc
      READF, 10, zc & PRINT, ' line 34 : ', zc
      READF, 10, zc & PRINT, ' line 35 : ', zc
      
      ; Read solid concentration array
      FOR i_solid = 0, N_solid - 1 DO BEGIN
         PRINT, ' i_solid  *** ', i_solid
         READF, 10, zc & zaaa = strsplit(zc,/EXTRACT)
         c_name_solid (i_solid ) = zaaa(0)
         conc_solid(i_solid,i_T,i_S) = FLOAT(zaaa(1))
         PRINT, ' c_name_solid  ', c_name_solid (i_solid ), ' conc_solid      ', conc_solid (i_solid,i_T,i_S) & PRINT
      ENDFOR
      
      READF, 10, zc & PRINT, ' line 137 : ', zc
      READF, 10, zc & PRINT, ' line 138 : ', zc
   
      ; extract pH
      READF, 10, zc & PRINT, ' line 139 : ', zc
      zaaa=strsplit(zc,/EXTRACT)
      pH(i_T,i_S) = zaaa(1)
      
      READF, 10, zc & PRINT, ' line 140 : ', zc
      READF, 10, zc & PRINT, ' line 141 : ', zc
   
      ; extract Iterations
      READF, 10, zc & PRINT, ' line 142 : ', zc
      zaaa=strsplit(zc,/EXTRACT)
      nit(i_T,i_S) = LONG(zaaa(2))
      
      READF, 10, zc & PRINT, ' line 143 : ', zc
      READF, 10, zc & PRINT, ' line 144 : ', zc
      READF, 10, zc & PRINT, ' line 145 : ', zc
   
   ENDFOR
   
   CLOSE, 10

ENDFOR

;==================================================================================================
; Molar masses (mm's)
;==================================================================================================

molecular_mass, 'H'  , mm_H   ; hydrogen
molecular_mass, 'O'  , mm_O   ; oxygen
molecular_mass, 'OH' , mm_OH  ; hydroxide
molecular_mass, 'H2O', mm_H2O ; H2O
molecular_mass, 'S'  , mm_S   ; sulphur
molecular_mass, 'CO3', mm_CO3 ; carbonate
molecular_mass, 'B'  , mm_B   ; boron

molecular_mass, 'Na'  , mm_Na
molecular_mass, 'Cl'  , mm_Cl
molecular_mass, 'K'   , mm_K
molecular_mass, 'SO4' , mm_SO4
molecular_mass, 'Ca'  , mm_Ca
molecular_mass, 'Mg'  , mm_Mg
molecular_mass, 'Br'  , mm_Br

;-----------------
; dissolved salts
;-----------------

mm_solute = DBLARR(N_solute)

molecular_mass, 'Na', zmm   &   mm_solute(0) = zmm   ; NA
molecular_mass, 'K' , zmm   &   mm_solute(1) = zmm   ; K
molecular_mass, 'Ca', zmm   &   mm_solute(2) = zmm   ; CA
molecular_mass, 'Mg', zmm   &   mm_solute(3) = zmm   ; MG
mm_solute(4) = mm_H                                  ; H
mm_solute(5) = mm_OH + mm_solute(3)                  ; MGOH
molecular_mass, 'Cl', zmm   &   mm_solute(6) = zmm   ; CL
molecular_mass, 'SO4', zmm  &   mm_solute(7) = zmm   ; SO4
mm_solute(8) = mm_OH                                 ; OH
mm_solute(9) = mm_CO3 + mm_H                         ; HCO3
mm_solute(10) = mm_CO3                               ; CO3
mm_solute(11) = mm_H + mm_solute(7)                  ; HSO4
molecular_mass, 'Br', zmm   &   mm_solute(12) = zmm  ; BR
molecular_mass, 'CO2', zmm  &   mm_solute(13) = zmm  ; CO2
mm_solute(14) = mm_solute(2) + mm_CO3                ; CACO3
mm_solute(15) = mm_solute(3) + mm_CO3                ; MGCO3
molecular_mass, 'Sr', zmm   &   mm_solute(16) = zmm  ; SR
mm_solute(17) = mm_B + 4.*mm_OH                      ; B(OH)4
mm_solute(18) = mm_B + 3.*mm_OH                      ; B(OH)3
molecular_mass, 'F', zmm    &   mm_solute(19) = zmm  ; F
mm_solute(20) = mm_H + mm_solute(19)                 ; HF

;-----------------
; solid salts
;-----------------
mm_solid     = DBLARR(N_solid)
mm_solid_H2O = DBLARR(N_solid)

; see which minerals are active (otherwise it will take forever to compute all molar masses!)
i_flag = BYTARR(N_solid) & i_flag(*) = 0
i_S = 0
FOR i_solid = 0, N_solid -1 DO BEGIN
   zmean  = MEAN(conc_solid(i_solid,*,i_S))
   IF ( zmean  GT 0. ) THEN BEGIN
      i_flag(i_solid) = 1
      PRINT, ' Active mineral       ', c_name_solid(i_solid)
      PRINT, ' Concentration at -36deg ', conc_solid(i_solid,N_T-1,i_S)
   ENDIF
ENDFOR

; NACL.2H2O
i_solid = WHERE( c_name_solid EQ 'NACL.2H2O' )
mm_solid    ( i_solid ) = mm_Na + mm_Cl
mm_solid_H2O( i_solid ) = 2. * mm_H2O 
print, 'NACL.2H2O (hydrohalite)', mm_solid(i_solid), mm_solid_H2O(i_solid)

; KCL
i_solid = WHERE( c_name_solid EQ 'KCL' )
mm_solid    ( i_solid ) = mm_K + mm_Cl
mm_solid_H2O( i_solid ) = 0.
print, 'KCL (sylvite)', mm_solid(i_solid), mm_solid_H2O(i_solid)

; NA2SO4.10H2O
i_solid = WHERE( c_name_solid EQ 'NA2SO4.10H2O' )
mm_solid    ( i_solid ) = 2. * mm_Na + mm_SO4
mm_solid_H2O( i_solid ) = 10. * mm_H2O
print, 'NA2SO4.10H2O (mirabilite)', mm_solid(i_solid), mm_solid_H2O(i_solid)

; CASO4.2H2O
i_solid = WHERE( c_name_solid EQ 'CASO4.2H2O' )
mm_solid    ( i_solid ) = mm_Ca + mm_SO4
mm_solid_H2O( i_solid ) = 2. * mm_H2O
print, 'CASO4.2H2O (gypsum)', mm_solid(i_solid), mm_solid_H2O(i_solid)

; MGSO4.11H2O
i_solid = WHERE( c_name_solid EQ 'MGSO4.11H2O' )
mm_solid    ( i_solid ) = mm_Mg + mm_SO4
mm_solid_H2O( i_solid ) = 11. * mm_H2O
print, 'MGSO4.11H2O (meridianite)', mm_solid(i_solid), mm_solid_H2O(i_solid)

; CACO3.6H2O
i_solid = WHERE( c_name_solid EQ 'CACO3.6H2O' )
mm_solid    ( i_solid ) = mm_Ca + mm_CO3
mm_solid_H2O( i_solid ) = 6. * mm_H2O
print, 'CACO3.6H2O (ikaite)', mm_solid(i_solid), mm_solid_H2O(i_solid)

; NABR
i_solid = WHERE( c_name_solid EQ 'NABR' )
mm_solid    ( i_solid ) = mm_Na + mm_Br
mm_solid_H2O( i_solid ) = 0.
print, 'NABR (sodium bromide)', mm_solid(i_solid), mm_solid_H2O(i_solid)

;
;==================================================================================================
; convert molalities (mol/kgh2O) into molar concentrations (mol/kg solution)
;==================================================================================================
; frezchem outputs molalities (even though it is not written anywhere)

FOR i_S = 0, N_S - 1 DO BEGIN
   
   ; source: Butler et al (2016), eqn. 2
   ztm = DBLARR(N_T) ; total molality
   FOR i_T = 0, N_T - 1 DO BEGIN
      ztm(i_T) = TOTAL( conc_solute(*,i_T,i_S) * mm_solute(*) )
   ENDFOR
   
   FOR i_T = 0, N_T - 1 DO BEGIN
      conc_solute(*,i_T,i_S) = conc_solute(*,i_T,i_S) * 1000. / ( 1000. + ztm(i_T) )
   ENDFOR

ENDFOR

;==================================================================================================
; mass fractions (mf) (g/kg solution)
;==================================================================================================
   
;-----------------
; dissolved salts
;-----------------
   
mf_solute = DBLARR(N_solute,N_T,N_S) ; mass fraction of solutes in solution (g/kg solution)
   
FOR i_solute = 0, N_solute - 1 DO BEGIN
   mf_solute(i_solute,*,*) = conc_solute(i_solute,*,*) * mm_solute(i_solute)
ENDFOR
   
zaddr = WHERE( ( c_name_solute NE 'H' ) AND ( c_name_solute NE 'OH' ) ) 
zmf   = mf_solute(zaddr,*,*)
   
S_br  = TOTAL(zmf, 1)                ; brine salinity

;M_tot = M_H2O_liq(0,*) + S_br(0,*)        ; total mass of the system
M_tot = M_H2O_liq(0,*) + S_br(0,*) * 1000. / ( 1000. - S_br(0,*) ) ; bug fixed for v2

;-----------------
; solid salts
;-----------------

mf_solid     = DBLARR(N_solid, N_T, N_S)
mf_solid_H2O = DBLARR(N_solid, N_T, N_S)
   
FOR i_solid = 0, N_solid - 1 DO BEGIN

   IF ( i_flag(i_solid) EQ 1 ) THEN BEGIN

      mf_solid(i_solid,*,*)     = conc_solid(i_solid,*,*) * mm_solid(i_solid)     
      mf_solid_H2O(i_solid,*,*) = conc_solid(i_solid,*,*) * mm_solid_H2O(i_solid)

   ENDIF

ENDFOR

   
;==================================================================================================
; Components of mass, water and salt budgets
;==================================================================================================

M_salt_min   = TOTAL(mf_solid, 1)                     ; salt in minerals

zden         = 1./ ( 1000.0D - S_br )
M_salt_liq   = ( S_br * M_H2O_liq ) * zden            ; total salt mass in minerals

M_H2O_min    = TOTAL(mf_solid_H2O, 1)                 ; total water in minerals

phi_ice      = DBLARR(N_T,N_S)
phi_H2O_liq  = DBLARR(N_T,N_S)
phi_H2O_min  = DBLARR(N_T,N_S)
phi_salt_liq = DBLARR(N_T,N_S)
phi_salt_min = DBLARR(N_T,N_S)
   
FOR i_S = 0, N_S - 1 DO BEGIN

   phi_ice(*,i_S)      = M_ice(*,i_S)      / M_tot(0,i_S)     ; ice fraction
   
   phi_H2O_liq(*,i_S)  = M_H2O_liq(*,i_S)  / M_tot(0,i_S)     ; liquid H2O fraction 
  
   phi_H2O_min(*,i_S)  = M_H2O_min(*,i_S)  / M_tot(0,i_S)     ; mineral H2O fraction
  
   phi_salt_liq(*,i_S) = M_salt_liq(*,i_S) / M_tot(0,i_S)     ; dissolved salt fraction
   
   phi_salt_min(*,i_S) = M_salt_min(*,i_S) / M_tot(0,i_S)     ; solid salt fraction

ENDFOR

phi_liq      = phi_H2O_liq + phi_salt_liq             ; liquid fraction
   
phi_solid    = phi_ice + phi_H2O_min + phi_salt_min   ; solid fraction
   
phi_salt     = phi_salt_liq + phi_salt_min            ; total salt fraction
   
phi_H2O      = phi_H2O_min + phi_H2O_liq + phi_Ice    ; total H2O fraction
   
phi_tot      = phi_ice + phi_H2O_liq + phi_H2O_min + phi_salt_liq + phi_salt_min ; sum of all mass fractions
   
IF ( i_correct_conservation EQ 1 ) THEN BEGIN
   
   PRINT
   PRINT, ' i_correct_conservation = 1 '
   PRINT, ' Impose mass conservation by dividing by phi_tot  '
   PRINT, ' std(phi_tot) = ', stddev(phi_tot), '%'
   
   phi_ice      = phi_ice      / phi_tot
   phi_H2O_liq  = phi_H2O_liq  / phi_tot
   phi_H2O_min  = phi_H2O_min  / phi_tot
   phi_salt_liq = phi_salt_liq / phi_tot
   phi_salt_min = phi_salt_min / phi_tot
   phi_liq      = phi_liq      / phi_tot
   phi_solid    = phi_solid    / phi_tot
   phi_H2O      = phi_H2O      / phi_tot
   phi_tot      = phi_ice + phi_H2O_liq + phi_H2O_min + phi_salt_liq + phi_salt_min ; sum of all mass fractions
   
ENDIF
   
; solid salt fraction
SA_diag   = phi_salt * 1000.D
S_ss      = phi_salt_min * 1000.D
f_ss      = S_ss / SA_diag

;======================================================================================================================
; Conservation tests
;======================================================================================================================

PRINT, ' '
PRINT, ' -------------------------------------------------------------------------- '
PRINT, '   Conservation checks                                                      '
PRINT, ' -------------------------------------------------------------------------- '
PRINT
   
PRINT, ' Total mass of the system : ', M_tot
  
M_H2O_tot  = M_H2O_min + M_H2O_liq + M_Ice     & PRINT, ' Total mass of water      : ', M_H2O_tot
  
M_salt_tot = M_salt_min + M_salt_liq           & PRINT, ' Total mass of salt       : ', M_salt_tot
   
M_test = M_H2O_tot + M_salt_tot                & PRINT, ' Sum of water and salt    : ', M_test
   
C_error1 = DBLARR(N_S)
FOR i_S = 0, N_S - 1 DO BEGIN
   C_error1(i_S) = STDDEV(M_test(*,i_S)) / MEAN(M_test(*,i_S)) * 100.     & PRINT, ' Conservation error (%)   : ', C_error1(i_S)
ENDFOR

C_error_abs = DBLARR(N_T,N_S)
C_error_rel = DBLARR(N_T,N_S)
FOR i_T = 0, N_T - 1 DO BEGIN
   C_error_abs(i_T,*) = M_test(i_T,*) - M_tot(0,*)
   C_error_rel(i_T,*) = C_error_abs(i_T,*) / M_tot(0,*) * 100.
ENDFOR

;======================================================================================================================
; Test Plots
;======================================================================================================================

!P.MULTI = [0,2,2]
PLOT, temp-273.15, TITLE = 'temperature (K)'
PLOT, temp-273.15, pH, TITLE = 'pH'
PLOT, temp-273.15, M_H2O_liq, TITLE = 'M_H2O (g)'
PLOT, temp-273.15, M_Ice, TITLE = 'M_Ice (g)'

!P.MULTI = [0,2,2]
PLOT, temp-273.15, -18.7 * (temp-273.15) - 0.519*(temp-273.15)^2 - 0.00535 * (temp-273.15)^3, TITLE = 'Liquidus curve', YTITLE = 'S_br (g/kg)'
OPLOT, temp-273.15, S_br, LINESTYLE = 1

PLOT, temp-273.15, f_SS, LINESTYLE = 1, YTITLE ='f_ss'

PLOT, [0,40], [0.001, 10.], /YLOG, /NODATA, YTITLE='C (mol/kg sol)', TITLE = '5 main solutes molar concentration'
i_sol = WHERE(c_name_solute EQ 'CL')
OPLOT, -(temp-273.15), conc_solute(i_sol,*)
i_sol = WHERE(c_name_solute EQ 'NA')
OPLOT, -(temp-273.15), conc_solute(i_sol,*)
i_sol = WHERE(c_name_solute EQ 'SO4')
OPLOT, -(temp-273.15), conc_solute(i_sol,*)
i_sol = WHERE(c_name_solute EQ 'CA' )
OPLOT, -(temp-273.15), conc_solute(i_sol,*)
i_sol = WHERE(c_name_solute EQ 'MG')
OPLOT, -(temp-273.15), conc_solute(i_sol,*), linestyle = 1

i_ls = -1
PLOT, [0,40], [1.0e-6, 34.], /YLOG, /NODATA, YTITLE = ' g/kg ', TITLE = 'Salt in minerals', YSTYLE = 1
FOR i_solid = 0, N_Solid-1 DO BEGIN
   IF ( i_flag(i_Solid) EQ 1 ) THEN BEGIN
      OPLOT, -(temp-273.15), mf_solid(i_solid,*), linestyle = i_ls 
      i_ls = i_ls + 1 
   ENDIF
ENDFOR
OPLOT, -(temp-273.15), phi_salt_min, THICK = 3

;======================================================================================================================
; Store computations in files
;======================================================================================================================

;---------------
; NetCDF output
;---------------

file_name = 'FREZCHEM_gitterman.nc'
file_no = NCDF_CREATE(file_name, /CLOBBER)

temp_dim_no     = NCDF_DIMDEF( file_no, 'T', N_T )
sal_dim_no      = NCDF_DIMDEF( file_no, 'S', N_S )
solute_dim_no   = NCDF_DIMDEF( file_no, 'solute', N_solute )
solid_dim_no    = NCDF_DIMDEF( file_no, 'solid' , N_solid  )

temp_no         = NCDF_VARDEF( file_no, 'T', [temp_dim_no], /FLOAT)
NCDF_ATTPUT, file_no, temp_no, 'Units', 'degC', /CHAR
NCDF_ATTPUT, file_no, temp_no, 'long_name', 'ITS-90 Celsius Temperature', /CHAR

sal_no          = NCDF_VARDEF( file_no, 'SA', [sal_dim_no], /FLOAT)
NCDF_ATTPUT, file_no, sal_no, 'Units', 'g/kg', /CHAR
NCDF_ATTPUT, file_no, sal_no, 'long_name', 'Absolute salinity', /CHAR

is_no           = NCDF_VARDEF( file_no, 'I', [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, is_no  , 'Units', '', /CHAR
NCDF_ATTPUT, file_no, is_no  , 'long_name', 'Ionic Strength', /CHAR

rho_no          = NCDF_VARDEF( file_no, 'rho'           , [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, rho_no , 'Units', 'kg/m3', /CHAR
NCDF_ATTPUT, file_no, rho_no , 'long_name', 'Brine Density', /CHAR

Phi_no          = NCDF_VARDEF( file_no, 'Osm_coeff'     , [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, Phi_no , 'Units', '', /CHAR
NCDF_ATTPUT, file_no, Phi_no , 'long_name', 'Osmotic coefficient', /CHAR

Pres_no         = NCDF_VARDEF( file_no, 'Pres'          , [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, Pres_no, 'Units', 'bars', /CHAR
NCDF_ATTPUT, file_no, Pres_no, 'long_name', 'Pressure', /CHAR

pH_no           = NCDF_VARDEF( file_no, 'pH'            , [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, pH_no  , 'Units', 'log_conc', /CHAR
NCDF_ATTPUT, file_no, pH_no  , 'long_name', 'pH', /CHAR

nit_no          = NCDF_VARDEF( file_no, 'nit'           , [temp_dim_no, sal_dim_no], /LONG)
NCDF_ATTPUT, file_no, nit_no , 'Units', '', /CHAR
NCDF_ATTPUT, file_no, nit_no , 'long_name', 'Number of iterations to reach convergence', /CHAR

M_tot_no        = NCDF_VARDEF( file_no, 'M_tot'         , [sal_dim_no])
NCDF_ATTPUT, file_no, M_tot_no, 'Units', 'g', /CHAR
NCDF_ATTPUT, file_no, M_tot_no, 'long_name', 'Total mass of the system', /CHAR

M_Ice_no        = NCDF_VARDEF( file_no, 'M_Ice'         , [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, M_Ice_no, 'Units', 'g', /CHAR
NCDF_ATTPUT, file_no, M_ice_no, 'long_name', 'Mass of ice', /CHAR

M_H2O_liq_no    = NCDF_VARDEF( file_no, 'M_H2O_liq'     , [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, M_H2O_liq_no, 'Units', 'g', /CHAR
NCDF_ATTPUT, file_no, M_H2O_liq_no, 'long_name', 'Mass of liquid H2O', /CHAR

M_H2O_min_no    = NCDF_VARDEF( file_no, 'M_H2O_min'     , [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, M_H2O_min_no, 'Units', 'g', /CHAR
NCDF_ATTPUT, file_no, M_H2O_min_no, 'long_name', 'Mass of H2O complexed in minerals', /CHAR

M_salt_liq_no   = NCDF_VARDEF( file_no, 'M_salt_liq'    , [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, M_salt_liq_no, 'Units', 'g', /CHAR
NCDF_ATTPUT, file_no, M_salt_liq_no, 'long_name', 'Mass of dissolved salt', /CHAR

M_salt_min_no   = NCDF_VARDEF( file_no, 'M_salt_min'    , [temp_dim_no, sal_dim_no])
NCDF_ATTPUT, file_no, M_salt_min_no, 'Units', 'g', /CHAR
NCDF_ATTPUT, file_no, M_salt_min_no, 'long_name', 'Mass of salt in minerals', /CHAR

S_br_no         = NCDF_VARDEF( file_no, 'S_br'          , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, S_br_no, 'Units', 'g/kg', /CHAR
NCDF_ATTPUT, file_no, S_br_no, 'long_name', 'Liquid phase salinity', /CHAR

S_ss_no         = NCDF_VARDEF( file_no, 'S_sm'          , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, S_br_no, 'Units', 'g/kg', /CHAR
NCDF_ATTPUT, file_no, S_br_no, 'long_name', 'Salinity due to minerals', /CHAR

f_ss_no         = NCDF_VARDEF( file_no, 'f_sm'          , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, f_ss_no, 'Units', 'g/g of total salt', /CHAR
NCDF_ATTPUT, file_no, f_ss_no, 'long_name', 'Fraction of total salt in minerals', /CHAR

phi_ice_no      = NCDF_VARDEF( file_no, 'phi_ice'       , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_ice_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_ice_no, 'long_name', 'Mass fraction of ice', /CHAR

phi_H2O_liq_no  = NCDF_VARDEF( file_no, 'phi_H2O_liq'   , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_H2O_liq_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_H2O_liq_no, 'long_name', 'Mass fraction of liquid H2O', /CHAR

phi_H2O_min_no  = NCDF_VARDEF( file_no, 'phi_H2O_min'   , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_H2O_min_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_H2O_min_no, 'long_name', 'Mass fraction of H2O in minerals', /CHAR

phi_salt_liq_no = NCDF_VARDEF( file_no, 'phi_salt_liq'  , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_salt_liq_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_salt_liq_no, 'long_name', 'Mass fraction of dissolved salt', /CHAR

phi_salt_min_no = NCDF_VARDEF( file_no, 'phi_salt_min'  , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_salt_min_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_salt_min_no, 'long_name', 'Mass fraction of salt in minerals', /CHAR

phi_liq_no      = NCDF_VARDEF( file_no, 'phi_liq'       , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_liq_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_liq_no, 'long_name', 'Mass fraction of all components of liquid phase (H2O, salt)', /CHAR

phi_solid_no    = NCDF_VARDEF( file_no, 'phi_solid'     , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_solid_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_solid_no, 'long_name', 'Mass fraction of solid phase (ice, minerals)', /CHAR

phi_H2O_no      = NCDF_VARDEF( file_no, 'phi_H2O'       , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_H2O_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_H2O_no, 'long_name', 'Mass fraction of H2O (liquid, ice, minerals)', /CHAR

phi_salt_no     = NCDF_VARDEF( file_no, 'phi_salt'      , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_salt_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_salt_no, 'long_name', 'Mass fraction of salt', /CHAR

phi_tot_no      = NCDF_VARDEF( file_no, 'phi_tot'       , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, phi_salt_no, 'Units', 'kg/kg', /CHAR
NCDF_ATTPUT, file_no, phi_salt_no, 'long_name', 'Sum of all mass fractions (conservation check)', /CHAR

C_error_abs_no  = NCDF_VARDEF( file_no, 'C_error_abs'       , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, C_error_abs_no, 'Units', 'g', /CHAR
NCDF_ATTPUT, file_no, C_error_abs_no, 'long_name', 'Absolute conservation error', /CHAR

C_error_rel_no  = NCDF_VARDEF( file_no, 'C_error_rel'       , [temp_dim_no, sal_dim_no] )
NCDF_ATTPUT, file_no, C_error_abs_no, 'Units', '%', /CHAR
NCDF_ATTPUT, file_no, C_error_abs_no, 'long_name', 'Relative conservation error', /CHAR

conc_solute_no   = NCDF_VARDEF( file_no, 'conc_solute', [solute_dim_no, temp_dim_no, sal_dim_no]) ; molar concentration of solutes
NCDF_ATTPUT, file_no, conc_solute_no, 'Units', 'mol/kg brine', /CHAR
NCDF_ATTPUT, file_no, conc_solute_no, 'long_name', 'Molar concentration of solutes in liquid phase', /CHAR

conc_solid_no   = NCDF_VARDEF( file_no, 'conc_solid' , [solid_dim_no, temp_dim_no, sal_dim_no])  ; molar concentration of solid minerals 
NCDF_ATTPUT, file_no, phi_salt_no, 'Units', 'mol/kg', /CHAR
NCDF_ATTPUT, file_no, phi_salt_no, 'long_name', 'Molar concentration of solid minerals', /CHAR

mf_solute_no    = NCDF_VARDEF( file_no, 'mf_solute'  , [solute_dim_no, temp_dim_no, sal_dim_no]) ; mass fraction of solutes (g/kg)
NCDF_ATTPUT, file_no, mf_solute_no, 'Units', 'g/kg brine', /CHAR
NCDF_ATTPUT, file_no, mf_solute_no, 'long_name', 'Mass fraction of solutes in liquid phase', /CHAR

mf_solid_no     = NCDF_VARDEF( file_no, 'mf_solid'   , [solid_dim_no, temp_dim_no, sal_dim_no]) ; mass fraction of salt in solid minerals (g/kg)
NCDF_ATTPUT, file_no, mf_solid_no, 'Units', 'g/kg', /CHAR
NCDF_ATTPUT, file_no, mf_solid_no, 'long_name', 'Mass fraction of salt in solid minerals', /CHAR

;
;conc_solute_no = LONARR(N_solute)
;FOR i = 0, N_solute - 1 DO BEGIN
;   conc_solute_no(i) = NCDF_VARDEF(file_no, c_name_solute(i)+'_solute', [temp_dim_no, sal_dim_no])
;ENDFOR
;
;conc_solid_no = LONARR(N_solid)
;FOR i = 0, N_solid - 1 DO BEGIN
;   IF ( ( i NE 79 ) AND ( i NE 73 ) ) THEN BEGIN ; must exclude one of the FE(II)FE(III)2(SO4)4 minerals (there are two of them, i don't know why)
;      conc_solid_no(i) = NCDF_VARDEF(file_no, c_name_solid(i)+'_solid', [temp_dim_no, sal_dim_no])
;   ENDIF
;ENDFOR
;
; following line does not work for unknown reason (char writing for arrays does not work)
;name_solute_no = NCDF_VARDEF( file_no, 'name_solute', [solute_dim_no], /CHAR) ; c_name_solute

NCDF_CONTROL, file_no, /ENDEF

NCDF_VARPUT, file_no, temp_no, temp-273.1500D
NCDF_VARPUT, file_no, sal_no , SA
NCDF_VARPUT, file_no, is_no  , ionic_strength
NCDF_VARPUT, file_no, rho_no , rho*1000.
NCDF_VARPUT, file_no, Phi_no , Phi
NCDF_VARPUT, file_no, Pres_no , Pres
NCDF_VARPUT, file_no, pH_no  , pH
NCDF_VARPUT, file_no, nit_no , nit

zMtot = DBLARR(N_S)   &   zMtot(*) = M_tot(0,*)
NCDF_VARPUT, file_no, M_tot_no        , zMtot
NCDF_VARPUT, file_no, M_Ice_no        , M_Ice
NCDF_VARPUT, file_no, M_H2O_liq_no    , M_H2O_liq
NCDF_VARPUT, file_no, M_H2O_min_no    , M_H2O_min
NCDF_VARPUT, file_no, M_salt_liq_no   , M_salt_liq
NCDF_VARPUT, file_no, M_salt_min_no   , M_salt_min

NCDF_VARPUT, file_no, S_br_no         , S_br
NCDF_VARPUT, file_no, S_ss_no         , S_ss
NCDF_VARPUT, file_no, f_ss_no         , f_ss

NCDF_VARPUT, file_no, phi_ice_no      , phi_ice
NCDF_VARPUT, file_no, phi_H2O_liq_no  , phi_H2O_liq
NCDF_VARPUT, file_no, phi_H2O_min_no  , phi_H2O_min
NCDF_VARPUT, file_no, phi_salt_liq_no , phi_salt_liq
NCDF_VARPUT, file_no, phi_salt_min_no , phi_salt_min

NCDF_VARPUT, file_no, phi_liq_no      , phi_liq
NCDF_VARPUT, file_no, phi_solid_no    , phi_solid
NCDF_VARPUT, file_no, phi_H2O_no      , phi_H2O
NCDF_VARPUT, file_no, phi_salt_no     , phi_salt
NCDF_VARPUT, file_no, phi_tot_no      , phi_tot

NCDF_VARPUT, file_no, C_error_abs_no  , C_error_abs
NCDF_VARPUT, file_no, C_error_rel_no  , C_error_rel

NCDF_VARPUT, file_no, conc_solute_no  , conc_solute
NCDF_VARPUT, file_no, mf_solute_no    , mf_solute
NCDF_VARPUT, file_no, conc_solid_no   , conc_solid 
NCDF_VARPUT, file_no, mf_solid_no     , mf_solid

;---

;FOR i_solute = 0, N_solute -1 DO BEGIN
;   zarray = DBLARR(N_T,N_S)
;   zarray(*,*) = conc_solute(i_solute, *, *)
;   NCDF_VARPUT, file_no, conc_solute_no(i_solute), zarray
;ENDFOR
;
;FOR i_solid  = 0, N_solid  -1 DO BEGIN
;   zarray = DBLARR(N_T,N_S)
;   zarray(*,*) = conc_solid (i_solid , *, *)
;   IF ( ( i_solid NE 79 ) AND ( i_solid NE 73 ) ) THEN BEGIN
;      NCDF_VARPUT, file_no, conc_solid_no(i_solid ), zarray
;   ENDIF
;ENDFOR

NCDF_CLOSE, file_no

;----------------------------------
; Text files with names of solutes
;----------------------------------

; create files with variable names for concentration arrays
OPENW, 10, 'solute_names.txt'
FOR i = 0, N_solute -1 DO BEGIN
  PRINTF, 10, ' ' + STRING(i+1) + ' ' + c_name_solute(i)
ENDFOR

CLOSE, 10

OPENW, 10, 'solid_names.txt'
FOR i = 0, N_solid -1 DO BEGIN
  PRINTF, 10, ' ' + STRING(i+1) + ' ' + c_name_solid(i)
ENDFOR

CLOSE, 10

;======================================================================================================================
END
