	
C  FREZCHEM13: This is a chemical thermodynamic model for aqueous 
C  solutions over the temperature range from <-70C to +25C.  This
C  model uses the Pitzer equations for activity coefficients and
C  the activity of water and is valid to high ionic strengths
C  (20 M).  The model considers the precipitation-dissolution of
C  the chloride, nitrate, sulfate and bicarbonate-carbonate salts
C  of calcium, magnesium, sodium,  and potassium. This version also
C  contains strong acid (HCl, HNO3, H2SO4),iron (ferrous and ferric),
C  silica,,aluminum, and perchlorate chemistries.  This version contains a 
C  pressure dependency for certain cations and anions plus 
C  clathrate chemistry.  Includes freezing and evaporation options and 
C  fractional and equilibrium crystallization options.
C  Also allows for a specificiation of an open or closed carbon system.
C  Model will calculate density of molar solns. and convert to molal.
	
      REAL IX,INIT(21),I,LAM
      DIMENSION FINAL(21),NCOMP(10),HYDRO(8),PHOPTION(10)
      CHARACTER*50 TITLE
      DOUBLE PRECISION AKI,AKII,ISALGM,SALGM,DELGM,SALH2O,X,AX,K,KV,K0
      DOUBLE PRECISION AH2O,PHI
	
	
      COMMON /A/ MAXCAT,MAXAN,AKI(0:20),AKII(0:20),BET0(200,200),
     XBET1(200,200),BET2(200,200),C(200,200),CPHI(200,200),
     XPSI(200,200,200),THETA(200,200),A,Z(30),LAM(200,200),
     XXI(200,200,200),BV0(200,200),BV1(200,200),BV2(200,200),
     XCV(200,200),AV
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
     
      COMMON /T/TITLE

	OPEN (UNIT=2, FILE = "FrOut")
	OPEN (9, FILE = 'INPUT.TXT')

	
	
C  READ IN OR INITIALIZE RUN PARAMETERS.

	DO 1000 J = 1,200
		IX(J) = 0.0
		X(J) = 0.0
1000	CONTINUE
C	PRINT*, 'TITLE ='
	READ(9,1) TITLE
1	FORMAT (A50)
C	PRINT*,'FREEZE(1) OR EVAPORATION(2) OR PRESSURE(3) SCENARIO ?'
	READ(9,*) PATH
C	PRINT*, 'EQUILIBRIUM(1) OR FRACTIONAL(2) CRYSTALLIZATION?'
	READ(9,*) NEQFR
C	PRINT*, 'OPEN(1) OR CLOSED(2) CARBON SYSTEM?'
	READ(9,*) NCAR
	NMAX = 0
	READ(9,*)YESORNO
	READ(9,*)S
	SA = S*35.165/35.00
	READ(9,*)CARBSS
C	PRINT*, 'SODIUM (M/KG) ='
	READ(9,*) IX(1)
	IF(IX(1).GT.0.0) NMAX = NMAX+1
C	PRINT*, 'POTASSIUM (M/KG) ='
	READ(9,*) IX(2)
	IF(IX(2).GT.0.0) NMAX = NMAX+1
C	PRINT*, 'CALCIUM (M/KG) ='
	READ(9,*) IX(3)
	IF(IX(3).GT.0.0) NMAX = NMAX+1
C	PRINT*, 'MAGNESIUM (M/KG) ='
	READ(9,*)IX(4)
	IF(IX(4).GT.0.0) NMAX=NMAX+1
C	PRINT*, 'STRONTIUM (M/KG) ='
	READ(9,*)IX(172)
	X(172) = IX(172)
C	PRINT*, 'FERROUS IRON (M/KG) = '
	READ(9,*)IX(7)
	IF(IX(7).GT.0.0) NMAX=NMAX+1
C	PRINT*, 'FERRIC IRON (M/KG) = '
	READ(9,*) IX(9)
	IF(IX(9).GT.0.0) NMAX=NMAX+1
C	PRINT*, 'ALUMINUM (M/KG) = '
	READ(9,*) IX(10)
	IF(IX(10).GT.0.0) NMAX=NMAX+1
C	PRINT*, 'SILICA (M/KG) = '
	READ(9,*) IX(166)
	IF(IX(166).GT.0.0) NMAX=NMAX+1
	IRON = 1
	DO IJK=1,10
		READ(9,100)PHOPTION(IJK)
100	FORMAT(A6)
	END DO
C	IF((IX(9).GT.0).OR.(IX(7).GT.0).OR.(IX(10).GT.0).OR.
C     X(IX(166).GT.0)) THEN
C	PRINT*,'FOR FE,AL,OR SI CHEMI.,DO YOU WANT ACIDITY IGNORED(1),'
C          PRINT*,'OR FIXED BY PH(2), OR ACIDITY(3), OR ALKALINITY(4)? '
C	  PRINT*,'     IF YES,THEN ENTER NUM'
C     	  PRINT*, 'NOTE THAT OPTIONS 3 AND 4 REQUIRE' 
C	  PRINT*, '     A FURTHER SPECIFICATION BELOW. ' 
C      PRINT*,'OPTIONS 2-4 WILL ADJUST SOLUTION-PHASE CHARGE BALANCE AS'
C      PRINT*,'AL, FE, OR SI REACTIONS PRODUCE ACIDITY BY ASSUMING H+' 
C      PRINT*,'REACTS WITH ROCKS TO RELEASE NA,K,CA,MG,OR FE(II) IONS.'
C      PRINT*,'SOME OF THE LATTER IONS MUST BE PRESENT AS INPUT TO SERVE'
C      PRINT*,'AS AN ION SINK/SOURCE.'  
C     		READ*,IRON
C		PRINT*, 'INITIAL pH='
C		READ*,PH
C	END IF
	READ(9,*)IRON
	READ(9,*)PH
C	PRINT*, 'CHLORIDE (M/KG) ='
	READ(9,*) IX(11)
	IF(IX(11).GT.0.0) NMAX = NMAX+1
C	PRINT*, 'BROMIDE (M/KG) ='
	READ(9,*) IX(18)
	IF(IX(18).GT.0.0) NMAX = NMAX+1
C	PRINT*, 'PERCHLORATE (M/KG) ='
	READ(9,*) IX(19)
	IF(IX(19).GT.0.0) NMAX = NMAX+1
C	PRINT*, 'SULFATE (M/KG) ='
	READ(9,*) IX(12)
	IF(IX(12).GT.0.0) NMAX = NMAX+1
C	PRINT*, 'NITRATE (M/KG) ='
	READ(9,*) IX(17)
	IF(IX(17).GT.0.0) NMAX = NMAX+1
C	PRINT*, 'ALKALINITY (EQUIV/KG) ='
	READ(9,*) ALK
	IF(ALK.GT.0.0) NMAX = NMAX+1
C	PRINT*, 'ACIDITY(EQUIV/KG)='
	READ(9,*)ACID
	IF(ACID.GT.0.0)THEN
		NMAX=NMAX+1
	END IF
C		PRINT*,'HCL(BARS)='
		READ(9,*)AX(23)
C		PRINT*,'HNO3(BARS)='
		READ(9,*)AX(26)
C		PRINT*,'H2SO4(BARS)='
		READ(9,*)AX(27)
	IF(ACID.GT.0.0) THEN
		IX(23)=AX(23)
		IX(26)=AX(26)
		IX(27)=AX(27)
	END IF
C	PRINT*, 'BORON (M/KG) ='
	READ(9,*) IX(20)
	X(20) = IX(20)
C	PRINT*, 'FLUORIDE (M/KG) = '
	READ(9,*) IX(170)
	X(170) = IX(170)

		
C	PRINT*,'INITIAL TOTAL PRESSURE (BARS) = '
	READ(9,*) PB

C	PRINT*, 'INITIAL CO2(BARS) ='
	READ(9,*) AX(29)
C	PRINT*, 'ENTER MOLE FRACTION OF CO2.' 
C	PRINT*, 'IF 0.0 THEN GAS CONCENTRATION IS FIXED.'
C     	PRINT*,  'IF 1.0, THEN PURE CO2 IS SPECIFIED.'
     	READ(9,*) CO2MF
	IF(CO2MF.GT.0.0)AX(29)=CO2MF*PB
	IF(AX(29).GT.0.0)NMAX=NMAX+1
C	PRINT*,'O2(BARS)='
	READ(9,*)AX(151)
C	PRINT*,'INITIAL CH4(BARS)='
	READ(9,*)AX(154)
C	PRINT*, 'ENTER MOLE FRACTION OF CH4.'  
C	PRINT*, 'IF 0.0 THEN GAS CONCENTRATION IS FIXED.'
C     	PRINT*, 'IF 1.0, THEN PURE CH4 IS SPECIFIED.'
     	READ(9,*) CH4MF
	IF(CH4MF.GT.0.0)AX(154)=CH4MF*PB
	IF(AX(154).GT.0.0)NMAX=NMAX+1
C	IF((AX(29).GT.0.0).AND.(AX(154).GT.0.0))THEN
C		PRINT*,'DO YOU WANT TO CONSIDER THIS AS A MIXED CH4-CO2
C     X GAS HYDRATE?'
C     		PRINT*'YES=1,NO=0'
	READ(9,*) XIM
	MIX=XIM
C	END IF
	
C	PRINT*, 'MOLAR TO MOLAL CONVERSION? YES=1, NO=0'
		READ(9,*)AMOLAR
		MOLAR = AMOLAR
C	IF(MOLAR.EQ.1) THEN
		RHO = 1.00
C		PRINT*, ' SALINITY/LITER =  ' 
		READ(9,*) SL
		CFFINAL = 0
C	END IF

C	PRINT*, 'INITIAL TEMPERATURE (K) ='
	READ(9,*) TEMP
	TEMPI=TEMP
	X(28) = 0
	X(30) = 1000
	X(31) = 0
	ITTER=0
	
	
C	IF (PATH.EQ.1) THEN
C		PRINT*, 'FINAL TEMPERATURE (K) ='
		READ(9,*) FINTEM
C		PRINT*, 'TEMPERATURE DECREMENT (K) ='
		READ(9,*) DELTEM
C	END IF
	
C	IF (PATH.EQ.2) THEN
C		PRINT*, 'INITIAL WATER (G) = '
		READ(9,*) X(30)
		DO 2 IJK = 1,12
			IX(IJK) = IX(IJK)*1000/X(30)
2 		CONTINUE
		ALK = ALK*1000/X(30)
		ACID = ACID*1000/X(30)
		IX(17) = IX(17)*1000/X(30)
		IX(18) = IX(18)*1000/X(30)
		IX(19) = IX(19)*1000/X(30)
		IX(20) = IX(20)*1000/X(30)
		IX(170) = IX(170)*1000/X(30)
		IX(172) = IX(172)*1000/X(30)
C		PRINT*, 'FINAL WATER (G) = '
		READ(9,*) FINWAT
C		PRINT*, 'WATER DECREMENT (G) = '
		READ(9,*) DELWAT
C	END IF
	
C	IF(PATH.EQ.3) THEN
C		PRINT*,'FINAL PRESSURE(BARS)='
		READ(9,*) FINPRE
C		PRINT*,'PRESSURE INCREMENT(BARS)='
		READ(9,*) DELPRE
C	END IF
			

	DATA DEL / 1.10, 1.010, 1.001, 1.00001, 1.0000001 /

Conversion to alternative seawater salinities
	IF(YESORNO.GT.0)THEN
	IX(1) =  IX(1)*SA/35.165
	IX(2) =  IX(2)*SA/35.165
	IX(3) =  IX(3)*SA/35.165
	IX(4) =  IX(4)*SA/35.165
	IX(11) = IX(11)*SA/35.165
	IX(12) = IX(12)*SA/35.165
	IX(17) = IX(17)*SA/35.165
	IX(18) = IX(18)*SA/35.165
	IX(166) = IX(166)*SA/35.165
	IX(172) = IX(172)*SA/35.165
	IX(170) = IX(170)*SA/35.165
	IX(20) = IX(20)*SA/35.165
	ALK = ALK*SA/35.165
	END IF
	
	X(1) = IX(1)
	X(2) = IX(2)
	X(3) = IX(3)
	X(4) = IX(4)
	X(7) = IX(7)
	X(9) = IX(9)
	X(10) = IX(10)
	MAXCAT = 10
	X(11) = IX(11)
	X(12) = IX(12)
	IX(16) = 0.0
	X(16) = IX(16)
	X(17) = IX(17)
	X(18) = IX(18)
	X(19) = IX(19)
	X(20) = IX(20)
	X(170) = IX(170)
	X(172) = IX(172)
	MAXAN = 20
	IX(30) = X(30)/18.01528
	ISALGM = 0
	PERCENT = 1000


	CALL PARAMETER
	

	CALL PITZER

 
	IF((NCAR.EQ.1).AND.(AX(29).GT.0.0))THEN
		CALL GAS(29,PB,TEMP,GX(29),ZZZ)
		X(29)=0.0
		X(21)=K(29)*AX(29)*GX(29)/GX(21)
		IX(21)=X(21)
		IX(29)=AX(29)
	END IF
	IF((NCAR.EQ.2).AND.(AX(29).GT.0.0))THEN
		CALL GAS(29,PB,TEMP,GX(29),ZZZ)
		X(29) = 0.1*AX(29)/(8.314467E-2*TEMP*ZZZ)
		X(21)=K(29)*AX(29)*GX(29)/GX(21)
		TCAR=X(21)+X(29)
		IX(21)=TCAR
		IX(29)=AX(29)
	END IF
	
	IF((NCAR.EQ.1).AND.(AX(154).GT.0.0))THEN
		CALL GAS(154,PB,TEMP,GX(154),ZZZ)
		X(154)=0.0
		X(155)=K(155)*AX(154)*GX(154)/GX(155)
		IX(155)=X(155)
		IX(154)=AX(154)
	END IF
	IF((NCAR.EQ.2).AND.(AX(154).GT.0.0))THEN
		CALL GAS(154,PB,TEMP,GX(154),ZZZ)
		X(154) = 0.1*AX(154)/(8.314467E-2*TEMP*ZZZ)
		X(155)=K(155)*AX(154)*GX(154)/GX(155)
		TMET=X(154)+X(155)
		IX(155)=TMET
		IX(154)=AX(154)
	END IF
	
	IX(28)=AH2O/K(28)
	IF(AX(151).GT.0.0)THEN
		IX(151)=AX(151)
		IX(153)=((K(153)*AH2O**2)/AX(151))**0.5
	END IF
	
	
C  INITIALIZE PARAMETERS

	X(152)=K(152)*AX(151)/GX(152)
	IX(152) = X(152)
	
	IF (ALK .GT. 0.0) THEN
		AX(5) = EXP(-PH*2.302585)
		X(13) = K(13)*AH2O/(AX(5)*GX(13))
		X(14) = ALK/(1.0 + (2*K(15)*GX(14))/(AX(5)*GX(15)))
		X(15) = (ALK - X(14))/2
		X(5) = AX(5)/GX(5)
		IX(5)=X(5)
		IX(13)=X(13)
		IX(14) = X(14)
		IX(15)= X(15)
		CALL MGOHIP
		IX(4) = X(4)
		IX(6) = X(6)
		CALL MGCO3IP
		IX(4) = X(4)
		IX(15) = X(15)
		IX(25) = X(25)
		CALL CACO3IP
		IX(3) = X(3)
		IX(15) = X(15)
		IX(24) = X(24)
	END IF
		
	IF(ACID.GT.0.0) THEN
		X(5) = ACID
		IX(5)=X(5)
		AX(5) = X(5)*GX(5)
		X(13) = K(13)*AH2O/(AX(5)*GX(13))
		IX(13) = X(13)
	END IF
	

	
	IF (IRON.EQ.2) THEN
		AX(5) = EXP(-PH*2.302585)
		X(5) = AX(5)/GX(5)
		IX(5) = X(5)
	END IF
	
	IF(IX(166).GT.0)THEN
	AX(5)=GX(5)*X(5)
	X(166) = IX(166)/(1.0+(K(166)*GX(166))/(AX(5)*GX(167)))
	X(167) = IX(166)-X(166)
	END IF
	


3	ITER = 0
	PARTH = 0.0
	
	IF (MOLAR.EQ.1)THEN
		WRITE(2,55)"RHO","SA","CF"
55		FORMAT(8X,A3,8X,A2,10X,A2)
	END IF
	
	IF(NEQFR.EQ.2) THEN
		DO 4 IJK=31,131
			X(IJK) = 0.0
4		CONTINUE
		ISALGM = 0.0
	ELSE
		DO 6 IJK=31,131
			FX(IJK)=0.0
6		CONTINUE
	ENDIF
	
	IF (ITTER.EQ.0)THEN	
	OPEN(5, FILE = 'SOLIDMASS.TXT')
	READ(5,*)PHASE
	IF (PHASE.EQ.1)THEN
		READ(5,*)ANNN
		IF(ANNN.GT.0) THEN
			NNN=ANNN
			DO IJK=1,NNN
				READ(5,*)ANN,CONC
				NN=ANN
				X(NN)=CONC
			END DO
		END IF
	END IF
	END IF
	CLOSE(5)

	
5	IF(X(30).LT.0.1)THEN
		J=0
		DO 180 IJ=31,131
		IF (X(IJ).GT.0.0) THEN
			J=J+1
			NCOMP(J) = IJ
			WRITE(2,*)J,NCOMP(J)
		ENDIF
180		CONTINUE
		WRITE(2,182)TEMP,PB,(NCOMP(IJ),IJ=1,J)
182		FORMAT(//,'THE SYSTEM IS RUNNING OUT OF WATER
     X(<0.1G).  THIS MEANS THAT THE MODEL IS AT THE 
     XEUTECTIC,',/,'BEYOND THE EUTECTIC, EVAPORATED TO DRYNESS,  
     XOR THE MODEL IS HAVING CONVERGENCE PROBLEMS',/, 
     X'AT T =',F8.3,' K AND P =',F8.3,' BARS',/,
     X'THE SOLIDS THAT ARE PRECIPITATING ARE',10I5)		
	GO TO 270
	END IF
	
	CALL PARAMETER
	CALL PITZER

C  TEST FOR SUPERSATURATION WITH RESPECT TO ICE AND HYDRATE PHASES
C  AND FREEZE IF NECESSARY.
	
	EQ1AH2O=999.9
	EQ2AH2O=999.8
	
C  RE-EQUILIBRATE GAS COMPONENTS

	AX(28)=AH2O/K(28)
	
	IF (AX(29).GT.0.0) THEN
		CALL GAS(29,PB,TEMP,GX(29),ZZZ)
		X(21)=K(29)*AX(29)*GX(29)/GX(21)
		EQ1AH2O = (K(87)/(GX(29)*AX(29)))**(0.1666666667)
	END IF
	
	IF (AX(154).GT.0.0) THEN
		CALL GAS(154,PB,TEMP,GX(154),ZZZ)
		X(155)=K(155)*AX(154)*GX(154)/GX(155)
		EQ2AH2O = (K(88)/(GX(154)*AX(154)))**0.1666666667
	END IF
	
	IF(AX(151).GT.0.0)X(152)=K(152)*AX(151)/GX(152)
	
	IF((EQ1AH2O.LT.EQ2AH2O).AND.(EQ1AH2O.LT.K(31)))CASE = 1
	IF((EQ2AH2O.LT.EQ1AH2O).AND.(EQ2AH2O.LT.K(31)))CASE = 2
	IF((K(31).LT.EQ2AH2O).AND.(K(31).LT.EQ1AH2O))CASE = 3

	IF (CASE.EQ.1) THEN
		IF((AH2O.GT.EQ1AH2O).OR.(X(87).GT.0.0))
     XCALL CO26H2O(EQ1AH2O)
	END IF

	IF (CASE.EQ.2) THEN
		IF((AH2O.GT.EQ2AH2O).OR.(X(88).GT.0.0))
     XCALL CH46H2O(EQ2AH2O)
	END IF
	
	IF (CASE.EQ.3) THEN
		IF ((AH2O .GT. K(31)).OR.(X(31).GT.0.0)) THEN
		IF (PATH.EQ.2) THEN
		WRITE(2,*)'THEORETICALLY THIS SOLUTION SHOULD FREEZE.'
    		WRITE (2,*) 'THEREFORE, CAN NOT EVALUATE THIS USING AN 
     X EVAPORATIVE SCENARIO.'
     			GOTO 270
		END IF
		CALL ICE
		END IF
	END IF
	
	X(21)=K(29)*AX(29)*GX(29)/GX(21)
	X(152)=K(152)*AX(151)/GX(152)
	X(155)=K(155)*AX(154)*GX(154)/GX(155)
	
	
C  Conversion from mole/L to mole/kg(H2O) via density calculation.
	IF(MOLAR.EQ.1) THEN
	
	SA=SL/RHO
	CF=(1/RHO)*(1/(1-SA/1000))
	
	X(1)=IX(1)*CF
	X(2)=IX(2)*CF
	X(3)=IX(3)*CF
	X(4)=IX(4)*CF
	X(5) = IX(5)*CF
	X(6) = IX(6)*CF
	X(7) = IX(7)*CF
	X(8) = IX(8)*CF
	X(9) = IX(9)*CF
	X(10) = IX(10)*CF
	X(11)=IX(11)*CF
	X(12)=IX(12)*CF
	X(14)=IX(14)*CF
	X(15) = IX(15)*CF
	X(16)=IX(16)*CF
	X(17) = IX(17)*CF
	X(18) = IX(18)*CF
	X(19) = IX(19)*CF
	X(20) = IX(20)*CF
	X(24) = IX(24)*CF
	X(25) = IX(25)*CF
	WRITE(2,56)RHO,SA,CF
56	FORMAT(F12.6,F12.5,F12.6)
	
	IF(ABS(CF-CFFINAL)*1E6.LT.1)THEN
		MOLAR = 0
		GO TO 200
	END IF
	
	CFFINAL = CF
	END IF

	
C  TEST FOR MINERAL SATURATION AND EQUILIBRATE SOLUTIONS.	
	
200	DO 210 J = 1, 20
		INIT(J) = X(J)
210 	CONTINUE

	CALL PITZER
	ITER = ITER + 1
	
	IF((ACID.GT.0).AND.(AX(23).GT.0))CALL ACIDITY
	IF((ACID.GT.0).AND.(AX(26).GT.0))CALL ACIDITY
	IF((ACID.GT.0).AND.(AX(27).GT.0))CALL ACIDITY
 

	IF((IRON.GT.1).AND.(X(7).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(9).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(10).GT.0.0))CALL ALH

	
	IF((X(5).GT.0.0).AND.(X(12).GT.0.0)) THEN
		SO4T=X(12)+X(16)
		HT=X(5)+X(16)
		CALL BISULFATE(SO4T,HT)
	END IF
	
	IF(IX(166).GT.0)CALL SILICA
	IF((IX(166).GT.0).AND.(IX(10).GT.0))CALL KAOLINITE
	

		
	IF((ACID.GT.0).AND.(X(17).GT.0))CALL HNO3
	IF((ACID.GT.0).AND.(X(12).GT.0))CALL H2SO4
	IF((ACID.GT.0).AND.(X(11).GT.0))CALL HCL
	IF((X(1).GT.0).AND.(X(17).GT.0))CALL NANO3
	IF((X(1).GT.0).AND.(X(12).GT.0).AND.(X(17).GT.0))CALL DARAP
	IF((X(2).GT.0).AND.(X(17).GT.0))CALL KNO3
	IF((X(1).GT.0).AND.(X(16).GT.0))CALL NAHSO4
	IF((X(1).GT.0).AND.(X(12).GT.0).AND.(X(5).GT.0))CALL NA3H
	IF((X(2).GT.0).AND.(X(16).GT.0))CALL KHSO4
	IF((X(2).GT.0).AND.(X(12).GT.0).AND.(X(5).GT.0))CALL K3H
	IF((X(2).GT.0).AND.(X(12).GT.0).AND.(X(5).GT.0))CALL K5H3
	IF((X(2).GT.0).AND.(X(12).GT.0).AND.(X(5).GT.0))CALL K8H6
	IF((X(5).GT.0.0).AND.(X(12).GT.0.0)) THEN
		SO4T=X(12)+X(16)
		HT=X(5)+X(16)
		CALL BISULFATE(SO4T,HT)
	END IF
	
C  THESE ARE FERRIC/ALUMINUM OXIDE/HYDROXIDE SUBROUTINES
	IF((X(9).GT.0.0).AND.(X(5).GT.0.0))CALL FERRICOXIDE
	IF(X(10).GT.0.0)CALL GIBBSITE
	IF((IRON.GT.1).AND.(X(7).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(9).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(10).GT.0.0))CALL ALH
	IF((X(5).GT.0.0).AND.(X(12).GT.0.0)) THEN
		SO4T=X(12)+X(16)
		HT=X(5)+X(16)
		CALL BISULFATE(SO4T,HT)
	END IF	


C  THESE ARE CHLORIDE SUBROUTINES
	IF ((IX(2) .GT. 0) .AND. (IX(11) .GT. 0)) CALL SYLVITE
	IF ((IX(1) .GT. 0) .AND. (IX(11) .GT. 0)) CALL NACL
	IF ((IX(1) .GT. 0) .AND. (IX(18) .GT. 0)) CALL NABR
	IF ((IX(4) .GT. 0) .AND. (IX(11) .GT. 0)) CALL MGCL2
	IF ((IX(4).GT.0).AND.(IX(18).GT.0))CALL MGBR2
	IF ((IX(3) .GT. 0) .AND. (IX(11) .GT. 0)) CALL ANTARCTICITE
	IF ((IX(2) .GT. 0) .AND. (IX(4) .GT. 0) .AND. (IX(11) .GT. 0)) 
     x	CALL CARNALLITE
      IF ((IX(3) .GT. 0) .AND. (IX(4) .GT. 0) .AND. (IX(11) .GT. 0)) 
     x	CALL TACHYHYDRITE
        IF((IX(10).GT.0).AND.(IX(11).GT.0))CALL ALCL3
        IF((IX(7).GT.0).AND.(IX(11).GT.0))CALL FECL2
	IF((IX(9).GT.0).AND.(IX(11).GT.0))CALL FECL3
	IF((IX(9).GT.0).AND.(IX(2).GT.0).AND.(IX(11).GT.0))CALL FECL3KCL
	IF((IRON.GT.1).AND.(X(7).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(9).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(10).GT.0.0))CALL ALH
	
C  THESE ARE PERCHLORATE SUBROUTINES
	IF((IX(1).GT.0).AND.(IX(19).GT.0))CALL NACLO4
	IF((IX(4).GT.0).AND.(IX(19).GT.0))CALL MGCLO4
     	IF((IX(3).GT.0).AND.(IX(19).GT.0))CALL CACLO4
     	IF((IX(2).GT.0).AND.(IX(19).GT.0))CALL KCLO4
     	
C  THESE ARE SULFATE SUBROUTINES
     	IF ((IX(3) .GT. 0) .AND. (IX(12) .GT. 0)) CALL CASO4
	IF ((IX(4) .GT. 0) .AND. (IX(12) .GT. 0)) CALL MGSO4
	IF ((IX(1) .GT. 0) .AND. (IX(12) .GT. 0)) CALL NA2SO4
	IF ((IX(2) .GT. 0) .AND. (IX(12) .GT. 0)) CALL ARCANITE
	IF ((IX(2) .GT. 0) .AND. (IX(4) .GT. 0) .AND. (IX(12) .GT. 0)) 
     x	CALL PICROMERITE
      IF ((IX(1) .GT. 0) .AND. (IX(4) .GT. 0) .AND. (IX(12) .GT. 0)) 
     x	CALL BLOEDITE
      IF ((IX(1) .GT. 0) .AND. (IX(2) .GT. 0) .AND. (IX(12) .GT. 0))
     x	CALL APHTHITALITE
        IF((IX(7).GT.0).AND.(IX(12).GT.0)) CALL FESO4
	IF((IX(9).GT.0).AND.(IX(12).GT.0).AND.(IX(5).GT.0.0)) 
     X	CALL JAROSITE
	IF((IX(9).GT.0).AND.(IX(12).GT.0)) CALL FE3SO4
	IF((IX(7).GT.0).AND.(IX(12).GT.0).AND.(IX(9).GT.0)
     X	.AND.(IX(5).GT.0.0))CALL COPIAPITE
     	IF((IX(7).GT.0).AND.(IX(12).GT.0).AND.(IX(9).GT.0))
     X  CALL FE3FE2SO4
     	IF((IX(7).GT.0).AND.(IX(12).GT.0).AND.(IX(9).GT.0)
     X  .AND.(IX(2).GT.0)) CALL VOLTAITE
     	IF((IX(12).GT.0).AND.(IX(9).GT.0).AND.(IX(5).GT.0.0)) 
     X  CALL FERRICOPIAPITE
	IF((IX(9).GT.0).AND.(IX(12).GT.0).AND.(IX(5).GT.0)) 
     X	CALL FE3SO4H
	IF((IX(9).GT.0).AND.(IX(2).GT.0).AND.(IX(12).GT.0)) 
     X  CALL FE2K4SO4
     	IF((IX(7).GT.0).AND.(IX(2).GT.0).AND.(IX(12).GT.0))
     X	CALL K2FESO4
     	IF((IX(7).GT.0).AND.(IX(1).GT.0).AND.(IX(12).GT.0))
     X	CALL NA2FESO4
        IF((IX(10).GT.0).AND.(IX(12).GT.0)) CALL AL2SO4
        IF((IX(10).GT.0).AND.(IX(12).GT.0).AND.(IX(5).GT.0.0)) 
     X	CALL ALUNITE
     	IF((IX(10).GT.0).AND.(IX(12).GT.0).AND.(IX(2).GT.0.0)) 
     X	CALL ALKSO4
        IF((IX(10).GT.0).AND.(IX(12).GT.0).AND.(IX(1).GT.0.0)) 
     X	CALL ALNASO4
     	IF((IX(10).GT.0).AND.(IX(12).GT.0).AND.(IX(7).GT.0.0)) 
     X	CALL ALFESO4
        IF((IX(10).GT.0).AND.(IX(12).GT.0).AND.(IX(4).GT.0.0)) 
     X	CALL ALMGSO4
     	IF((IRON.GT.1).AND.(X(7).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(9).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(10).GT.0.0))CALL ALH
	IF((X(5).GT.0.0).AND.(X(12).GT.0.0)) THEN
		SO4T=X(12)+X(16)
		HT=X(5)+X(16)
		CALL BISULFATE(SO4T,HT)
	END IF


		
C  THESE ARE CARBONATE SUBROUTINES
	
    	IF ((ALK .GT. 0) .AND. (IX(3).GT.0) .AND. (IX(4).GT.0)) 
     X	CALL DOLOMITE
		HYDRO(1) = AX(5)
	IF ((ALK .GT. 0) .AND. (IX(3).GT.0)) CALL CACO3
		HYDRO(2) = AX(5)
	IF ((ALK .GT. 0) .AND. (IX(4).GT.0)) CALL MGCO3
		HYDRO(3) = AX(5)
	IF ((ALK .GT. 0) .AND. (IX(1).GT.0)) CALL NAHCO3
		HYDRO(4) = AX(5)
	IF ((ALK .GT. 0) .AND. (IX(1).GT.0)) CALL NATRON
		HYDRO(5) = AX(5)
	IF ((ALK .GT. 0) .AND. (IX(1).GT.0)) CALL TRONA
		HYDRO(6) = AX(5)
	IF((ALK.GT.0) .AND. (IX(2).GT.0)) CALL KHCO3
		HYDRO(7) = AX(5)
	IF((ALK.GT.0).AND.(IX(7).GT.0)) CALL FECO3
		HYDRO(8) = AX(5)
	IF((IRON.GT.1).AND.(X(7).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(9).GT.0.0))CALL FEH
	IF((IRON.GT.1).AND.(X(10).GT.0.0))CALL ALH
	IF((X(5).GT.0.0).AND.(X(12).GT.0.0)) THEN
		SO4T=X(12)+X(16)
		HT=X(5)+X(16)
		CALL BISULFATE(SO4T,HT)
	END IF


	IF(X(20).GT.0)CALL BORON
	IF(X(170).GT.0)CALL FLUORIDE
		
	IF (ITER .GT. 50) THEN
		WRITE (2,215)TEMP 
215		FORMAT(//,5X,'THIS RUN (T=',F8.3,'K) IS NOT CONVERGING 
     x	AFTER 50 INTERATIONS')
		J=0
		PERCENT = PERCENT/10
		WRITE (2,*)PERCENT,X(31)
		ITER = 0
		DO 216 IJ=31,131
		IF (X(IJ).GT.0.0) THEN	
			J=J+1
			NCOMP(J) = IJ
		ENDIF
216		CONTINUE
		IF(NMAX.LE.J) GOTO 270
     		
	END IF


C  CALCULATE WATER ASSOCIATED WITH HYDRATED SALTS.

      SALH2O=2*X(32)+6*X(35)+6*X(36)+8*X(37)+12*X(38)+6*X(39)+12*X(40)
	SALH2O=SALH2O+10*X(41)+6*X(43)+7*X(44)+6*X(46)+4*X(47)
	SALH2O=SALH2O+2*X(48)+11*X(50)+3*X(54)+5*X(55)+6*X(56)
	SALH2O=SALH2O+10*X(58)+2*X(59)+3*X(60)+7*X(62)+3*X(66)
	SALH2O=SALH2O+3*X(69)+6.5*X(70)+4.0*X(71)+6*X(72)+2*X(73)
	SALH2O=SALH2O+X(75)+X(78)+X(80)+7*X(81)+X(82)+6*X(83)+4*X(84)
	SALH2O=SALH2O+3*X(86)+10*X(89)+6*X(90)+X(91)+14*X(93)
	SALH2O=SALH2O+6*X(94)+4*X(95)+9*X(96)+8*X(97)+6*X(98)
        SALH2O=SALH2O+6*X(99)+7*X(100)+3*X(101)+2*(X(102)+X(103))
        SALH2O=SALH2O+1.75*X(104)+4*X(105)+7*X(106)+22*(X(107)+X(108))
	SALH2O=SALH2O+22*X(109)+14*X(110)+18*X(111)+6*X(112)+17*X(113)
	SALH2O=SALH2O+6*X(115)+6*(X(119)+X(120))+3*X(116)+12*X(121)
	SALH2O=SALH2O+12*X(122)+22*X(123)+X(124)+22*X(125)+X(126)
	SALH2O=SALH2O+8*X(127)+6*X(128)+6*X(130)+2*X(131)
	SALGM = SALH2O * X(30) * 18.01528 / 1000
	DELGM = SALGM - ISALGM
	X(30) = X(30) - DELGM
	DO 220 J = 1, 25
	IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*(X(30)+DELGM)/X(30)
	IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GO TO 220
	X(J) = X(J) * (X(30) + DELGM) / X(30)
220	CONTINUE
	DO 221 J = 152,172
		IF((J.EQ.153).OR.(J.EQ.154)) GO TO 221
		X(J) = X(J)*(X(30)+DELGM)/X(30)
221	CONTINUE
	DO 230 J = 32, 86
		X(J) = X(J)*(X(30)+DELGM)/X(30)
230	CONTINUE
	DO 232 J = 89,131
		X(J) = X(J)*(X(30)+DELGM)/X(30)
232	CONTINUE



	ISALGM = SALGM
	
	
	
	IF(IRON.EQ.2)THEN
	BALAN=X(1)+X(2)+2*(X(3)+X(4)+X(7)-X(12)-X(15)+X(158)+X(162))
     X  +3*(X(9)+X(10))+X(6)+X(8)-X(11)-X(13)-X(14)-X(16)-X(17)-X(18)
     X  -X(157)+X(159)-X(161)+X(163)-X(165)-X(167)+X(5)-X(19)-X(20)
     X -X(170)+2*X(172)
	PLUSCHARGE=X(1)+X(2)+2*(X(3)+X(4)+X(7))
	X(1) = X(1)-X(1)*BALAN/PLUSCHARGE
	X(2) = X(2)-X(2)*BALAN/PLUSCHARGE
	X(3) = X(3)-X(3)*BALAN/(PLUSCHARGE*2)
	X(4) = X(4)-X(4)*BALAN/(PLUSCHARGE*2)
	X(7) = X(7)-X(7)*BALAN/(PLUSCHARGE*2)
	END IF
	
	IF(IRON.EQ.3)THEN
	BALAN=X(1)+X(2)+2*(X(3)+X(4)+X(7)-X(12)-X(15)+X(158)+X(162))
     X  +3*(X(9)+X(10))+X(6)+X(8)-X(11)-X(13)-X(14)-X(16)-X(17)-X(18)
     X  -X(157)+X(159)-X(161)+X(163)-X(165)-X(167)+X(5)-X(19)-X(20)
     X -X(170)+2*X(172)
	X(5) = X(5)-BALAN
	END IF

234	CONTINUE


		
	

C  TEST FOR MINERAL EQUILIBRIA.
	
	DO 240 J = 1, 20
		WATER = X(30)*18.01528
		FINAL(J) = X(J)
		IF (FINAL(J) .EQ. 0) GOTO 240
	IF ((ABS(FINAL(J)-INIT(J))/FINAL(J))*PERCENT.GT.(0.1)) GOTO 5
240	CONTINUE


	
	
C  TEST OF PH CONVERGENCE.

	IF(ALK.EQ.0.0)GOTO 245
	HMIN = MIN(HYDRO(1),HYDRO(2),HYDRO(3),HYDRO(4),HYDRO(5),HYDRO(6)
     X,HYDRO(7),HYDRO(8))
	HMAX = MAX(HYDRO(1),HYDRO(2),HYDRO(3),HYDRO(4),HYDRO(5),HYDRO(6)
     X,HYDRO(7),HYDRO(8))
	PCEN = ((HMAX-HMIN)/HMIN)*PERCENT
	IF(ABS(PCEN).GT.1.0) GOTO 200
	

C TEST FOR ICE-GAS HYDRATE-WATER EQUILIBRIUM. 

245	CALL PITZER

	
	IF ((AH2O-K(31) .GT. 0.00001).OR.
     X((X(31).GT.0.0).AND.(K(31)-AH2O.GT.0.0001))) GOTO 5
     	IF(NCAR.EQ.1) THEN
     		IF ((AH2O-EQ1AH2O .GT. 0.0001).OR.
     X((X(87).GT.0.0).AND.(EQ1AH2O-AH2O.GT.0.0001))) GOTO 5
        	IF ((AH2O-EQ2AH2O .GT. 0.0001).OR.
     X((X(88).GT.0.0).AND.(EQ2AH2O-AH2O.GT.0.0001))) GOTO 5
     	END IF
     	
C TEST FOR MOLAR TO MOLAL CONVERGENCE
	IF (MOLAR.EQ.1)GO TO 5

	ITTER=ITTER+1	
	
C  PRINT RESULTS.

	CALL PPRINT(PERCENT)

C UPDATE TEMPERATURE OR WATER CONTENT OR PRESSURE.

	IF (PATH.EQ.1) THEN
		TEMP = TEMP-DELTEM
		DELTAT=(TEMP-FINTEM)
		IF(DELTAT.LT.0.0)GO TO 270
		J=0
		DO 261 IJ=31,131
		IF (X(IJ).GT.0.0) THEN
			J=J+1
			NCOMP(J) = IJ
		ENDIF
261		CONTINUE

		IF(NMAX.LE.J)THEN
			WRITE(2,262)NMAX,TEMP,(NCOMP(IJ),IJ=1,J)
262			FORMAT(//,'GIVEN THE INITIAL SPECIFICATIONS, THE 
     X MODEL HAS SENSED THAT THE MAXIMUM NUMBER ',/,'OF SOLID PHASES (',
     XI2,') ARE PRECIPITATING, WHICH MEANS THAT THE MODEL IS AT THE 
     XEUTECTIC,',/,'BEYOND THE EUTECTIC, OR THE MODEL IS HAVING 
     XCONVERGENCE PROBLEMS AT T =',F8.3,/,'THE SOLIDS THAT ARE 
     XPRECIPITATING ARE',10I5)
     		GOTO 270
    		ENDIF
             IF(TEMPI .EQ. FINTEM) GOTO 270

C  IF YOU WANT TO REDUCE THE TEMPERATURE DECREMENT IN THE VICINITY OF
C  AN EQUILIBRIUM OR SOME OTHER POINT (E.G., FROM 5 K TO 1K OR 0.1K), 
C  REPLACE THE TEMPERATURE OR DELTEM IN EITHER OF THE FOLLOWING 
C  TWO STATEMENTS AND REMOVE COMMENT "C".
C		IF(TEMP.LE.248.15) DELTEM=1.0
C		IF(TEMP.LE.243.15) DELTEM=0.1
	OPEN(4, FILE= 'NUANCES.TXT') 
		READ(4,*)ANN
		IF(ANN.EQ.1)THEN
			READ(4,*)ATEMP,ADELTEM
			READ(4,*)BTEMP,BDELTEM
			IF(TEMP.LE.ATEMP) DELTEM=ADELTEM
			IF(TEMP.LE.BTEMP) DELTEM=BDELTEM
		END IF
	CLOSE(4)
		 GOTO 3
	END IF
	
	IF (PATH.EQ.2) THEN 
		X(30)=X(30)-DELWAT
		TH2O = SALGM+X(30)
		IF (TH2O.LT.FINWAT) GOTO 270
		DO 263 IJK=1,25
		IF((IJK.EQ.5).AND.(ACID.GT.0.0))X(IJK)=X(IJK)*(X(30)
     X+DELWAT)/X(30)
		IF((IJK.EQ.5).OR.(IJK.EQ.13).OR.(J.EQ.23)) GOTO 263
		X(IJK)=X(IJK)*(X(30)+DELWAT)/X(30)
263		CONTINUE
		DO 264 IJK=152,172
			IF((IJK.EQ.153).OR.(IJK.EQ.154)) GO TO 264
			X(IJK) = X(IJK)*(X(30)+DELWAT)/X(30)
264		CONTINUE
		DO 265 IJK=32,131
			X(IJK)=X(IJK)*(X(30)+DELWAT)/X(30)
265		CONTINUE

C  IF YOU WANT TO REDUCE THE WATER DECREMENT IN THE VICINITY OF
C  AN EQUILIBRIUM OR SOME OTHER POINT (E.G., FROM 50G TO 10G OR 1G), 
C  REPLACE THE WATER OR DELWAT IN THE FOLLOWING 
C  STATEMENTS AND REMOVE COMMENT "C".
C		IF(X(30).LE.20) DELWAT=1.0
C		IF(X(30).LE.5) DELWAT=0.1
	OPEN(4, FILE= 'NUANCES.TXT')
		DO IJK = 1,3
			READ(4,*)PHOPTION(IJK)
		END DO 
		READ(4,*)ANN
		IF(ANN.EQ.1)THEN
			READ(4,*)AWAT,ADELWAT
			READ(4,*)BWAT,BDELWAT
			IF(X(30).LE.AWAT) DELWAT=ADELWAT
			IF(X(30).LE.BWAT) DELWAT=BDELWAT
		END IF
	CLOSE(4)
		GO TO 3	
	END IF
	
	IF (PATH.EQ.3) THEN
		IF(PB.GE.FINPRE)GO TO 270
		PB=PB+DELPRE
		IF(CO2MF.EQ.0.0)AX(29)=AX(29)
		IF(CO2MF.GT.0.0)AX(29)=CO2MF*PB
		IF(CH4MF.EQ.0.0)AX(154)=AX(154)
		IF(CH4MF.GT.0.0)AX(154)=CH4MF*PB
		
C  IF YOU WANT TO REDUCE THE PRESSURE INCREMENT IN THE VICINITY OF
C  AN EQUILIBRIUM OR SOME OTHER POINT (E.G., FROM 50 BARS TO 10 BARS
C  OR 1 BAR, REPLACE THE PRESSURE OR DELPRE IN EITHER OF THE FOLLOWING 
C  STATEMENTS AND REMOVE COMMENT "C".
C      		IF(PB.GE.250) DELPRE=10
C		IF(PB.GE.801) DELPRE=1
	OPEN(4, FILE= 'NUANCES.TXT')
		DO IJK=1,6
			READ(4,*)PHOPTION(IJK)
		END DO  
		READ(4,*)ANN
		IF(ANN.EQ.1)THEN
			READ(4,*)APRE,ADELPRE
			READ(4,*)BPRE,BDELPRE
			IF(PB.GT.APRE) DELPRE=ADELPRE
			IF(PB.GT.BPRE) DELPRE=BDELPRE
		END IF
	CLOSE(4)

		GO TO 3
	END IF
	
	
270	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE PARAMETER
	
C  This subroutine calculates the parameters and their temperature
C  dependence for the Pitzer equations and mineral solubility products.
	
	REAL IX,I,LAM
	CHARACTER*50 TITLE
	DOUBLE PRECISION D(350,6), P(350),AKI,AKII,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
          
  	 COMMON /A/ MAXCAT,MAXAN,AKI(0:20),AKII(0:20),BET0(200,200),
     XBET1(200,200),BET2(200,200),C(200,200),CPHI(200,200),
     XPSI(200,200,200),THETA(200,200),A,Z(30),LAM(200,200),
     XXI(200,200,200),BV0(200,200),BV1(200,200),BV2(200,200),
     XCV(200,200),AV


	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
      DIMENSION PINT(21),YAA(21)
     
	DATA AKI / 1.925154014814667, -0.060076477753119,
     x	-0.029779077456514, -0.007299499690937,
     x	0.000388260636404, 0.000636874599598,
     x	0.000036583601823, -0.000045036975204,
     x	-0.000004537895710, 0.000002937706971,
     x	0.000000396566462, -0.000000202099617,
     x	-0.000000025267769, 0.000000013522610,
     x	0.000000001229405, -0.000000000821969,
     x	-0.000000000050847, 0.000000000046333,
     x	0.000000000001943, -0.000000000002563,
     x	-0.000000000010991 /
     
      DATA AKII / 0.628023320520852, 0.462762985338493,
     x	0.150044637187895, -0.028796057604906,
     x	-0.036552745910311, -0.001668087945272,
     x	0.006519840398744, 0.001130378079086,
     x	-0.000887171310131, -0.000242107641309,
     x	0.000087294451594, 0.000034682122751,
     x	-0.000004583768938, -0.000003548684306,
     x	-0.000000250453880, 0.000000216991779,
     x	0.000000080779570, 0.000000004558555,
     x	-0.000000006944757, -0.000000002849257,
     x	0.000000000237816 /
     
      DATA Z / 1,1,2,2,1,1,2,1,3,3,-1,-2,-1,-1,-2,
     x	-1,-1,-1,-1,-1,0,0,0,0,0,0,0,0,0,0 /
     

C  The First Data Stored in D(I,J) are from Spencer et al. (1990) 
C  and Marion and Farren (1998)


      DATA ((D(II,JJ),JJ=1,6),II=1,10) /
     x	86.6836498, 0.0848795942, -8.8878515D-5,
     x	4.88096393D-8, -1.32731477D3, -17.6460172,
     x	7.87239712, -8.3864096D-3, 1.44137774D-5,
     x	-8.7820301D-9, -496.920671, -0.820972560,
     x	866.915291, 0.606166931, -4.8048921D-4,
     x	1.88503857D-7, -1.70460145D4, -167.171296,
     x	1.70761824, 2.32970177D-3, -2.46665619D-6,
     x	1.21543380D-9, -1.35583596, -0.387767714,
     x	26.5718766, 9.92715099D-3, -3.62323330D-6,
     x	-6.28427180D-11, -755.707220, -4.67300770,
     x	1.69742977D3, 1.22270943, -9.99044490D-4,
     x	4.04786721D-7, -3.28684422D4, -328.813848,
     x	-3.27571680, -1.27222054D-3, 4.71374283D-7,
     x	1.1162507D-11, 90.7747666, 0.580513562,
     x	-5.62764702D1, -3.00771997D-2, 1.05630400D-5,
     x	3.3331626D-9, 1.11730349D3, 1.06664743D1,
     x	3.4787, -1.5417D-2, 3.1791D-5, 0, 0, 0,
     x	2.64231655D1, 2.46922993D-2, -2.48298510D-5,
     x	1.22421864D-8, -4.18098427D2, -5.35350322/
      DATA ((D(II,JJ),JJ=1,6),II=11,21) /
     x	3.13852913D2, 2.61769099D-1, -2.46268460D-4,
     x	1.15764787D-7, -5.53133381D3, -6.21616862D1,
     x	-3.18432525D4, -2.86710358D1, 2.78892838D-2,
     x	-1.3279705D-5, 5.24032958D5, 6.40770396D3,
     x	5.9532D-2, -2.49949D-4, 2.41831D-7, 0, 0, 0,
     x	-0.12709E1, 0.4425144E-2, -0.35E-8,
     x	-0.928E-9, 0.1425E2, -0.584E-2,
     x	-0.13915E1, 0.107532E-1, -0.183E-6,
     x	-0.4498E-8, 0.9328E2, -0.167885E0,
     x	0.21225E0, -0.72306E-3, 0.00,
     x	-0.114E-9, 0.435E1, -0.1855E-2,
     x	-0.7568E0, 0.2529E-2,0.365E-7,0.531E-9,
     x      -0.108E1,-0.125E-2,
     x	0.1953E1,-0.3996E-2,0.355E-6,
     x      0.1669E-7,0.267E2,-0.4785E-1,
     x	0.70E-3,0.48E-4,0.90E-8,0.326E-9,-0.768E1,0.2835E-2,
     x  0.795e-1,-0.122E-3,0.5001E-5,0.6704E-8,-0.15228E3,-0.6885e-2,
     x  0.28945E1,0.7434E-2,0.5287E-5,
     x  -0.101513E-6,-0.208505E4,0.1345E1/
       DATA ((D(II,JJ),JJ=1,6),II=22,33) /
     x	-0.5704E2,-0.1028E-1,-0.2235E-3,
     x      0.3526E-6,0.5788E4,-0.18378E1,
     x	0.1678E1,-0.5514E-2, 0.597E-6,
     x	0.15651E-7, -0.22392E3, 0.6594E-1,
     x	0.1484E1,0.6274E-2,0.541E-5,0.884E-7,
     x      -0.13210E4,0.30605E0,
     x	0.2230E0,-0.6101E-3,-0.10E-8,-0.1096E-8,0.4265E2,-0.1792E-1,
     x	-1.82266741E1, -3.6903847E-3, 0.0,
     x	0.0, 6.12415011E2, 3.02994981,
     x	6.48108127, 1.46803468D-3, 0,
     x	0, -204.354019, -1.09448043,
     x	-0.563E-1,0.1414E-2,0.23E-7,
     x      -0.21088E-7,-0.25661E3,0.18538E0,
     x	0.30E-1,-0.19E-4, 0.00, 0.95E-9,-0.250E1,0.13E-2,
     x	-7.63980, -1.2990D-2, 1.1060D-5, 0, 0, 1.8475,
     x	-0.808E-1,0.46565E-2,0.5546E-5,
     x	-0.14107E-6,-0.10915E4,0.96985E0,
     x	0.07,0.00,0.00,0.00,0.00,0.00,
     x	-3.109870D-2, 5.4464780D-5, 0, 0, 1.99404210, 0/
       DATA ((D(II,JJ),JJ=1,6),II=34,47) /
     x	-0.1207E0,0.5235E-3,-0.539E-6,
     x	-0.439E-9,-0.1723E2,0.12645E-1,
     x	2.365710, -4.540D-3, 0, 0, -2.84940D2, 0,
     x	-5.930D-2, 2.54280D-4, 0, 0, -1.34390D1, 0,
     x	0.1167, 0, 0, 0, 0, 0,
     x	5.0362230D-2, -8.750820D-6, 0, 0, -2.899090D1, 0,
     x	-0.118e0,-0.478e-4,-0.327e-6,
     x      -0.937e-9,0.3344e2,-0.884e-2,
     x	5.31274136, -6.3424248D-3, 0, 0, -9.83113847D2, 0,
     x	4.15790220D1, 1.30377312D-2, 0,0, -9.81658526D2, -7.4061986,
     x	0.70E-1, 0, 0, -0.78E-9,-0.100E1, 0,
     x	0.2554E-1,-0.6138E-4,-0.90E-8,0.304E-9,-0.89E0,-0.2275E-2,
     x	0.608E-1,-0.1824E-3,-0.215E-7,-0.328E-9,0.522E1,-0.301E-2,
     x	-0.263E-1, -0.946E-4, -0.3125e-6,
     x      -0.128E-8,0.2944E2,-0.649E-2,
     x	0.5869E-1,-0.897E-4,0.47E-7,0.65E-10,-0.2413E2,0.4345E-2,
     x	-1.62917341D3, -1.51940390, 1.45249679D-3,
     x	-6.9427505D-7, 2.26012743D4, 333.075506/
       DATA ((D(II,JJ),JJ=1,6),II=48,60) /
     x 1.906354e0,-1.880285e-2,6.603001e-5,-3.419967e-8,0.0,0.0,
     x	-1.2222551D4, -9.8806459, 8.46685083D-3,
     x	-3.4459117D-6, 2.09823965D5, 2.42328528D3,
     x	-1.47477745D1, 0, 0, 0, 3.26409496D3, 0,
     x	3.65283115D2, -7.1578257D-1, 0, 0, -4.48753391D4, 0,
     x	9.14839001D3, 8.22348745, -8.1288759D-3,
     x	3.95552403D-6, -1.54040868D5, -1.83624247D3,
     x	1.42290062D5, 1.61973105D2, -1.95332071D-1,
     x	1.17636119D-4, -2.04059847D6, -2.97464810D4,
     x	7.52225099D2, 1.17584653D-1,0,0,-2.43223909D4,-1.21990076D2,
     x	2.27801976D3, 6.49361616D-1,0,0,-6.23075123D4,-3.95438891D2,
     x	2.55008896D5, 2.44532240D2, -2.48807876D-1,
     x	1.22425236D-4, -4.02988342D6, -5.18668604D4,
     x	-4.45702171D1, 2.32023790D-1, -7.14935692D-4,
     x	5.32658215D-7, -4.24817923D3, 8.59110245,
     x	8.03777918D1, -1.388069D-1, 0, 0, 0, 0,
     x	-46.33773,1.753075e-1,-9.822103e-5,0.0, 0.00, 0.0,
     x	-1.238537, 1.929792E-3, 0.00,0.0,0.0,0.0/
       DATA ((D(II,JJ),JJ=1,6),II=61,73) /
     x	-5.7876, 0.0068509, 0, 0, 0.00, 0.00,
     x	0.3956E1, 0, 0, 0, -0.24710E4, 0,
     x	0.6500E1, 0.0, 0.0, 0.0, -0.31573E4, 0.0,
     x	-0.8661262E2, 0.470966E0, -0.7186864E-3, 0, 0, 0, 
     x	-0.79121E1, 0.8220223E-2,0.00,0,0,0,
     x      -91.07165, 0.7584271, -2.370863e-3, 2.456876e-6, 0, 0,
     x	-0.7822042E2,0.6908174E0,-0.2246589E-2,0.2344988E-5,0.0,0.0,
     x	-0.3089478e2, 0.9351655e-1, 0.0, 0.0, 0.0, 0.0,
     x	-0.6207986e2, 0.1527005E0, 0.00, 0.0,0.0,0.0,
     x	0.00,0.00,0.00,0.00,0.00,0.00,
     x	0.33e-1,-0.1529e-3,0.897e-6,
     x	0.1569e-8,0.11e1,-0.12755e-1,
     x	0.024, 0.0,0.0,0.0,0.0,0.0,
     x	0.18829E3,-0.103999E1,0.12242E-2,0.34974E-5,
     x      0.8975E5,-0.679235E2/
      T=TEMP
	DO 730 J = 1, 73
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3+D(J,5)
     x		/T+D(J,6)*LOG(T)
730	CONTINUE
	DO 700 J=1,200
		K(J) = 0.0
		KV(J) = 0.0
700	CONTINUE

	A = P(1)
	BET0(1,11) = P(2)
	BET1(1,11) = P(3)
	CPHI(1,11) = P(4)
	BET0(2,11) = P(5)
	BET1(2,11) = P(6)
	CPHI(2,11) = P(7)
	BET0(3,11) = P(8)
	BET1(3,11) = P(9)
	CPHI(3,11) = P(10)
	BET0(4,11) = P(11)
	BET1(4,11) = P(12)
	CPHI(4,11) = P(13)
	BET0(2,12) = P(17)
	BET1(2,12) = P(18)
	CPHI(2,12) = P(19)
	BET0(3,12) = P(20)
	BET1(3,12) = P(21)
	BET2(3,12) = P(22)
	CPHI(3,12) = P(71)
	BET0(4,12) = P(23)
	BET1(4,12) = P(24)
	BET2(4,12) = P(73)
	CPHI(4,12) = P(25)
	THETA(1,2) = P(26)
	PSI(1,2,11) = P(27)
	PSI(1,2,12) = P(28)
	THETA(1,3) = P(29)
	PSI(1,3,11) = P(30)
	PSI(1,3,12) = P(31)
	THETA(1,4) = P(32)
	PSI(1,4,11) = P(33)
	PSI(1,4,12) = P(34)
	THETA(2,3) = P(35)
	PSI(2,3,11) = P(36)
	PSI(2,3,12) = P(70)
	THETA(2,4) = P(37)
	PSI(2,4,11) = P(38)
	PSI(2,4,12) = P(39)
	THETA(3,4) = P(40)
	PSI(3,4,11) = P(41)
	PSI(3,4,12) = P(72)
	THETA(11,12) = P(42)
	PSI(11,12,1) = P(43)
	PSI(11,12,2) = P(44)
	PSI(11,12,3) = P(45)
	PSI(11,12,4) = P(46)
	K(34) = EXP(P(47))
	K(31) = P(48)
	K(32) = EXP(P(49))
	K(33) = EXP(P(52))
	K(35) = EXP(P(53))
	K(36) = EXP(P(54))
	K(37) = EXP(P(55))
	K(38) = EXP(P(56))
	K(39) = EXP(P(57))
	K(40) = EXP(P(58))
	K(41) = EXP(P(59))
	K(42) = EXP(P(60))
	K(43) = EXP(P(61))
	K(44) = EXP(P(62))
	K(45) = EXP(P(63))
	K(46) = EXP(P(64))
	K(47) = EXP(P(65))
	K(48) = EXP(P(66))
	K(49) = EXP(P(67))
	K(50) = EXP(P(68))
	K(51) = EXP(P(69))
C
C THE DATA BELOW FOR CARBONATE PARAMETERS COME FROM HE AND MORSE (1993)
C OR PABALAN AND PITZER(87) OR HOLMES ET AL.(87) OR MARION(2000)
C
	DATA ((D(II,JJ),JJ=1,6), II=81,99)/
     X-37.2624193,-0.01445932,0.0,0.0,682.885977,6.8995857,
     X-61.4635193,-0.02446734,0.0,0.0,1129.389146,11.4108589,
     X-0.3088232,0.001,0.0,0.0,-0.00069869,-4.701488E-6,
     X-0.2802,0.00109999,0.0,0.0,0.000936932,6.15660566E-6,
     X13697.10,8.250840,-0.00434,0.0,-273406.1716,-2607.115202,
     X-157839.8351,-92.7779354,0.0477642,0.0,3203209.6948,29927.151503,
     X29576.53405,18.447305,-0.009989,0.0,-576520.5185,-5661.1237,
     X-1028.8510522,-0.3725876718,8.9691E-5,0,26492.240303,183.13155672,
     X-60.5387702,-0.023301655,0.0,0.0,1108.3760518,11.19855531,
     X-237.5156616,-0.09989121,0.0,0.0,4412.511973,44.5820703,
     X0.0052,0.0,0.0,0.0,0.0,0.0,
     X-0.1991649,0.00110,0.0,0.0,1.8063362E-5,0.0,
     X0.1330579,0.00436,0.0,0.0,0.0011899,0.0,
     X0.0005,0.0,0.0,0.0,0.0,0.0,
     X0.0,0.0,0.0,0.0,0.0,0.0,
     X-5496.38465,-3.326566,0.0017532,0.0,109399.341,1047.021567,
     X2856.528099,1.7670079,-0.0009487,0.0,-55954.1929,-546.074467,
     X-12774.6472,-8.101555,0.00442472,0.0,245541.5435,2452.509720,
     X-479.362533,-0.541843,0.00038812,0.0,3589.474052,104.3452732/
      DATA ((D(II,JJ),JJ=1,6),II=100,117) /
     X1659.944942,0.9964326,-0.00052122,0.0,-33159.6177,-315.827883,
     X2274.656591,1.8270948,-0.00114272,0.0,-33927.7625,-457.015738,
     X-804.121738,-0.470474,0.000240526,0.0,16334.38917,152.3838752,
     X-379.459185,-0.258005,0.000147823,0.0,6879.030871,73.74511574,
     X-379.686097,-0.257891,0.000147333,0.0,6853.264129,73.79977116,
     X-166.065290,-0.018002,-2.47349E-5,0.0,5256.844332,27.377452415,
     X-1342.60256,-0.772286,0.000391603,0.0,27726.80974,253.62319406,
     X0.0,0.0,0.0,0.0,0.0,0.0,
     X67030.02482,37.930519,-0.01894730,0.0,-1399082.37,-12630.27457,
     X-2907.03326,-2.860763,0.001951086,0.0,30756.86749,611.37560512,
     X-7374.24392,-4.608331,0.002489207,0.0,143162.6076,1412.302898,
     x-148.16780,0.8933802,-2.332199e-3,2.146860e-6,0.0,0.0,
     X-1.290052E1,1.108975E-1,-3.208817E-4,3.124540E-7,0.0,0.0,
     X-7.698673E0,7.152585E-2,-2.187257E-4,2.290117E-7,0.0,0.0,
     X-2.011610E-1,2.492005E-3,-9.411507E-6,1.127798E-8,0.0,0.0,
     X3.56122E-1,-5.305245E-4,0.00,0.00,0.0,0.0,
     X-7.420199E0,1.15874E-1,-6.666408E-4,1.685445E-6,-1.564321E-9,0.0,
     X-2.78619E-3,1.735035E-5,-5.937631E-8,0.0,0.0,0.0/

C
C THE DATA BELOW COME FROM PLUMMER AND BUSENBERG(82) 
C  AND PLUMMER ET AL(88)
C
	DATA ((D(II,JJ),JJ=1,6), II=131,136)/
     X-395.8293,-0.179586,0.0,6537.774,71.595,0.0,
     X249.5691,0.04570806,0.0,-15932.81,-40.45154,1541270,
     X-820.4327,-0.14027266,0.0,50275.49,126.8339,-3879660,
     X-248.4192,-0.07489962,0.0,11862.43,38.92561,-1297999,
     X2829.430,0.689486,0.0,-81771.13,-485.818,0.0,
     X74.201,0.0,0.0,-2517.845,-12.72433,0.0/
     
	DO 740 J = 81, 114
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3+D(J,5)
     x		/T+D(J,6)*LOG(T)
740	CONTINUE 
	
	DO 745 J = 115, 117
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3+D(J,5)
     x		*T**4
745	CONTINUE


	DO 750 J = 131,136
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)/T+D(J,5)*LOG(T)
     X + D(J,6)/T**2
750	CONTINUE
	

      	BET0(1,14) = P(81)
	BET1(1,14) = P(82)
	BET0(2,14) = P(83)
	BET1(2,14) = P(84)
	BET0(4,14) = P(85)
	BET1(4,14) = P(86)
	BET0(3,14) = P(87)
	BET1(3,14) = P(88)
	BET0(1,15) = P(89)
	BET1(1,15) = P(90)
	CPHI(1,15) = P(91)
	BET0(2,15) = P(92)
	BET1(2,15) = P(93)
	CPHI(2,15) = P(94)
	LAM(5,21) = P(95)
	LAM(1,21) = P(96)
	LAM(2,21) = P(97)
	LAM(3,21) = P(98)
	LAM(4,21) = P(99)
	LAM(11,21) = P(100)
	LAM(16,21) = LAM(11,21)
	LAM(17,21) = LAM(11,21)
	LAM(18,21) = LAM(11,21)
	LAM(19,21) = LAM(11,21)
	LAM(12,21) = P(101)
	XI(5,11,21) = P(102)
	XI(5,16,21) = XI(5,11,21)
	XI(5,17,21) = XI(5,11,21)
	XI(5,18,21) = XI(5,11,21)
	XI(5,19,21) = XI(5,11,21)
	XI(1,11,21) = P(103)
	XI(1,16,21) = XI(1,11,21)
	XI(1,17,21) = XI(1,11,21)
	XI(1,18,21) = XI(1,11,21)
	XI(1,19,21) = XI(1,11,21)
	XI(2,11,21) = P(104)
	XI(2,16,21) = XI(2,11,21)
	XI(2,17,21) = XI(2,11,21)
	XI(2,18,21) = XI(2,11,21)
	XI(2,19,21) = XI(2,11,21)
	XI(3,11,21) = P(105)
	XI(3,16,21) = XI(3,11,21)
	XI(3,17,21) = XI(3,11,21)
	XI(3,18,21) = XI(3,11,21)
	XI(3,19,21) = XI(3,11,21)
	XI(4,11,21) = P(106)
	XI(4,16,21) = XI(4,11,21)
	XI(4,17,21) = XI(4,11,21)
	XI(4,18,21) = XI(4,11,21)
	XI(4,19,21) = XI(4,11,21)
	XI(5,12,21) = P(107)
	XI(1,12,21) = P(108)
	XI(2,12,21) = P(109)
	XI(4,12,21) = P(110)
	K(13) = EXP(P(111))
	BET0(1,13) = P(112)
	BET1(1,13) = P(113)
	CPHI(1,13) = P(114)
	BET0(5,11) = P(115)
	BET1(5,11) = P(116)
	CPHI(5,11) = P(117)
	K(52) = EXP(P(131))
	K(29) = EXP(P(132))/1.01325
	K(14) = EXP(P(133))
	K(15) = EXP(P(134))
	K(24) = EXP(P(135))
	K(25) = EXP(P(136))
	
C  SALINITY CALCULATIONS FOR SEAWATER CARBONATE SUPERSATURATION
	IF(CARBSS.EQ.1) THEN
		SAA=SA*X(1)/IX(1)
		OMEGA = -14.6128 + 0.098043*TEMP + 0.129602*SAA
		K(52) = K(52)*OMEGA
	END IF


C
C THE FOLLOWING CONSTANTS ARE FROM HARVIE ET AL(84)
C
	BET0(2,13) = 0.1298
	BET1(2,13) = 0.320
	CPHI(2,13) = 0.0041
	BET0(3,13) = -0.1747
	BET1(3,13) = -0.2303
	BET2(3,13) = -5.72
	BET0(5,12) = 0.0298
	CPHI(5,12) = 0.0438
	PSI(1,2,14) = -0.003
	PSI(1,2,15) = 0.003
	THETA(11,13) = -0.050
	PSI(11,13,1) = -0.006
	PSI(11,13,2) = -0.006
	PSI(11,13,3) = -0.025
	THETA(11,14) = 0.03
	PSI(11,14,4) =-0.096
	THETA(11,15) = -0.02
	PSI(11,15,1) = 0.0085
	PSI(11,15,2) = 0.004
	THETA(12,13) = -0.013
	PSI(12,13,1) = -0.009
	PSI(12,13,2) = -0.050
	THETA(12,14) = 0.01
	PSI(12,14,1) = -0.005
	PSI(12,14,4) = -0.161
	THETA(12,15) = 0.02
	PSI(12,15,1) = -0.005
	PSI(12,15,2) = -0.009
	THETA(13,15) = 0.10
	PSI(13,15,1) = -0.017
	PSI (13,15,2) = -0.01
	THETA(14,15) = -0.04
	PSI(14,15,1) = 0.002
	PSI(14,15,2) = 0.012
	THETA(1,5) = 0.036
	PSI(1,5,11) = -0.0037
	THETA(2,5) = 0.005
	PSI(2,5,11) = -0.0114
	THETA(4,5) = 0.10
	PSI(4,5,11) = -0.0077
	THETA(3,5) = 0.092
	PSI(3,5,11) = -0.0142
	PSI(12,16,5) = 0.0
C
C THE FOLLOWING PARAMETERS ARE FOR CARBONATE EQUILIBRIA
C
	DATA((D(II,JJ),JJ=1,6),II=137,151)/
     X-0.39E-2,-0.325E-4,-0.66E-7,-0.274E-9,0.583E1,-0.985E-3,
     X-28.902,0,0,0,3104.3,0,
     X0.5847459E2,-0.4688674E0,0.7771429E-3,0,0,0,
     X0.9556371E3,-0.1003715E2,0.3464409E-1,-0.3978274E-4,0,0,
     X1.391669e2,-1.556298,5.625521e-3,-6.6461e-6,0,0,
     X-0.7861589E1,-0.5802879E-1,0.2622444E-3,0,0,0,
     X-0.9986743e1,0.2563766e-1,0,0,0,0,
     X-0.127801E3,0,0,0,0.12861E5,0,
     X-0.55261e2,0,0,0,0.47485e4,0,
     X-0.1807263E2,0.5723688E-1,0,0,0,0,
     X0.39e-2,0.373e-4,0.164e-6,0.616e-9,-0.1822e2,0.3455e-2,
     X-6.500201,1.301118e-2, 3.442106e-5, 0.0, 0.0, 0.0,
     X0.96E-2,0.47E-5,-0.375E-7,-0.223E-9,0.294E1,-0.52E-3,
     X-395.9924,-0.179586,0.0,0.0,6685.079,71.595,
     X-396.3428,-0.179586,0.0,0.0,7079.731,71.595/
     
	DO 760 J = 137,151
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3+D(J,5)
     x		/T+D(J,6)*LOG(T)
760	CONTINUE

	PSI(11,14,1) = P(137)
	K(53) = EXP(P(138))
	K(54) = EXP(P(139))
	K(55) = EXP(P(140))
	K(57) = EXP(P(141))
	K(58) = EXP(P(142))
	K(59) = EXP(P(143))
	K(60) = EXP(P(144))
	K(61) = EXP(P(145))
	K(62) = EXP(P(146))
	PSI(12,15,1) = P(147)
	K(63) = EXP(P(148))
	PSI(11,15,1) = P(149)
	K(64) = EXP(P(150))
	K(65) = EXP(P(151))
	PSI(1,2,14) = -0.0079
	BET0(6,11) = -0.10
	BET1(6,11) = 1.658
	PSI(4,6,11) = 0.028
	
	
	AKKK=1.685346e2-1.7867604e0*T+4.664398e-3*T**2-4.29372e-6*T**3
     x+1.2861e4/T
     	AKKK=EXP(AKKK)
	

C NEW PARAMETERS ADDED FOR ACIDITY ROUTINES.
	
	DATA((D(II,JJ),JJ=1,6),II=152,158)/
     X394.005278,0.131442311,-0.420928363E-4,0.0,-3020.3522,-71.001998,
     X1.2956527E3,5.704742E-1,-2.57206E-4,0.0,-3.056394E4,-2.360504E2,
     X78.12179,-3.696246E-1,6.735943E-4,-5.00638E-7,0.0,0.0,
     X1.71812E2,-6.503309E-1,6.909049E-4,0.0,0.0,0.0,
     X5.14235,1.63017E-2,0.0,0.0,0.0,0.0,
     X4.367384,3.637139E-3,0.0,0.0,0.0,0.0,
     X-1.270087E1,7.050180E-2,0.0,0.0,0.0,0.0/
     
	DO 770 J = 152,158
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3+D(J,5)
     x		/T+D(J,6)*LOG(T)
770	CONTINUE

	K(23) = EXP(P(154))/1.01325
	K(26) = EXP(P(152))/1.01325
	K(16) = EXP(P(153))
	K(27) = EXP(P(155))/1.01325
	THETA(11,17) = 0.016
	PSI(1,2,17) = -0.0012
	PSI(1,4,17) = -0.0099
	PSI(11,17,3) = -0.0409
	PSI(11,17,4) = 0.0046
	K(66) = EXP(P(158))
	K(69)=EXP(P(156))
	K(72)=EXP(P(157))
	IF(T.GT.203.15) K(72)=1000.00
	
C  THESE PARAMETERS ARE FOR H2SO4 USING CLEGG MODEL.
	DATA((D(II,JJ),JJ=1,6),II=159,168)/
     X-6.888679E-1,1.195453E-2,-4.667571E-5,5.878913E-8,0.0,0.0,
     X-3.815780E2,6.261241E0,-3.789588E-2,1.006085E-4,-9.906089E-8,0.0,
     X9.773929E-2,-1.148641E-3,4.422169E-6,-5.765707E-9,0.0,0.0,
     X1.099940E2,-1.969903E0,1.289248E-2,-3.672285E-5,3.850406E-8,0.0,
     X1.388618E1,-2.200263E-1,1.314763E-3,-3.475869E-6,3.420786E-9,0.0,
     X-1.679737E2,2.609701E0,-1.526685E-2,3.984122E-5,-3.908818E-8,0.0,
     X-5.315201E-1,8.619821E-3,-5.14571E-5,1.350347E-7,-1.314709E-10,.0,
     X-7.766817E2,1.164255E1,-6.537128E-2,1.626702E-4,-1.513403E-7,0.0,
     X-8.947832E1,7.407673E-1,-1.477903E-3,0.0,0.0,0.0,
     X-7.103329E1,6.235489E-1,-1.279573E-3,0.0,0.0,0.0/

        DO 780 J=159,168
		P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3
     X+D(J,5)*T**4
780     CONTINUE

	BET0(5,16) = P(159)
	BET1(5,16) = P(160)
	C0(5,16) = P(161)
	C1(5,16) = P(162)
	BET0(5,12) = P(163)
	BET1(5,12) = P(164)
	C0(5,12) = P(165)
	C1(5,12) = P(166)
	K(70) = EXP(P(167))
	K(71) = EXP(P(168))
	
C NITRIC ACID AND NITRATE PARAMETERS

	DATA((D(II,JJ),JJ=1,6),II=169,180)/
     X-1.019608E0,8.052811E-3,-1.414706E-5,0.0,0.0,0.0,
     X-6.829838E0,7.588276E-2,-2.843828E-4,3.695995E-7,0.0,0.0,
     X1.264791E-1,-8.808517E-4,1.469263E-6,0.0,0.0,0.0,
     X4.151797E0,-4.445727E-2,1.57303E-4,-1.876457E-7,0.0,0.0,
     X2.559033E0,-1.679067E-2,2.892045E-5,0.0,0.0,0.0,
     X-6.187135E0,9.307292E-2,-5.252546E-4,1.316116E-6,-1.233392E-9,0.0,
     X-3.75677E-1,3.241125E-3,-8.920938E-6,7.36791E-9,0.0,0.0,
     X0.7088889,-5.599812E-3,1.085E-5,0.0,0.0,0.0,
     X8.312979E1,-6.161264E-1,1.1334E-3,0.0,0.0,0.0,
     X0.0,0.0,0.0,0.0,0.0,0.0,
     X7.016265E2,-9.648812E0,5.093224E-2,-1.227837E-4,1.144431E-7,0.0,
     X-2.948e-1,7.326e-4,0.0,0.0,0.0,0.0/
       DATA((D(II,JJ),JJ=1,6),II=181,200)/
     X-6.2735,2.1149e-2,0.0,0.0,0.0,0.0,
     X6.669e-2,-2.0505e-4,0.0,0.0,0.0,0.0,
     X-4.652079e1,2.575014e-1,-3.431593e-4,0.0,0.0,0.0,
     X0.3687,-0.5295E-3,0.0,0.0,0.0,0.0,
     X4.1485,-9.1875E-3,0.0,0.0,0.0,0.0,
     X-0.02014,0.0,0.0,0.0,0.0,0.0,
     X0.5207,-0.51525E-3,0.0,0.0,0.0,0.0,
     X2.9242,-4.4925E-3,0.0,0.0,0.0,0.0,
     X-0.02062,0.0,0.0,0.0,0.0,0.0,
     X-3.395532e0,2.266940e-2,-3.80e-5,0.00,0.00,0.00,
     X0.00,0.0,0.0,0.0,0.0,0.0,
     X0.0454,0.00,0.0,0.0,0.0,0.0,
     X-6.7010e0,2.5352e-2,0.0,0.0,0.0,0.0,
     X-2.122993e3,2.296880e1,-8.282936e-2,9.946746e-5,0.0,0.0,
     X-1.897335E4,2.204478E2,-8.5329E-1,1.100162E-3,0.0,0.0,
     X6.581474E2,-6.926105E0,2.431396E-2,-2.830635E-5,0.0,0.0,
     X4.561655E1,-4.356452E-1,8.546984E-4,0.0,0.0,0.0,
     X-3.552640E1,6.711111E-2,0.0,0.0,0.0,0.0,
     X9.591803E1,-9.575202E-1,1.841905E-3,0.0,0.0,0.0,
     X-1.019832E1,3.865551E-2,0.0,0.0,0.0,0.0/


        DO 790 J=169,200
		P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3
     X+D(J,5)*T**4
790	CONTINUE
	BET0(5,17) = P(169)
	BET1(5,17) = P(170)
	CPHI(5,17) = P(171)
	THETA(16,17) = P(172)
	THETA(12,17) = P(173)
	PSI(16,17,5) = P(174)
	PSI(12,17,5) = P(175)
	BET0(1,17) = P(176)
	BET1(1,17) = P(177)
	CPHI(1,17) = P(178)
	K(68) = EXP(P(179))
	BET0(2,17) = P(180)
	BET1(2,17) = P(181)
	CPHI(2,17) = P(182)
	K(67) = EXP(P(183))
	BET0(3,17) = P(184)
	BET1(3,17) = P(185)
	CPHI(3,17) = P(186)
	BET0(4,17) = P(187)
	BET1(4,17) = P(188)
	CPHI(4,17) = P(189)
	CPHI(1,16) = P(191)
	BET0(1,16) = P(192)
	BET1(1,16) = P(193)
	K(74) = EXP(P(194))
	K(75) = EXP(P(196))
	K(76) = EXP(P(197))
	K(77) = EXP(P(198))
	K(78) = EXP(P(199))
	K(79) = EXP(P(200))
	DATA((D(II,JJ),JJ=1,6),II=201,210)/
     X0.36798, 0.0,0.0,0.0,-4630.73,0.0,
     X-1.4967E0,5.456E-3,0.0,0.0,0.0,0.0,
     X-1.1668,0.0,0.0,0.0,-7759.3,0.0,
     X9.053594E1,-7.215505E-1,2.112659E-3,-2.254724E-6,0.0,0.0,
     X-5.773862E-1,3.94084E-3,-6.80E-6,0.0,0.0,0.0,
     X-1.065548E0,6.957931E-3,-1.142531E-5,0.0,0.0,0.0,
     X1.004759E2,-7.127881E-1,1.262349E-3,0.0,0.0,0.0,
     X-11.34482,4.197429E-2,0.0,0.0,0.0,0.0,
     X-4.715997E0,3.156712E-2,-5.304224E-5,0.0,0.0,0.0,
     X-7.707985E-2,2.482609E-4,0.0,0.0,0.0,0.0/
     	DATA((D(II,JJ),JJ=1,6),II=211,223)/
     X-4.091076E2,2.838782E0,-4.902359E-3,0.0,0.0,0.0,
     X1.175741E0,-2.374627E-3,0.0,0.0,0.0,0.0,
     X3.075223E0,-2.094837E-2,3.566667E-5,0.0,0.0,0.0,
     X-4.525314E-2,7.995736E-5,0.0,0.0,0.0,0.0,
     X-7.656214E-1,2.4871E-3,0.0,0.0,0.0,0.0,
     X-2.222887E-1,1.0313E-3,-1.0E-6,0.0,0.0,0.0,
     X1.306284E2,-8.44064E-1,1.356205E-3,0.0,0.0,0.0,
     X1.419947E2,-1.11958E0,2.16824E-3,0.0,0.0,0.0,
     X-2.9392E-1,9.60E-4,0.0,0.0,0.0,0.0,
     X-3.481452E-2,1.285714E-4,0.0,0.0,0.0,0.0,
     X-6.494E-1,2.00E-3,0.0,0.0,0.0,0.0,
     X-9.011042E-1,2.944255E-3,0.0,0.0,0.0,0.0,
     X-2.089075E0,1.399737E-2,-2.360221E-5,0.0,0.0,0.0/

	DO 800 J = 201,223
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3+D(J,5)
     x		/T+D(J,6)*LOG(T)
800	CONTINUE
	K(56)=EXP(P(201))
	PSI(2,5,12) = P(202)
	K(6) = EXP(P(203))
	K(28) = EXP(P(204))/1.01325
	IF (TEMP.GE.273.15) THEN
	    	 K(28)=EXP(4.419919E1-2.140260E-1*T+2.594636E-4*T**2)
	END IF
	PSI(11,17,1) = P(205)
	PSI(11,17,2) = P(206)
	BET1(2,16) = P(207)
	PSI(12,17,2) = P(209)
	PSI(1,5,17) = P(210)
	
	BET1(4,16) = P(211)
	BET0(4,16) = P(212)
	CPHI(4,16) = P(213)
	PSI(4,5,16) = P(214)
	PSI(12,16,4) = P(215)
	PSI(12,17,1) = P(216)
	K(80) = EXP(P(217))
	K(73) = EXP(P(218))
	PSI(12,17,4) = P(219)
	PSI(1,3,17) = P(220)
	PSI(2,4,17) = P(221)
	PSI(2,3,17) = P(222)
	PSI(2,5,17) = P(223)
	
	CPHI(2,16) = 0.00
	BET0(2,16) = -0.0003
	PSI(12,16,2) = -0.0677
	PSI(1,5,12) = 0.00
	THETA(12,16) = 0.00
	PSI(11,16,5) = 0.013
	PSI(11,16,1) = -0.006
	THETA(11,16) = -0.006
	PSI(1,5,16)=-0.0129
	PSI(12,16,1)=-0.0094
	IF(T.LT.273.15) THEN
		BET1(4,16) = 0.5361 
		BET0(4,16) = 0.5315
		CPHI(4,16) = 0.0143
		PSI(4,5,16) = -0.0234
		PSI(12,16,4) = -0.0884
	END IF
	PSI(3,5,12) = 0.0
	PSI(3,5,16) = 0.0
	PSI(12,16,3) = 0.0
	CPHI(3,16) = 0.0
	BET0(3,16) = 0.0619
	BET1(3,16) = 2.602
	IF(T.LT.273.15)THEN
		BET1(2,16) = -0.0371
		PSI(2,5,12) = -0.0064
	ENDIF
	PSI(2,5,16) = -0.0303
	PSI(12,17,3) = -0.2281
	PSI(14,17,1) = 0.0061
	PSI(15,17,1) = 0.0132
	PSI(15,17,2) = 0.0075
	
	DATA((D(II,JJ),JJ=1,6),II=231,233)/
     X1.470571E1,-2.293478E-1,1.350491E-3,-3.537708E-6,3.466102E-9,0.0,
     X-3.447035E1,5.312162E-1,-3.119749E-3,8.181394E-6,-8.022815E-9,0.0,
     X5.161188E1,-8.245243E-1,4.902233E-3,-1.280795E-5,1.252258E-8,0.0/
        DO 810 J=231,233
		P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3
     X+D(J,5)*T**4
810	CONTINUE
	CPHI(1,12) = P(231)
	BET0(1,12) = P(232)
	BET1(1,12) = P(233)
	
	
C  PARAMETERS FOR IRON CHEMISTRY

	DATA((D(II,JJ),JJ=1,6),II=251,260)/
     X0.3359,0.0,0.0,0.0,0.0,0.0,
     X38.3836,-0.1236,0.0,0.0,0.0,0.0,
     X-0.00861,0.0,0.0,0.0,0.0,0.0,
     X12.9506,-3.86E-2,0.391E-4,0.0,-1389.64,0.0,
     X8.758343E1,-6.383194E-1,1.190408E-3,0.0,0.0,0.0,
     X-42.0,0.0,0.0,0.0,0.0,0.0,
     X0.0209,0.0,0.0,0.0,0.0,0.0,
     X2.096187E1,-2.343349E-1,4.928070E-4,0.0,0.0,0.0,
     X-3.607762E2,4.61798E0,-1.886403E-2,2.525105E-5,0.0,0.0,
     X-4.594879E0,1.45731E-1,-3.461353E-4,0.0,0.0,0.0/
     
	DO 820 J = 251,260
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3+D(J,5)
     x		/T+D(J,6)*LOG(T)
820	CONTINUE

	BET0(7,11) = P(251)
	BET1(7,11) = P(252)
	CPHI(7,11) = P(253)
	BET0(7,12) = P(254)
	BET1(7,12) = P(255)
	BET2(7,12) = P(256)
	CPHI(7,12) = P(257)
	K(81) = EXP(P(258))
	K(83) = EXP(P(259))
	K(84) = EXP(P(260))
	IF(T.LT.263.15) K(84) = 999999
	IF(T.GT.223.15) K(71) = 999.9


C IRON PARAMETERS

	BET0(9,11) = 0.34082 + 7.2519E-3*(298.15-T)
	BET1(9,11) = 1.6285 - 0.62455*(298.15-T)
	BET2(9,11) = 1.7199
	CPHI(9,11) = -0.014 - 1.12482E-3*(298.15-T)

	

	K(89)=EXP(-7.716939E1+2.944561E-1*T-7.676424E-5*T**2)
	K(90) = EXP(9.715823E1-9.428088E-1*T+2.143448E-3*T**2)
	THETA(7,9) = -0.05
	PSI(7,9,11) = 0.012
	THETA(1,9) = 2.183566e1-1.378504e-1*T+2.182622e-4*T**2
	PSI(1,9,11) = -3.685900e0+2.498632e-2*T-4.255333e-5*T**2
	THETA(2,9) = -0.07
	PSI(2,9,11) = 2.751573E-1-9.528E-4*T
	K(91) = EXP(-9.315575E1+3.499720E-1*T)
	THETA(5,9) = -0.024
	PSI(5,9,11) = 2.770491E-1-9.644444E-4*T
	
	BET0(9,12) = 0.56622 + 1.60E-3*(298.15-T)
	BET1(9,12) = 12.16131 - 0.1751*(298.15 -T)
	BET2(9,12) = 3.07519
	CPHI(9,12) = 0.000524 - 0.20E-4*(298.15-T)
	PSI(7,9,12) = -0.0372
	
	K(92) = EXP(-101.0657+29165.9/T)
     	PSI(2,9,12) = -0.03
	K(93) = EXP(-31.8903)
	K(94) = EXP(-3.644195E1+8.970862E-2*T)
	K(95) = EXP(-6.7220)
	
	K(156) = EXP(0.853-14396.5/T)
	K(157) = EXP(-20.238-15248.0/T)
	K(158) = EXP(12.205-5231.8/T)
	K(159) = EXP(15.827-8611.5/T)
	K(160) = EXP(12.940-12508.3/T)
	K(161) = EXP(3.915-15996.1/T)
	
	BET0(9,16) = 14.161-0.0496*T
	BET1(9,16) = -131.6+0.41*T
	BET2(9,16) = 10.9
	CPHI(9,16) = -2.020+0.008*T
	PSI(5,9,12) = 0.009
	PSI(5,9,16) = 0.0
	PSI(12,16,9) = 0.0
	
	K(96) = EXP(-48.3104+12772.9/T)
	K(97) = EXP(-65.6395+19123.2/T)
	
	
	THETA(3,9) = -0.05
	THETA(4,9) = -0.05
	PSI(1,9,12) = -0.03
	PSI(3,9,12) = 0.030
	PSI(4,9,12) = -0.024
	PSI(3,9,11) = 0.012
	PSI(4,9,11) = 0.012
	K(98) = EXP(-69.4643+12700.7/T)
	K(99) = EXP(-70.3921+16838.0/T)
	K(100) = EXP(-105.6084+27337.8/T)
	K(101) = EXP(-52.7235+15755.6/T)
	K(102) = EXP(-24.5667+7456.8/T)
	K(103) = EXP(-24.7280+8671.6/T)
	K(104) = EXP(-26.8609+8805.4/T)
	K(105) = EXP(-6.4360+9.68E-3*T)


	K(106) = EXP(-59.9039+16369.0/T)
	
	K(107) = EXP(-138.8076+25269.1/T)
C	K(108) = EXP(-145.7056+27169.4/T)
	AK108=-145.7056+27169.4/T
	K(108) = EXP(AK108/2)
	K(108) = K(108)**2
	
	K(109) = EXP(-35.9423-637.4/T)
	K(110) = EXP(-67.1649+11943.0/T)
	AK111 = -232.6369+42732.5/T
	K(111) = EXP(AK111/2)
	K(111) = K(111)**2
C	K(111) = EXP(-232.6369+42732.5/T)

	BV0(9,11) = 0.0
	BV1(9,11) = 0.0107271-3.40E-5*T
	CV(9,11) = 0.0
	BV0(9,12) = 0.0
	BV1(9,12) = -4.625e-2+1.805063E-4*T
	CV(9,12) = 0.0

C  AL VOLUMETRICS BELOW ARE SET EQUAL TO FE(III) ABOVE	
	BV0(10,11) = 0.0
	BV1(10,11) = 0.0107271-3.40E-5*T
	CV(10,11) = 0.0
	BV0(10,12) = 1.316e-4
	BV1(10,12) = 8.080e-2-2.71e-4*T
	CV(10,12) = 0.0
	
	

C  THE FOLLOWING IRON PARAMETERS ARE EQUAL TO MG ANALOGUES	
        DATA((D(II,JJ),JJ=1,6),II=261,271)/
     X13697.10,8.250840,-0.00434,0.0,-273406.1716,-2607.115202,
     X-157839.8351,-92.7779354,0.0477642,0.0,3203209.6948,29927.151503,
     X	-3.109870D-2, 5.4464780D-5, 0, 0, 1.99404210, 0,
     X	-0.1207E0,0.5235E-3,-0.539E-6,-0.439E-9,-0.1723E2,0.12645E-1,
     X	5.0362230D-2, -8.750820D-6, 0, 0, -2.899090D1, 0,
     X	-0.118e0,-0.478e-4,-0.327e-6,-0.937e-9,0.3344e2,-0.884e-2,
     X	5.31274136, -6.3424248D-3, 0, 0, -9.83113847D2, 0,
     X	4.15790220D1, 1.30377312D-2, 0,0, -9.81658526D2, -7.4061986,
     X-479.362533,-0.541843,0.00038812,0.0,3589.474052,104.3452732,
     X-1342.60256,-0.772286,0.000391603,0.0,27726.80974,253.62319406,
     X-7374.24392,-4.608331,0.002489207,0.0,143162.6076,1412.302898/
     
	DATA((D(II,JJ),JJ=1,6),II=272,276)/
     X0.393,0.0,0.0,0.0,-6639.0,0.0,
     X-14.6641,0.0,0.0,0.0,1365.17,0.0,
     X0.5869E-1,-0.897E-4,0.47E-7,0.65E-10,-0.2413E2,0.4345E-2,
     X0.5207,-0.51525E-3,0.0,0.0,0.0,0.0,
     X2.9242,-4.4925E-3,0.0,0.0,0.0,0.0/


       
	DO 830 J = 261,276
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3+D(J,5)
     x		/T+D(J,6)*LOG(T)
830	CONTINUE
	CPHI(7,14) = 0.0
	BET0(7,14) = P(261)
	BET1(7,14) = P(262)
	THETA(1,7) = 0.08
	PSI(1,7,11) = -0.014
	PSI(1,7,12) = P(264)
	THETA(2,7) = 0.1167
	PSI(2,7,11) = P(265)
	PSI(2,7,12) = P(266)
	THETA(3,7) = P(267)
	PSI(3,7,11) = P(268)
	PSI(3,7,12) = 0.024
	THETA(4,7) = 0.0
	PSI(4,7,11) = 0.0
	PSI(4,7,12) = 0.0
	LAM(7,21)= P(269)
	XI(7,11,21) = P(270)
	XI(7,16,21) = XI(7,11,21)
	XI(7,17,21) = XI(7,11,21)
	XI(7,18,21) = XI(7,11,21)
	XI(7,19,21) = XI(7,11,21)
	XI(7,12,21) = P(271)
	
	CPHI(8,11) = 0.0
	BET0(8,11) = -0.10
	BET1(8,11) = 1.658
	PSI(7,8,11) = 0.028
	K(8) = EXP(P(272))
	K(22) = EXP(P(273))
	PSI(5,7,12) = 0.00
	PSI(11,12,7) = P(274)
	CPHI(7,17) = -0.02062
	BET0(7,17) = P(275)
	BET1(7,17) = P(276)

	DATA((D(II,JJ),JJ=1,6),II=280,289)/
     X6.758464E1,-7.649696E-1,2.894494E-3,-3.636364E-6,0.0,0.0,
     X5.75716E1,-5.7767E-1,1.924796E-3,-2.129138E-6,0.0,0.0,
     X6.324332,-2.7915E-2,0.0,0.0,0.0,0.0,
     X-29.654,0.0,0.0,0.0,1248.45,0.0,
     X-0.14157,5.15E-4,0.0,0.0,0.0,0.0,
     X5.207E-1,-5.1525E-4,0.0,0.0,0.0,0.0,
     X2.9242E0,-4.4925E-3,0.0,0.0,0.0,0.0,
     X-24.4859,0.0,0.0,0.0,9645.8,0.0,
     X-2.676925E1,1.147623E-1,-3.016638E-5,0.0,0.0,0.0,
     X1.649717E2,-1.214645E0,2.284327E-3,0.0,0.0,0.0/


       
	DO 840 J = 280,289
	    P(J)=D(J,1)+D(J,2)*T+D(J,3)*T**2+D(J,4)*T**3+D(J,5)
     x		/T+D(J,6)*LOG(T)
840	CONTINUE

	BET0(7,16) = P(280)
	BET1(7,16) = 3.48
	PSI(5,7,16) = P(281)
	CPHI(7,16) = 0.0
	THETA(5,7) = 0.0
	PSI(5,7,12) = 0.0
	PSI(12,16,7) = 0.0
	K(82) = EXP(P(282))
	K(85) = EXP(P(283))
	PSI(11,14,7) =-0.096
	PSI(12,14,7) = -0.161
	PSI(1,7,14) = 0.0
	PSI(2,7,14) = 0.0
	PSI(3,7,14) = 0.0
	PSI(4,7,14) = 0.0
	PSI(5,7,11) = P(284)
	CPHI(7,17) = -2.062E-2
	BET0(7,17) = P(285)
	BET1(7,17) = P(286)
	K(86) = EXP(P(287))
	K(87)=EXP(P(288))
	K(88)=EXP(P(289))
	IF(T.LE.285.0)K(88)=EXP(-2.224001E1+9.319961E-2*T)
	
	
	
C  THESE ARE PARAMETERS FOR AL, BR, AND SI (FC VERSION 12)

	K(162) = EXP(7.8904-5785.1/T)
	K(163) = EXP(22.3278-13590.70/T)
	K(164) = EXP(28.6813-20085.4/T)
	K(165) = EXP(26.9466-23621.4/T)
	K(166) = EXP(-12.2631-3079.0/T)
	BET0(10,11) = 0.71532
	BET1(10,11) = 5.65087-0.35857*(298.15-T)
	CPHI(10,11) = -0.00418
	K(112) = EXP(-1.084571E2+6.751493E-1*T-8.626394E-4*T**2)
	BET0(10,12) = 0.56622 + 1.60E-3*(298.15-T)
	BET1(10,12) = 12.16131 - 0.1751*(298.15 -T)
	BET2(10,12) = 3.07519
	CPHI(10,12) = 0.000524 - 0.20E-4*(298.15-T)
	K(113) = EXP(-5.343939E1+2.916448E-1*T-5.359448E-4*T**2)
	K(116) = EXP(-24.1754+12659.8/T)
	K(117) = EXP(0.9682-3018.8/T)
	K(118) = EXP(-0.6051-1683.8/T)
	K(119) = EXP(-92.3367+27770.7/T)
	K(120) = EXP(-96.4231+30901.4/T)
	THETA(4,10) = 0.00
	PSI(4,10,11) = -0.0114
	PSI(4,10,12) = 0.0135
	THETA(2,10) = 4.19552067E-1
	PSI(2,10,11) = 2.98247471E1+1.09536809E-2*T-6.67124867E2/T
     X-5.43572997*LOG(T)
	THETA(5,10) = 0.179086398
	PSI(5,10,11) = -1.26910509+2.17181206e-3*T+1.83332699E2/T
	THETA(9,10) = 0.00
	PSI(9,10,11) = -4.4685E-1+1.756E-3*T
	PSI(2,10,12) = 0.293079-2.768E-3*T
	K(121) = EXP(-3.98684E1+8.6936E-2*T)
	THETA(1,10) = 0.335
	PSI(1,10,11) = -1.10588543E0+1.71362150E-3*T+1.57980032E2/T
	PSI(1,10,12) = 1.87172E-1-9.88E-4*T
	K(122) = EXP(-1.75130E1+2.59544E-2*T)
	
	
	PSI(9,10,12) = 24.9193-0.08396*T
	
	THETA(7,10) = 0.000
	PSI(7,10,12) = -0.0019
	K(123) = EXP(-19.7061)
	PSI(5,10,12) = -0.0472
	PSI(5,10,16) = 0.000
	PSI(12,16,10) = 0.000
	BET0(10,16) = 1.025
	BET1(10,16) = 5.426
	BET2(10,16) = 10.9
	CPHI(10,16) = -0.0486
	K(124) = EXP(-52.5218 + 19676.4/T)
	K(125) = EXP(-18.4542)
	

	THETA(3,10) = THETA(4,10)
	PSI(3,10,11) = PSI(4,10,11)
	PSI(3,10,12) = PSI(4,10,12)
	PSI(7,10,11) = 1.2E-2
	PSI(7,10,16) = 0.0
	PSI(9,10,16) = 0.0

	

	
	
C  BROMINE PARAMETERS ARE FROM MILLERO AND PIERROT 1998

	BET0(1,18)=0.0973-(1.3E-5/3)*(298.15**3-298.15**2*7.692E-4)*
     X(1/T-1/298.15)-(1.3E-5/6)*(T**2-298.15**2)
     	BET1(1,18)=0.2791-(1.06E-5/3)*(298.15**3-298.15**2*10.79E-4)*
     X(1/T-1/298.15)-(1.06E-5/6)*(T**2-298.15**2)
     	CPHI(1,18)=0.00116+(0.16405E-5/3)*(298.15**3-298.15**2
     X*(-0.93E-4))*(1/T-1/298.15)+(0.164055E-5/6)*(T**2-298.15**2)  
  	BET0(2,18)=0.0569-(1.43E-5/3)*(298.15**3-298.15**2*7.39E-4)*
     X(1/T-1/298.15)-(1.43E-5/6)*(T**2-298.15**2)
     	BET1(2,18)=0.2122-(0.762E-5/3)*(298.15**3-298.15**2*1.74E-4)*
     X(1/T-1/298.15)-(0.762E-5/6)*(T**2-298.15**2)
     	CPHI(2,18)=-0.0018+(0.216E-5/3)*(298.15**3-298.15**2
     X*(-0.7004E-4))*(1/T-1/298.15)+(0.216E-5/6)*(T**2-298.15**2)
     	BET0(3,18) = 0.3816-5.2275E-4*(T-298.15)
     	BET1(3,18) = 1.61325 +6.0375E-3*(T-298.15)
     	CPHI(3,18) = -0.002572
     	BET0(4,18) = 0.432675-5.62E-5*(T-298.15)
     	BET1(4,18) = 1.75275+3.8625E-3*(T-298.15)
     	CPHI(4,18) = 0.003124	
     	BET0(5,18)=0.196-(0.357E-5/3)*(298.15**3-298.15**2*(-2.049))*
     X(1/T-1/298.15)-(0.357E-5/6)*(T**2-298.15**2)
     	BET1(5,18)=0.3564-(0.913E-5/3)*(298.15**3-298.15**2*4.467)*
     X(1/T-1/298.15)-(0.913E-5/6)*(T**2-298.15**2)
     	CPHI(5,18)=0.00827+(0.01272E-5/3)*(298.15**3-298.15**2
     X*(-0.5685))*(1/T-1/298.15)+(0.01272E-5/6)*(T**2-298.15**2)

C  ANALOGUE CASES     
       BET0(7,18) = BET0(3,18)
       BET1(7,18) = BET1(3,18)
       CPHI(7,18) = CPHI(3,18)
       BET0(9,18) = BET0(9,11)
       BET1(9,18) = BET1(9,11)
       BET2(9,18) = BET2(9,11)
       CPHI(9,18) = CPHI(9,11)
       BET0(10,18) = BET0(10,11)
       BET1(10,18) = BET1(10,11)
       CPHI(10,18) = CPHI(10,11)
       
       THETA(12,18) = THETA(11,12)
       PSI(12,18,1) = PSI(11,12,1)
       PSI(12,18,2) = PSI(11,12,2)
       PSI(12,18,3) = PSI(11,12,3)
       PSI(12,18,4) = PSI(11,12,4)
       PSI(12,18,5) = PSI(11,12,5)
       PSI(12,18,7) = PSI(11,12,7)
       PSI(3,5,18) = PSI(4,5,18)
       
       PSI(1,3,18) = PSI(1,3,11)
       PSI(1,4,18) = PSI(1,4,11)
       PSI(1,7,18) = PSI(1,7,11)
       PSI(1,9,18) = PSI(1,9,11)
       PSI(1,10,18) = PSI(1,10,11)
       PSI(2,3,18) = PSI(2,3,11)
       PSI(2,4,18) = PSI(2,4,11)
       PSI(2,7,18) = PSI(2,7,11)
       PSI(2,9,18) = PSI(2,9,11)
       PSI(2,10,18) = PSI(2,10,11)
       PSI(3,4,18) = PSI(3,4,11)
       PSI(3,7,18) = PSI(3,7,11)
       PSI(3,9,18) = PSI(3,9,11)
       PSI(3,10,18) = PSI(3,10,11)
       PSI(4,7,18) = PSI(4,7,11)
       PSI(4,9,18) = PSI(4,9,11)
       PSI(4,10,18) = PSI(4,10,11)
       PSI(5,7,18) = PSI(5,7,11)
       PSI(5,9,18) = PSI(5,9,11)
       PSI(5,10,18) = PSI(5,10,11)
       PSI(7,9,18) = PSI(7,9,11)
       PSI(7,10,18) = PSI(7,10,11)
       PSI(9,10,18) = PSI(9,10,11)

       

C  MILLERO AND PIERROT, 1998       
       THETA(13,18) = -0.065
       PSI(1,2,18) = -0.0022
       PSI(1,5,18) = -0.012
       PSI(2,5,18) = -0.021
       PSI(4,5,18) = -0.005
       PSI(13,18,1) = -0.018
       PSI(13,18,2) = -0.014

C  PITZER 1991       
       THETA(11,18) = 0.0
       PSI(11,18,1) = 0.0
       PSI(11,18,2) = 0.0
       
 
C VOL. PARAMETERS ARE FROM KRUMGALZ ET AL. 2000 
      
       DT = T-298.15
       IF(T.LT.273.15)DT = -25.0
       BV0(1,18)=0.7607E-5-2.0616E-7*DT+23.746E-9*DT**2-6.4078E-10*DT**3
       BV0(2,18)=1.0660E-5-3.9576E-7*DT+5.7835E-9*DT**2
       BV0(4,18)=-0.0468E-5+3.9927E-7*DT+10.053E-9*DT**2-
     X5.1034E-10*DT**3+0.4181E-11*DT**4
       BV0(3,18)=2.1496E-5-4.9548E-7*DT+19.443E-9*DT**2-0.2602E-10*DT**3
     X-0.6271E-11*DT**4+0.5196E-13*DT**5
       BV1(1,18)=0.9525E-5-1.4858E-6*DT-0.8325E-7*DT**2+0.2693E-8*DT**3
       BV1(2,18)=0.8337E-5-0.4863E-6*DT+0.0491E-7*DT**2
       BV1(4,18)=14.569E-5-11.373E-6*DT-1.3685E-7*DT**2+0.7532E-8*DT**3-
     X0.6438E-10*DT**4
       BV1(3,18)=-5.2328E-5+0.5886E-6*DT-1.5986E-7*DT**2-0.0338E-8*DT**3
     X+0.6086E-10*DT**4-0.4538E-12*DT**5
       CV(1,18)=-0.3491E-6+0.9052E-8*DT-1.8543E-9*DT**2+0.5436E-10*DT**3
       CV(2,18)=-0.7017E-6+4.2347E-8*DT-0.5150E-9*DT**2
       CV(4,18)=1.0696E-6-4.7426E-8*DT-0.7402E-9*DT**2+0.4480E-10*DT**3-
     X0.0381E-11*DT**4
       CV(3,18)=-0.8976E-6+2.5635E-8*DT-1.2525E-9*DT**2-0.0417E-10*DT**3
     X+0.0603E-11*DT**4-0.0488E-13*DT**5  	
     
	
	
C These are lamda and xi parameters for O2 taken from 
C Clegg and Brimblecombe, 1990.

	DATA((D(II,JJ),JJ=1,6),II=290,305)/
     X-0.39548,0.141307E3,0.0,9.19882E-7,0.0,0.0,
     X-0.51698,0.199431E3,0.0,0.0,0.0,0.0,
     X-0.79489,0.305513E3,0.0,0.0,0.0,0.0,
     X0.2497,0.0,0.0,0.0,0.0,0.0,
     X0.0,0.0,0.0,0.0,0.0,0.0,
     X0.93318,-0.430552E3,0.498608E5,0.0,0.0,0.0,
     X-0.377E-1,0.0,0.0,0.0,0.0,0.0,
     X0.100706E1,-0.274085E3,0.0,0.0,0.0,0.0,
     X-0.2379,0.81450E2,0.0,0.0,0.0,0.0,
     X0.0854,0.0,0.0,0.0,0.0,0.0,
     X1.0258,-0.277074E3,0.0,0.0,0.0,0.0,
     X0.0,-2.739,0.0,0.0,0.0,0.0,
     X0.2342E-2,0.0,-0.83615E3,0.0,0.0,0.0,
     X0.298399,-5.59617E3,1.049668E6,0.0,0.0,0.0,
     X39.2869,-6.87562E4,0.0,0.0,0.0,0.0,
     X-7.9489E-1,3.05513E2,0.0,0.0,0.0,0.0/
     
	DO 850 J = 290,305
	    P(J)=D(J,1)+D(J,2)/T+D(J,3)/T**2+D(J,4)*T**2
850	CONTINUE

	LAM(1,152) = P(290)
	LAM(2,152) = P(291)
	LAM(4,152) = P(292)
	LAM(3,152) = P(293)
	LAM(11,152) = P(294)
	LAM(13,152) = P(295)
	LAM(16,152) = LAM(11,152)
	LAM(17,152) = P(296)
	LAM(18,152) = -0.0347
	LAM(19,152) = LAM(11,152)
	LAM(12,152) = P(297)
	LAM(5,152) = P(298)
	LAM(14,152) = P(299)
	LAM(15,152) = P(300)
	XI(1,11,152) = P(301)
	XI(1,16,152) = XI(1,11,152)
	XI(1,19,152) = XI(1,11,152)
	XI(2,13,152) = P(302)
	K(152) = EXP(P(303))/1.01325
	K(153) = EXP(P(304))
	K(153)= K(153)*1.01325**3
	XI(1,13,152) = -0.0125
	XI(1,17,152) = -0.0120
	XI(1,18,152) = -0.00909
	XI(1,12,152) = -0.0460
	XI(2,11,152) = -0.0211
	XI(2,16,152) = XI(2,11,152)
	XI(2,19,152) = XI(2,11,152)
	XI(2,17,152) = -0.0281
	XI(2,18,152) = -0.00541
	XI(2,12,152) = 0.000
	XI(4,11,152) = -0.00565
	XI(4,16,152) = XI(4,11,152)
	XI(4,17,152) = XI(4,11,152)
	XI(4,18,152) = XI(4,11,152)
	XI(4,19,152) = XI(4,11,152)
	XI(4,12,152) = 0.0
	XI(3,11,152) = -0.0169
	XI(3,16,152) = XI(3,11,152)
	XI(3,17,152) = XI(3,11,152)
	XI(3,18,152) = XI(3,11,152)
	XI(3,19,152) = XI(3,11,152)
	XI(3,17,152) = 0.0
	XI(5,11,152) = -0.0077
	XI(5,16,152) = XI(5,11,152)
	XI(5,17,152) = XI(5,11,152)
	XI(5,18,152) = XI(5,11,152)
	XI(5,19,152) = XI(5,11,152)
	XI(1,14,152) = 0.000
	XI(1,15,152) = -0.0181
	LAM(7,152) = P(305)
	XI(7,11,152) = -5.65E-3
	XI(7,16,152) = XI(7,11,152)
	XI(7,17,152) = XI(7,11,152)
	XI(7,18,152) = XI(7,11,152)
	XI(7,19,152) = XI(7,11,152)
	XI(7,12,152) = 0.0
	
C USING O2-AL (CLEGG AND B, 1990) AS ANALOGUES FOR GAS-FE3+
	LAM(9,21) = 0.3095
	LAM(9,152) = 0.3095
	LAM(9,155) = 0.3095
	XI(9,11,21) = -0.0196
	XI(9,16,21) = XI(9,11,21)
	XI(9,17,21) = XI(9,11,21)
	XI(9,18,21) = XI(9,11,21)
	XI(9,19,21) = XI(9,11,21)
	XI(9,11,152) = -0.0196
	XI(9,16,152) = XI(9,11,152)
	XI(9,17,152) = XI(9,11,152)
	XI(9,18,152) = XI(9,11,152)
	XI(9,19,152) = XI(9,11,152)
	XI(9,11,155) = -0.0196
	XI(9,16,155) = XI(9,11,155)
	XI(9,17,155) = XI(9,11,155)
	XI(9,18,155) = XI(9,11,155)
	XI(9,19,155) = XI(9,11,155)
	XI(9,12,21) = -0.0248
	XI(9,12,152) = -0.0248
	XI(9,12,155) = -0.0248
	
	LAM(10,21) = 0.3095
	LAM(10,152) = 0.3095
	LAM(10,155) = 0.3095
	XI(10,11,21) = -0.0196
	XI(10,16,21) = XI(10,11,21)
	XI(10,17,21) = XI(10,11,21)
	XI(10,18,21) = XI(10,11,21)
	XI(10,19,21) = XI(10,11,21)
	XI(10,11,152) = -0.0196
	XI(10,16,152) = XI(10,11,152)
	XI(10,17,152) = XI(10,11,152)
	XI(10,18,152) = XI(10,11,152)
	XI(10,19,152) = XI(10,11,152)
	XI(10,11,155) = -0.0196
	XI(10,16,155) = XI(10,11,155)
	XI(10,17,155) = XI(10,11,155)
	XI(10,18,155) = XI(10,11,155)
	XI(10,19,155) = XI(10,11,155)
	XI(10,12,21) = -0.0248
	XI(10,12,152) = -0.0248
	XI(10,12,155) = -0.0248


C  PERCHLORATE PARAMETERS
	BET0(1,19) = 0.0554 - 1.57E-3*(298.15-T)
	BET1(1,19) = 0.2755 + 5.59E-3*(298.15-T)
	CPHI(1,19) = -0.00118 + 1.35E-4*(298.15-T)
	BET0(2,19) = -0.160 -5.517e-4*(298.15-T)
	BET1(2,19) = 0.15 - 1.333E-2*(298.15-T)
	CPHI(2,19) = 0.00
	BET0(3,19) = 0.45113 - 6.8e-4*(298.15-T)
	BET1(3,19) = 1.7565 + 2.16e-2*(298.15-T)
	CPHI(3,19) = -0.005001 + 1.56e-4*(298.15-T)
	BET0(4,19) = 0.49613 - 1.996E-3*(298.15-T)
	BET1(4,19) = 2.0085 + 8.830E-2*(298.15-T)
	CPHI(4,19) = 0.009581 + 5.202E-4*(298.15-T)
	BET0(5,19) = 0.1747
	BET1(5,19) = 0.2931 -1.6E-3*(298.15-T)
	CPHI(5,19) = 0.00819 -1.1E-5*(298.15-T)

	K(126) = EXP(-2.575938E1+1.910375E-1*T-2.942941E-4*T**2)
	K(131) = EXP(-9.445939+4.950649E-2*T)
	
C	K(130) = EXP(2.133243E1-2.785519E-2*T)
	K(130) = 1E30
	K(127) = EXP(2.152861E1-3.469271E-2*T)
C	K(127) = 1E30
	
	K(128) = EXP(-1.786378E1+2.253556E-1*T-4.013223E-4*T**2)
	K(129) = EXP(-7.125203E0-6.100201E-2*T+2.337460E-4*T**2)
	PSI(1,2,19) = 0.0116
	PSI(1,4,19) = -0.0107
	PSI(1,3,19) = -0.0107
	PSI(2,4,19) = -0.0107
	PSI(2,3,19) = -0.0107
	PSI(3,4,19) = -0.0238
	PSI(1,5,19) = -0.016
	PSI(2,5,19) = -0.016
	PSI(4,5,19) = -0.0077
	PSI(3,5,19) = -0.0142
	THETA(11,19) = 0.0341
	PSI(11,19,1) = -0.0523
	PSI(11,19,2) = -0.0523
	PSI(11,19,4) = 0.0046
	PSI(11,19,3) = -0.0409
	PSI(11,19,5) = 0.00
	THETA(14,19) = 0.081
	THETA(15,19) = 0.071
	PSI(14,19,1) = -0.019
	PSI(14,19,2) = -0.019
	PSI(14,19,4) = -0.36
	PSI(14,19,3) = -0.36
	PSI(15,19,1) = -0.006
	PSI(15,19,2) = -0.006
	PSI(15,19,4) = 0.0
	PSI(15,19,3) = 0.0
	
C BELOW ARE SURROGATES FOR BISULFATE AND SULFATE	
	THETA(16,19) = 0.081
	THETA(12,19) = 0.071
	PSI(16,19,1) = -0.019
	PSI(16,19,2) = -0.019
	PSI(16,19,4) = -0.36
	PSI(16,19,3) = -0.36
	PSI(12,19,1) = -0.006
	PSI(12,19,2) = -0.006
	PSI(12,19,4) = 0.0
	PSI(12,19,3) = 0.0
	
C NEW SEAWATER EQUATIONS
	K(20) = EXP(148.0248-8966.901/T-24.4344*LOG(T))
	K(170) = EXP(-12.641+1590.2/T)
C MILLERO-PIERROT PARAMETERS FOR B(OH)4
	DT=T-298.15
	DDT=T-303.15
	BET0(1,20) = -0.051 + 5.26E-3*DT
	BET1(1,20) = 0.0961 - 1.068E-3*DT
	CPHI(1,20) = 0.01498 - 1.57E-3*DT
	BET0(2,20) = 0.1469 + 2.881E-3*DT
	BET1(2,20) = -0.0989 - 6.876E-3*DT
	CPHI(2,20) = -0.05643 - 9.56E-4*DT
	BET0(4,20) = 0.623 + 6.496E-3*DT
	BET1(4,20) = 0.2515 - 0.01713*DT
	BET2(4,20) = -11.47 -3.24E-3*DDT**2
	CPHI(4,20) = 0.0
	BET0(3,20) = -0.4462 + 5.393E-3*DT
	BET1(3,20) = -0.868 - 0.0182*DT
	BET2(3,20) = -15.88 -2.858E-3*DDT**2
	CPHI(3,20) = 0.0
	THETA(11,20) = -0.0323 - 0.42333E-4*DT -21.926E-6*DT**2
	PSI(11,20,1) = -0.0132
	PSI(11,20,2) = -0.0132
	PSI(11,20,4) = -0.235
	PSI(11,20,3) = -0.8
	THETA(12,20) = -0.012
	LAM(1,169) = -0.097
	LAM(2,169) = -0.14
	LAM(11,169) = 0.091
	LAM(12,169) = 0.018
	XI(1,12,169) = 0.046
	LAM(1,166) = -0.097
	LAM(2,166) = -0.14
	LAM(11,166) = 0.091
	LAM(12,166) = 0.018
	XI(1,12,166) = 0.046

	

C  These parameters are for pressure dependent reactions.

      DO 860 IJ=1,200
      	V0(IJ) = 0.00
	K0(IJ) = 0.00
860   CONTINUE


C  MOLAL VOLUMES FOR IONS(FROM MILLERO 1983)
	
	V0(1) = -90.589+0.52876*T-7.68E-4*T**2
	K0(1) = -3.0891E-2+1.36923E-4*T-1.56E-7*T**2
	V0(2) = -72.019+0.49128*T-7.36E-4*T**2
	K0(2) = -1.0616E-2+7.613E-6*T+5.6E-8*T**2
	V0(3) = -142.301+0.79195*T-1.256E-3*T**2
	K0(3) = 6.3299E-2-4.8948E-4*T + 8.44E-7*T**2
	V0(4) = -165.407+0.96088*T-1.60E-3*T**2
	K0(4) = 6.2899E-2-4.8948E-4*T+8.44E-7*T**2
	V0(5) = 0.00
	K0(5) = 0.00
	V0(6) = 0.00
	K0(6) = 0.00
	V0(7) = -165.407+0.96088*T-1.60E-3*T**2
	K0(7) = 6.2899E-2-4.8948E-4*T+8.44E-7*T**2
	V0(8) = 0.00
	K0(8) = 0.00
	V0(9) = -5.70-0.1016*T
	K0(9) = 1.409230E-1-1.012854E-3*T+1.678571E-6*T**2
	V0(10) = -2.376838E2+1.374949E0*T-2.40E-3*T**2
	K0(10) = 1.543122E-3-4.5880E-5*T
	V0(11) = -102.412+0.78012*T-1.264E-3*T**2
	K0(11) = -0.15576+1.0101E-3*T-1.644E-6*T**2
	V0(12) = -352.433+2.36431*T-3.808E-3*T**2
	K0(12) = -2.9963E-1+1.8935E-3*T-3.056E-6*T**2
	V0(13) = -334.884+2.16412*T-3.536E-3*T**2
	K0(13) = -1.2874E-1+7.6471E-4*T-1.160E-6*T**2
	V0(14) = -197.188+1.41308*T-2.248E-3*T**2
	K0(14) = -1.2763E-1+7.6471E-4*T-1.160E-6*T**2
	V0(15) = -393.904+2.52016*T-4.064E-3*T**2
	K0(15) = -3.0024E-1+1.8935E-3*T-3.056E-6*T**2
	V0(16) = -1.85898e2+1.41308e0*T-2.248E-3*T**2
	K0(16) = -1.2737E-1+7.6471E-4*T-1.160E-6*T**2
	V0(17) = -174.089+1.27266*T-1.984E-3*T**2
	K0(17) = -7.1475E-2+4.2295E-4*T-6.08E-7*T**2
	V0(18) = -7.445345E1+6.200964E-1*T-9.642857E-4*T**2
	K0(18) = -1.423493E-1+9.254071E-4*T-1.500E-6*T**2
	
	V0(19) = 44.09
	K0(19) = -5.75E-3
	
	V0(20) = -3.350021E2+2.241794*T-3.504762E-3*T**2
	K0(20) = -4.178533E-1+2.691231E-3*T-4.390476E-6*T**2
	
	V0(172) = 2.526790E1-3.277986E-1*T+6.142857E-4*T**2
	K0(172) = 6.275624E-2-4.969714E-4*T+8.571429E-7*T**2
	V0(170) = -1.916402E2+1.253633*T-2.061905E-3*T**2
	K0(170) = -1.265038E-1+7.549143E-4*T-1.142857E-6*T**2
	
	
	V0(21) = 33.6
	V0(152) = 32.0
	V0(155) = 37.4
	K0(21) = 0.0
	K0(152) = 0.0
	K0(155) = 0.0
	V0(166) = -3.346193e2+2.239093e0*T-3.50e-3*T**2
	K0(166) = -4.186190e-1+2.696634e-3*T-4.40e-6*T**2
	V0(169) = V0(166)
	K0(169) = K0(166)
	
	
	IF (T.GE.273.15) THEN
		RHO=0.001*(999.83952+16.94518*(T-273.15)-7.98704E-3
     X*(T-273.15)**2-4.617046E-5*(T-273.15)**3+1.05563E-7*(T-273.15)
     X**4-2.805425E-10*(T-273.15)**5)/(1.0+1.687985e-2*(T-273.15))
     		V0(30) = 18.01528/RHO
	ELSE
		V0(30)=18.0182-1.407964E-3*(T-273.15)+1.461418E-4
     X*(T-273.15)**2
	ENDIF

      PINT(1) = 1.01325
      PI=(PB-1.01325)/20.0
      DO 50 KAA =2,21
      		PINT(KAA) = PINT(KAA-1)+PI
50    CONTINUE
     
	YSUM = 0.0
		DO 75 KAA=1,21
		YAA(KAA) = 0.00862420-5.06616E-5*T-3.78615E-6*PINT(KAA)
     X+2.27679E-8*PINT(KAA)*T+1.18481E-10*PINT(KAA)**2+8.20762E-8*T**2
     X-3.63261E-11*PINT(KAA)*T**2-2.87099E-13*T*PINT(KAA)**2
	IF((KAA.EQ.1).OR.(KAA.EQ.21)) YAA(KAA)=YAA(KAA)/2.0
     	YSUM=YSUM+YAA(KAA)
75	CONTINUE

	AVERK30 = YSUM/20.0
	K0(30)=AVERK30


C  MOLAL VOLUMES FOR SOLIDS


	V0(31) = 1.930447E1-7.988471E-4*T+7.563261E-6*T**2
     	K0(31) = 2.790102E-2-2.235440E-4*T+4.497731E-7*T**2
     	IF(T.LT.250) K0(31) = 1.258E-4

	VH2O=V0(30)-AVERK30*(PB-1.01325)
	
	V0(32) = 57.96
	V0(33) = 27.02
	V0(34) = 37.52
	V0(35) = 128.12
	V0(36) = 129.57
	V0(37) = 159.08
	V0(38) = 218.10
	V0(39) = 172.58
	V0(40) = 311.81
	V0(41) = 219.80
	V0(42) = 53.33
	V0(43) = 132.58
	V0(44) = 146.71
	V0(45) = 65.50
	V0(46) = 191.78
	V0(47) = 149.98
	V0(48) = 74.69
	V0(49) = 45.94
	V0(50) = 207.44
	V0(51) = 246.24
	V0(52) = 36.93
	V0(53) = 28.02
	V0(54) = 74.79
	V0(55) = 100.80
	V0(56) = 117.54
	V0(57) = 38.91
	V0(58) = 198.71
	V0(59) = 107.02
	V0(60) = 169.13
	V0(61) = 64.34
	V0(62) = 153.71
	V0(63) = 46.14
	V0(64) = 34.15
	V0(65) = 37.72
	V0(66) = 73.09
	V0(67) = 48.04
	V0(68) = 37.60
	V0(69) = 62.51
	V0(70) = 154.86
	V0(71) = 113.98
	V0(72) = 101.06
	V0(73) = 119.57
	V0(74) = 0.00
	V0(75) = 65.65
	V0(76) = 0.0
	V0(77) = 0.0
	V0(78) = 0.0
	V0(79) = 58.64
	V0(80) = 56.60
	V0(81) = 146.48
	V0(82) = 57.21
	V0(83) = 133.65
	V0(84) = 103.01
	V0(85) = 30.49
	V0(86) = 28.12
	V0(87) = 135.75
	V0(88) = 135.75
	V0(89) = 207.59
	V0(90) = 146.90
	V0(91) = 138.84
	V0(92) = 129.12
	V0(93) = 406.95
	V0(94) = 184.01
	V0(95) = 162.23
	V0(96) = 267.63
	V0(97) = 295.61
	V0(98) = 162.07
	V0(99) = 156.86
	V0(100) = 178.05
	V0(101) = 30.48
	V0(102) = 20.76
	V0(103) = 22.21
	V0(104) = 24.90
	V0(105) = 99.10
	V0(106) = 228.10
	V0(107) = 595.21
	V0(108) = 594.71
	V0(109) = 507.02
	V0(110) = 373.96
	V0(111) = 762.15
	V0(112) = 144.57
	V0(113) = 379.19
	V0(116) = 33.33
	V0(117) = 22.93
	V0(118) = 22.93
	V0(119) = 151.17
	V0(120) = 144.77
	V0(121) = 269.54
	V0(122) = 264.90
	V0(123) = 483.91
	V0(124) = 99.29
	V0(125) = 471.90
	V0(126) = 69.53
	V0(127) = 189.43
	V0(128) = 156.47
	V0(129) = 54.98
	V0(130) = 167.32
	V0(131) = 85.00

C  PRESSURE-DEPENDENT BINARY PARAMETERS


	BV0(1,11) = 1.088468E-4-3.2412E-7*T
	BV1(1,11) = 6.193806E-3-4.135834E-5*T+6.911453E-8*T**2
	CV(1,11) = -5.174534E-6+1.514940E-8*T
	BV0(2,11) = 6.593033E-5-1.782E-7*T
	BV1(2,11) = 4.987530E-3-3.224932E-5*T+5.215803E-8*T**2
	CV(2,11) = -7.112E-7
	BV0(3,11) = 1.409126E-4-4.293E-7*T
	BV1(3,11) = 7.702445e-2-7.785779e-4*T
     X+2.612103E-6*T**2-2.909328E-9*T**3
	CV(3,11) = -6.723184E-6+2.216E-8*T
	BV0(4,11) = 6.446574E-4-4.168596E-6*T+6.920E-9*T**2
	BV1(4,11) = 1.624497E-3-5.618320E-6*T
	CV(4,11) = -5.567E-7
	BV0(1,12) = 5.589854E-4-1.698E-6*T
	BV1(1,12) = 3.323357E-2-2.218483E-4*T+3.717169E-7*T**2
	CV(1,12) = -6.561572E-5+2.106E-7*T
	BV0(2,12) = -3.303430E-3+1.1125E-5*T
	BV1(2,12) = 1.122179E-2-3.6788E-5*T
	CV(2,12) = 1.741518E-3-5.791E-6*T
	BV0(3,12) = 0.00
	BV1(3,12) = 0.00
	CV(3,12) = 0.00
	BV0(4,12) = 1.789039E-4-4.330E-7*T
	BV1(4,12) = 3.157137E-2-2.055400E-4*T+3.358883E-7*T**2
	BV2(4,12) = 9.096288E-2-2.570E-4*T
	CV(4,12) = 8.232980E-6-2.629E-8*T
	BV0(1,17) = 6.772663E-4-4.469461E-6*T+7.432663E-9*T**2
	BV1(1,17) = 6.112177E-3-3.714953E-5*T+5.670603E-8*T**2
	CV(1,17) = 0.00
	BV0(2,17) = 4.017245E-3-2.727479E-5*T+4.639794E-8*T**2
	BV1(2,17) = -9.970759E-3+7.222127E-5*T-1.295960E-7*T**2
	CV(2,17) = 0.00
	BV0(3,17) = 2.034795E-4-6.169134E-7*T
	BV1(3,17) = 2.100958E-3-7.119747E-6*T
	CV(3,17) = 0.00
	BV0(4,17) = 1.921787E-3-1.276510E-5*T+2.135779E-8*T**2
	BV1(4,17) = 2.306674E-3-8.051390E-6*T
	CV(4,17) = 0.00
	BV0(1,14) = 2.630581E-2-1.820515E-4*T+3.141869E-7*T**2
	BV1(1,14) = -9.485264E-2+6.639475E-4*T-1.157075E-6*T**2
	CV(1,14) = 1.374E-5
	BV0(1,15) = 2.567300E-4-6.597813E-7*T
	BV1(1,15) = 1.488352E-2-9.170975E-5*T+1.410818E-7*T**2
	CV(1,15) = -6.326112E-6+1.030E-8*T
	BV0(2,14) = -7.241E-5
	BV1(2,14) = 7.527977E-2-5.051817E-4*T+8.503591E-7*T**2
	CV(2,14) = 3.9791E-5
	BV0(2,15) = 1.061377E-4-2.348475E-7*T
	BV1(2,15) = 2.307677E-2-1.421728E-4*T+2.179648E-7*T**2
	CV(2,15) = -8.468E-7
	BV0(3,14) = 0.0
	BV1(3,14) = 0.0
	CV(3,14) = 0.0
	BV0(3,15) = 0.0
	BV1(3,15) = 0.0
	CV(3,15) = 0.0
	BV0(4,14) = 0.0
	BV1(4,14) = 0.0
	CV(4,14) = 0.0
	BV0(4,15) = 0.0
	BV1(4,15) = 0.0
	CV(4,15) = 0.0
	BV0(7,11) = 1.19712E-4-2.42E-7*T
	BV1(7,11) = -2.40397E-3+1.80E-6*T
	CV(7,11) = 0.00

C	THESE TWO PARAMETERS ARE VALID FROM 263 TO 298 K
	BV0(7,12) = 2.817577E-1-1.984763E-3*T+3.4943E-6*T**2
	BV1(7,12) = 7.258122-8.373751E-2*T+3.197795E-4*T**2
     X-4.045441E-7*T**3
     
	CV(7,12) = 0.00
	BV2(7,12) = 0.00
	BV0(7,17) = 1.05448E-3
	BV1(7,17) = -5.97153E-3
	CV(7,17) = 0.00
	BV0(5,11) = 1.710768E-4-1.080235E-6*T+1.693469E-9*T**2
	BV1(5,11) = 0.00
	CV(5,11) = -5.584006E-6+3.505464E-8*T-5.380952E-11*T**2
	BV0(5,17) = 2.908819E-4-1.909668E-6*T+3.163571E-9*T**2
	BV1(5,17) = 2.191849E-3-1.421625E-5*T+2.255071E-8*T**2
	CV(5,17) = 0.00
	BV0(5,16) = 9.447669E-4-6.127516E-6*T+9.939028E-9*T**2
	BV1(5,16) = -2.229583E-2+1.474382E-4*T-2.418969E-7*T**2
	CV(5,16) = 0.00
	BV0(5,12) = 5.374354E-4-3.519066E-6*T+5.951988E-9*T**2
	BV1(5,12) = 1.326979E-2-7.288212E-5*T+1.010339E-7*T**2
	CV(5,12) = 0.00
	BV0(1,16) = 7.848698E-3-5.199439E-5*T+8.721005E-8*T**2
	BV1(1,16) = -3.960782E-2+2.627059E-4*T
	CV(1,16) = 0.00
	BV0(2,16) = 1.199133E-2-7.845685E-5*T+1.287364E-7*T**2
	BV1(2,16) = -4.699762E-2+3.063952E-4*T-5.001161E-7*T**2
	CV(2,16) = 0.00
	
	BV0(1,19) = 0.6475e-5
	BV1(1,19) = 2.0790E-5
	CV(1,19) = -0.2230E-6
	BV0(2,19) = -0.7162E-5
	BV1(2,19) = -27.555E-5
	CV(2,19) = 0.00
	BV0(3,19) = 3.122E-5
	BV1(3,19) = 0.6368E-5
	CV(3,19) = -1.0443E-6
	BV0(4,19) = -0.7061E-5
	BV1(4,19) = 1.3878E-5
	CV(4,19) = 5.040E-6
	
C  SURROGATES FOR F, SR, B(OH)4
	BV0(1,170) = BV0(1,11)
	BV1(1,170) = BV1(1,11)
	CV(1,170) = CV(1,11)
	BV0(2,170) = BV0(2,11)
	BV1(2,170) = BV1(2,11)
	CV(2,170) = CV(2,11)
	BV0(3,170) = BV0(3,11)
	BV1(3,170) = BV1(3,11)
	CV(3,170) = CV(3,11)
	BV0(4,170) = BV0(4,11)
	BV1(4,170) = BV1(4,11)
	CV(4,170) = CV(4,11)
	BV0(5,170) = BV0(5,11)
	BV1(5,170) = BV1(5,11)
	CV(5,170) = CV(5,11)
	BV0(7,170) = BV0(7,11)
	BV1(7,170) = BV1(7,11)
	CV(7,170) = CV(7,11)
	BV0(172,11) = BV0(3,11)
	BV1(172,11) = BV1(3,11)
	CV(172,11) = CV(3,11)
	BV0(172,17) = BV0(3,17)
	BV1(172,17) = BV1(3,17)
	CV(172,17) = CV(3,17)
	BV0(172,19) = BV0(3,19)
	BV1(172,19) = BV1(3,19)
	CV(172,19) = CV(3,19)
	BV0(1,20) = BV0(1,19)
	BV1(1,20) = BV1(1,19)
	CV(1,20) = CV(1,19)
	BV0(2,20) = BV0(2,19)
	BV1(2,20) = BV1(2,19)
	CV(2,20) = CV(2,19)
	BV0(3,20) = BV0(3,19)
	BV1(3,20) = BV1(3,19)
	CV(3,20) = CV(3,19)
	BV0(4,20) = BV0(4,19)
	BV1(4,20) = BV1(4,19)
	CV(4,20) = CV(4,19)

	
	DO 865 J=1,200
		WT(J) = 0.0
865	CONTINUE

	WT(1) = 22.99
	WT(2) = 39.10
	WT(3) = 40.08
	WT(4) = 24.31
	WT(5) = 1.008
	WT(6) = 41.32
	WT(7) = 55.85
	WT(8) = 72.85
	WT(9) = 55.85
	WT(10) = 26.97
	WT(11) = 35.45
	WT(12) = 96.06
	WT(13) = 17.007
	WT(14) = 61.02
	WT(15) = 60.01
	WT(16) = 97.07
	WT(17) = 62.00
	WT(18) = 79.909
	WT(19) = 99.45
	WT(20) = 78.839
	WT(21) = 44.011
	WT(22) = 115.86
	WT(24) = 100.09
	WT(25) = 84.32
	WT(152) = 31.999
	WT(155) = 16.043
	WT(156) = 89.86
	WT(157) = 106.87
	WT(158) = 72.85
	WT(159) = 89.86
	WT(160) = 106.87
	WT(161) = 123.88
	WT(162) = 43.97
	WT(163) = 60.98
	WT(164) = 77.99
	WT(165) = 95.00
	WT(166) = 96.11
	WT(167) = 79.11
	WT(168) = 0.00
	WT(169) = 61.832
	WT(170) = 18.9984
	WT(171) = 20.006
	WT(172) = 87.62
	
	
C
C	TEMPERATURE-PRESSURE DEPENDENT EQUATION FOR Av (derived from
C	tabular data of Ananthaswamy and Atkinson, 1984)
C
	AV = 3.73387-2.89662E-2*T+1.29461E-3*PB-5.62291E-6*T*PB
     X+7.62143E-5*T**2+4.09944E-8*PB**2
        IF(T.LE.236.15) AV=1.14


	
C NEW PARAMETERS FOR GAS HYDRATE CHEMISTRY

	PAR=4.30210345E1-6.83277221E-2*T-5.6871873E3/T+3.56636281E-5
     X*T**2-5.79133791E1/(680-T)+6.11616662E-3*PB-7.85528103E-4
     X*PB*LOG(T)
     X-9.42540759E-2*PB/T+1.92132040E-2*PB/(680-T)-9.17186899E-6*PB**2/T
	K(155)=EXP(-PAR)
	LAM(1,155)=9.92230792E-2+2.57906811E-5*T+1.83451402E-2*PB/T
     X-8.07196716E-6*PB**2/T
     	LAM(3,155)=-5.64278808E0+8.51392725E-3*T+1.00057752E3/T
     X+5.27816886E-5*PB
     	XI(1,11,155)=-6.23943799E-3
     	XI(1,16,155) = XI(1,11,155)
     	XI(1,17,155) = XI(1,11,155)
     	XI(1,18,155) = XI(1,11,155)
     	XI(1,19,155) = XI(1,11,155)
	LAM(11,155)=0.00
	LAM(16,155) = LAM(11,155)
	LAM(17,155) = LAM(11,155)
	LAM(18,155) = LAM(11,155)
	LAM(19,155) = LAM(11,155)
	LAM(2,155)=0.13909
	LAM(4,155)=0.24678
	LAM(12,155)=0.03041
	LAM(15,155)=0.16596
	LAM(14,155)=0.00669
	XI(2,11,155)=-0.00382
	XI(2,16,155) = XI(2,11,155)
	XI(2,17,155) = XI(2,11,155)
	XI(2,18,155) = XI(2,11,155)
	XI(2,19,155) = XI(2,11,155)
	XI(3,11,155)=-0.00468
	XI(3,16,155) = XI(3,11,155)
	XI(3,17,155) = XI(3,11,155)
	XI(3,18,155) = XI(3,11,155)
	XI(3,19,155) = XI(3,11,155)
	XI(4,11,155)=-0.01323
	XI(4,16,155) = XI(4,11,155)
	XI(4,17,155) = XI(4,11,155)
	XI(4,18,155) = XI(4,11,155)
	XI(4,19,155) = XI(4,11,155)
	

	IF ((X(87).EQ.TCAR).AND.(X(87).GT.0.0))THEN
		KV(87) = 999.9
		K(87) = 999.9
	END IF
	IF ((X(88).EQ.TMET).AND.(X(88).GT.0.0))THEN
		KV(88) = 999.9
		K(88) = 999.9
	END IF
	
	
C THESE PARAMETERS ARE FOR CALCULATING PRESSURE DENSITY 
C OF CHLORIDE AND SULFATE SALT SOLUTIONS
	DO 900 II = 1,10
		IJ=II+10
		AB1(II,IJ) = 0.0
		AB2(II,IJ) = 0.0
900	CONTINUE

		IF(X(1).LT.3.4)THEN
			AB1(1,11)=1.644134E-6-5.245763E-9*T
			AB2(1,11)=-5.658952E-8+1.896576E-10*T
		ELSE
			AB1(1,11) = 0.811E-7
			AB2(1,11) = 0.241E-9
		END IF
		AB1(2,11) = 0.878E-7
		AB2(2,11) = -0.1969E-8
		AB1(3,11) = 0.1447E-6
		AB2(3,11) = 0.518E-9
		AB1(4,11) = 0.1568E-6
		AB2(4,11) = 0.1062E-8
		AB1(1,12)=5.585892e-6-1.757200e-8*T
		AB2(1,12) = -5.890012E-7+1.784240E-9*T
		AB1(4,12) = 0.3315E-6
		AB2(4,12) = 0.657E-8
	
C  If you want to remove a mineral from the minerals database, then
C  assign Ksp an arbitrary high value.  For example, assigning K(52)
C  (calcite) a value of 1E20 (see below) would effectively remove 
C  calcite from the database and allow other less stable minerals 
C  such as aragonite or ikaite to precipitate.

C	K(52) = 1E20

C REMOVE THE COMMENTS FOR THESE FIVE CARBONATES IF YOU ARE RUNNING THE 
C CALCITE SUPERSATURATION (PSEUDO-HOMOGENEOUS NUCLEATION) OPTION.	
C	K(53) =1e20
C	K(60) = 1E20
C	K(61) = 1E20
C	K(64) = 1E20
C	K(65) = 1E20
C	K(33) = 1E20

	OPEN (10, FILE = 'SOLIDPHASE.TXT')

	READ(10,*)PHASEOUT
	IF (PHASEOUT.EQ.1) THEN
		DO IJK=31,131
			K(IJK)=1E20
		END DO
	END IF

	
	IF (PHASEOUT.EQ.0)READ(10,*)ANN
	IF (ANN.GT.0) THEN
		NN=ANN
		DO IJK=	1,NN
			READ(10,*)ANNA
			NNA=ANNA
			K(NNA) = 1E20
		END DO	
	END IF
	
	CLOSE(10)
	
C  THE NEXT LINES REMOVE MOST CARBONATES IF YOU SELECTED THE SUPERSATURATION 
C  OF CARBONATE MINERALS FOR THIS SEAWATER RUN. 
	
!IF(YESORNO.EQ.1)THEN martin bugfix, parameters are confused here
	IF(CARBSS.EQ.1)THEN
		K(53) = 1.0E30
		K(54) = 1.0E30
		K(55) = 1.0E30
		K(60) = 1.0E30
		K(61) = 1.0E30
		K(64) = 1.0E30
		K(65) = 1.0E30
	END IF


C TO EFFECTIVELY REMOVE ALL MINERALS FROM THE DATABASE AND CREATE A PURE 
C SOLUTION-PHASE MODEL, REMOVE THE NEXT 4 COMMENTS.  

C	DO 880 J=31,131
C		KV(J)=1.0E30
C		K(J)=1.0E30
C880	CONTINUE
	
	DO 870 J=1,200
		KV(J)=K(J)
870     CONTINUE

	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE PITZER
	
C  This subroutine calculates activity coefficients and the activity
C  of water using the Pitzer equations.
	
	REAL I,IX,LAM,H1,HPRI1
	CHARACTER*50 TITLE
	DOUBLE PRECISION AKI,AKII,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	DOUBLE PRECISION SUMB,VEXMIX,SM
	DIMENSION SUMCA(10), SUMCAT(10), SUMAN(10), SUMZ(10), 
     x	SUMAC(11:20), SUMAA(11:20), SUMCC(11:20), SUMK(11:20),
     x	BPHI(10,11:20), B(10,11:20), BPRIME(10,11:20),CTPHI(10,11:20),
     x	PHIPHI(20,20), PHIPRI(20,20), PHIIJ(20,20),CTPRI(10,11:20),
     X  SUMCATAN(10),SUMANCAT(11:20),BPRIMV(10,11:20),BV(10,11:20),
     X  VBAR(20),DELV(200),DELK(200),SUMMA(20),SUMMB(20),V00(20),
     X  BV1P(10,11:20),CVP(10,11:20),BP(10,11:20),
     X	BPHIV(10,11:20),BPHIP(10,11:20),CPP(10,11:20)
	
   	COMMON /A/ MAXCAT,MAXAN,AKI(0:20),AKII(0:20),BET0(200,200),
     XBET1(200,200),BET2(200,200),C(200,200),CPHI(200,200),
     XPSI(200,200,200),THETA(200,200),A,Z(30),LAM(200,200),
     XXI(200,200,200),BV0(200,200),BV1(200,200),BV2(200,200),
     XCV(200,200),AV


	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
   
      COMMON /T/TITLE
      
      DATA BV1P/100*0/
      DATA CVP/100*0/
      DATA BP/100*0/
      DATA BPHIV/100*0/
      DATA BPHIP/100*0/
      DATA CPP/100*0/
      
	
	ZZ = 0
	SM = 0
	I = 0
	DO 280 J = 1, 25
		IF(J.EQ.23)GOTO 280
		ZZ = ZZ + X(J) * ABS(Z(J))
		I = I + .5 * (X(J) * Z(J)**2)
		SM = SM + X(J)
280	CONTINUE
	ZZ=ZZ+X(157)+2*X(158)+X(159)+X(161)
	ZZ=ZZ+2*X(162)+X(163)+X(165)+X(167)+X(170)+2*X(172)
	I=I+0.5*(X(157)+4*X(158)+X(159)+X(161)+4*X(162)+X(163)+X(165))
	I=I+0.5*X(167)+0.5*(X(170)+4*X(172))
	SM=SM+X(152)+X(155)+X(156)+X(157)+X(158)+X(159)+X(160)+X(161)
	SM=SM+X(162)+X(163)+X(164)+X(165)+X(166)+X(167)+X(169)
	SM=SM+X(170)+X(171)+X(172)
	
	DO 285 J=1,10
		SUMCA(J) = 0.0
		SUMCAT(J) = 0.0
		SUMAN(J) = 0.0
		SUMZ(J) = 0.0
		IJ = J+10
		SUMAC(IJ) = 0.0
		SUMAA(IJ) = 0.0
		SUMCC(IJ) = 0.0
		SUMK(IJ) = 0.0
285     CONTINUE
	DO 286 IJ=1,20
		SUMMA(IJ)=0.0
		SUMMB(IJ)=0.0
286	CONTINUE

C  USING CA AND CL AS SURROGATES FOR SR AND F
	X(3) = X(3) + X(172)
	X(11) = X(11) + X(170)
	
	
	ALPHA = 2.0*SQRT(I)
	ALPHA1 = 1.4 * SQRT(I)
	ALPHA2 = 12 * SQRT(I)
	ALPHA3 = 2.5*SQRT(I)
	G = 2*(1-(1+ALPHA)*EXP(-ALPHA))/ALPHA**2
	G1 = 2*(1-(1+ALPHA1)*EXP(-ALPHA1))/ALPHA1**2
	G2 = 2*(1-(1+ALPHA2)*EXP(-ALPHA2))/ALPHA2**2
	H1 = (6.0-(6.0+ALPHA3*(6.0+3.0*ALPHA3+ALPHA3**2))
     X*EXP(-ALPHA3))/ALPHA3**4
        HPRI1 = EXP(-ALPHA3)/2 - 2*H1
	GPRIME = -2*(1-(1+ALPHA+ALPHA**2/2)*EXP(-ALPHA))/ALPHA**2
	GPRI1 = -2*(1-(1+ALPHA1+ALPHA1**2/2)*EXP(-ALPHA1))/ALPHA1**2
	GPRI2 = -2*(1-(1+ALPHA2+ALPHA2**2/2)*EXP(-ALPHA2))/ALPHA2**2
	DO 300 J = 1, MAXCAT
		DO 290 IK = 11, MAXAN
			IF (Z(J)*ABS(Z(IK)) .EQ. 4) THEN
			BPHI(J,IK)=BET0(J,IK)+BET1(J,IK)*EXP(-ALPHA1)+
     x				BET2(J,IK)*EXP(-ALPHA2)
			B(J,IK)=BET0(J,IK)+BET1(J,IK)*G1+BET2(J,IK)*G2
			  BPRIME(J,IK)=BET1(J,IK)*GPRI1/I+BET2(J,IK)*
     x				GPRI2/I
     			ELSE
			   BPHI(J,IK)=BET0(J,IK)+BET1(J,IK)*EXP(-ALPHA)
				B(J,IK)=BET0(J,IK)+BET1(J,IK)*G
				BPRIME(J,IK)=BET1(J,IK)*GPRIME/I
			END IF
		IF((J.EQ.9).OR.((J.EQ.10).AND.(IK.EQ.12)))THEN
				ALPHA4 = 2.0*SQRT(I)
				ALPHA5 = 1.0*SQRT(I)
			G4 = 2*(1-(1+ALPHA4)*EXP(-ALPHA4))/ALPHA4**2
			G5 = 2*(1-(1+ALPHA5)*EXP(-ALPHA5))/ALPHA5**2
	GPR4 = -2*(1-(1+ALPHA4+ALPHA4**2/2)*EXP(-ALPHA4))/ALPHA4**2
	GPR5 = -2*(1-(1+ALPHA5+ALPHA5**2/2)*EXP(-ALPHA5))/ALPHA5**2
			BPHI(J,IK)=BET0(J,IK)+BET1(J,IK)*EXP(-ALPHA4)+
     x				BET2(J,IK)*EXP(-ALPHA5)
			B(J,IK)=BET0(J,IK)+BET1(J,IK)*G4+BET2(J,IK)*G5
			BPRIME(J,IK)=BET1(J,IK)*GPR4/I+BET2(J,IK)*
     x				GPR5/I
     			END IF
     			
     		IF(((J.EQ.3).OR.(J.EQ.4)).AND.(IK.EQ.20))THEN
     			BPHI(J,IK)=BET0(J,IK)+BET1(J,IK)*EXP(-ALPHA1)+
     x			BET2(J,IK)*EXP(-ALPHA2)
			B(J,IK)=BET0(J,IK)+BET1(J,IK)*G1+BET2(J,IK)*G2
			  BPRIME(J,IK)=BET1(J,IK)*GPRI1/I+BET2(J,IK)*
     x				GPRI2/I
			END IF
			
			IF((J.EQ.5).AND.((IK.EQ.12).OR.(IK.EQ.16)))THEN
				C(J,IK)=C0(J,IK)+4.0*C1(J,IK)*H1
				CTPRI(J,IK)=4*C1(J,IK)*HPRI1/I
				CTPHI(J,IK)=C0(J,IK)+C1(J,IK)
     X*EXP(-ALPHA3)
			ELSE
			C(J,IK)=CPHI(J,IK)/(2*SQRT(Z(J)*ABS(Z(IK))))
			CTPRI(J,IK)=0.0
			CTPHI(J,IK)=C(J,IK)
			ENDIF
290		CONTINUE
300	CONTINUE
	DO 320 J = 1, MAXCAT - 1
		DO 310 IK = J + 1, MAXCAT
			IF ((Z(J) .EQ. 0) .OR. (Z(IK) .EQ. 0)) GOTO 310
			CALL INTERACTION(Z(J),Z(IK),I,A,PHIPHI(J,IK),
     x			PHIPRI(J,IK),PHIIJ(J,IK),THETA(J,IK),AKI,AKII)
310		CONTINUE
320	CONTINUE
	DO 340 J = 11, MAXAN - 1
		DO 330 IK = J + 1, MAXAN
			IF ((Z(J) .EQ. 0) .OR. (Z(IK) .EQ. 0)) GOTO 330
			CALL INTERACTION(Z(J),Z(IK),I,A,PHIPHI(J,IK),
     x			PHIPRI(J,IK),PHIIJ(J,IK),THETA(J,IK),AKI,AKII)
330		CONTINUE
340	CONTINUE

C  Calculation of summation terms for F and PHI.

	SCATON = 0
	SUBSUM = 0
	SANON = 0
	SUMCAF = 0
	SUMANF = 0
	
	DO 370 J = 1, MAXCAT - 1
		DO 360 IK = J + 1, MAXCAT
			DO 350 L = 11, MAXAN
				SUBSUM  = SUBSUM + PSI(J,IK,L) * X(L)
350			CONTINUE
			SCATON=SCATON+(SUBSUM+PHIPHI(J,IK))*X(J)*X(IK)
	      	SUMCAF=SUMCAF+PHIPRI(J,IK)*X(J)*X(IK)
			SUBSUM = 0
360		CONTINUE
370	CONTINUE
	SUBSUM = 0
	DO 400 J = 11, MAXAN - 1
		DO 390 IK = J + 1, MAXAN
			DO 380 L = 1, MAXCAT
				SUBSUM=SUBSUM+PSI(J,IK,L)*X(L)
380			CONTINUE
		      SANON=SANON+(SUBSUM+PHIPHI(J,IK))*X(J)*X(IK)
			SUMANF=SUMANF+PHIPRI(J,IK)*X(J)*X(IK)
			SUBSUM = 0
390		CONTINUE
400	CONTINUE
	SUMB = 0
	SUMPHI = 0
	DO 420 J = 1, MAXCAT
		DO 410 IK = 11, MAXAN
			SUMB=SUMB+X(J)*X(IK)*(BPRIME(J,IK)+ZZ*CTPRI
     X(J,IK)/2.0)
			SUMPHI=SUMPHI+X(J)*X(IK)*(BPHI(J,IK)+ZZ*
     XCTPHI(J,IK))
410		CONTINUE
420	CONTINUE
	JC=21
	ASUM=0.0
	BSUM=0.0
	CSUM=0.0
421	DO 422 JA=1,MAXCAT
	ASUM = ASUM+X(JA)*X(JC)*LAM(JA,JC)
422	CONTINUE
	DO 423 JB=11,MAXAN
	BSUM=BSUM+X(JB)*X(JC)*LAM(JB,JC)
423 	CONTINUE
	IF(JC.EQ.21)THEN
		JC=152
		GO TO 421
	END IF
	IF(JC.EQ.152) THEN
		JC=155
		GO TO 421
	END IF
	IF(JC.EQ.155) THEN
		JC=169
		GO TO 421
	END IF
	JC=21
425	DO 426 JA=1,MAXCAT
	DO 426 JB=11,MAXAN
	CSUM=CSUM+X(JA)*X(JB)*X(JC)*XI(JA,JB,JC)
426	CONTINUE
	IF(JC.EQ.21)THEN
		JC=152
		GO TO 425
	END IF
	IF(JC.EQ.152) THEN
		JC = 155
		GO TO 425
	END IF
	IF(JC.EQ.155) THEN
		JC=169
		GO TO 425
	END IF
	F=-A*(SQRT(I)/(1+1.2*SQRT(I))+2*LOG(1+1.2*SQRT(I))/1.2)+SUMB+
     x	SUMCAF+SUMANF
      PHI=1+(2/SM)*((-A*I**1.5)/(1+1.2*SQRT(I))+SUMPHI+SCATON+
     x	SANON+ASUM+BSUM+CSUM)
      AH2O = EXP(-PHI*SM/55.50844)

C  Calculation of terms for activity coefficients (gamma).

	SUM = 0
	DO 450 J = 1, MAXCAT - 1
		DO 440 IK = J + 1, MAXCAT
			DO 430 L = 11, MAXAN
				PSI(IK,J,L) = PSI(J,IK,L)
				PHIIJ(IK,J) = PHIIJ(J,IK)
430			CONTINUE
440		CONTINUE
450	CONTINUE
	DO 480 L = 11, MAXAN - 1
		DO 470 IK = L + 1, MAXAN
			DO 460 J = 1, MAXCAT
				PSI(IK,L,J) = PSI(L,IK,J)
				PHIIJ(IK,L) = PHIIJ(L,IK)
460			CONTINUE
470		CONTINUE
480	CONTINUE
	DO 500 J = 1, MAXCAT
		DO 490 IK = 11, MAXAN
		SUMCA(J) = SUMCA(J)+X(IK)*(2*(B(J,IK))+ZZ*C(J,IK))
490		CONTINUE
500	CONTINUE
	DO 530 J = 1, MAXCAT
		DO 520 IK = 1, MAXCAT
			IF (J .EQ. IK) GOTO 520
			DO 510 L = 11, MAXAN
				SUM=SUM+X(L)*PSI(J,IK,L)
510			CONTINUE
			SUMCAT(J)=SUMCAT(J)+X(IK)*(SUM+2*PHIIJ(J,IK))
			SUM = 0
520		CONTINUE
530	CONTINUE
	DO 560 J = 1, MAXCAT
		DO 550 IK = 11, MAXAN-1
			DO 540 L = IK + 1, MAXAN
			      SUMAN(J) = SUMAN(J)+X(IK)*X(L)*PSI(IK,L,J)
540			CONTINUE
550		CONTINUE
560	CONTINUE
	SUM = 0
	DO 580 J = 1, MAXCAT
		DO 570 IK = 11, MAXAN
			SUM = SUM + X(J)*X(IK)*C(J,IK)
570		CONTINUE
580	CONTINUE
	DO 590 J = 1, MAXCAT
		SUMZ(J) = SUM*ABS(Z(J))
590	CONTINUE
	DO 593 JA=1,MAXCAT
	SUMMA(JA)=SUMMA(JA)+X(21)*2*LAM(JA,21)+X(152)*2*LAM(JA,152)
     X+X(155)*2*LAM(JA,155)+X(166)*2*LAM(JA,166)+X(169)*2*LAM(JA,169)
		DO 592 JB=11,MAXAN
			SUMMB(JA)=SUMMB(JA)+X(21)*X(JB)*XI(JA,JB,21)+
     XX(152)*X(JB)*XI(JA,JB,152)+X(155)*X(JB)*XI(JA,JB,155)
     X+X(166)*X(JB)*XI(JA,JB,166)+X(169)*X(JB)*XI(JA,JB,169)
592		CONTINUE
593	CONTINUE
	DO 600 J = 1, MAXCAT
	        GX(J)=EXP(Z(J)**2*F+SUMCA(J)+SUMCAT(J)+SUMAN(J)+SUMZ(J)
     X+SUMMA(J)+SUMMB(J))
600	CONTINUE
	SUM = 0
	DO 620 IK = 11, MAXAN
		DO 610 J = 1, MAXCAT
		      SUMAC(IK) = SUMAC(IK)+X(J)*(2*B(J,IK)+ZZ*C(J,IK))
610		CONTINUE
620	CONTINUE
	DO 650 IK = 11, MAXAN
		DO 640 L = 11, MAXAN
			IF (IK .EQ. L) GOTO 640
			DO 630 J = 1, MAXCAT
				SUM = SUM+X(J)*PSI(IK,L,J)
630			CONTINUE
			SUMAA(IK)=SUMAA(IK)+X(L)*(2*PHIIJ(IK,L)+SUM)
			SUM = 0
640		CONTINUE
650	CONTINUE
	DO 680 IK = 11, MAXAN
		DO 670 J = 1, MAXCAT - 1
			DO 660 L = J + 1, MAXCAT
			      SUMCC(IK)=SUMCC(IK)+X(J)*X(L)*PSI(J,L,IK)
660			CONTINUE
670		CONTINUE
680	CONTINUE
	SUM = 0
	DO 700 J = 1, MAXCAT
		DO 690 IK = 11, MAXAN
			SUM = SUM+X(J)*X(IK)*C(J,IK)
690		CONTINUE
700	CONTINUE
	DO 710 IK = 11, MAXAN
		SUMK(IK) = SUM * ABS(Z(IK))
710	CONTINUE
	DO 713 JA=11,MAXAN
		SUMMA(JA)=X(21)*2*LAM(JA,21)+X(152)*2*LAM(JA,152)
     X+X(155)*2*LAM(JA,155)+X(169)*2*LAM(JA,169)+X(166)*2*LAM(JA,166)
		DO 712 JB=1,MAXCAT
			SUMMB(JA)=SUMMB(JA)+X(21)*X(JB)*XI(JB,JA,21)
     X+X(152)*X(JB)*XI(JB,JA,152)+X(155)*X(JB)*XI(JB,JA,155)
     X+X(169)*X(JB)*XI(JB,JA,169)+X(166)*X(JB)*XI(JB,JA,166)
712		CONTINUE
713	CONTINUE
	DO 720 IK = 11, MAXAN
	   GX(IK)=EXP(Z(IK)**2*F+SUMAC(IK)+SUMAA(IK)+SUMCC(IK)+SUMK(IK)
     X+SUMMA(IK)+SUMMB(IK))
720	CONTINUE
	
C
C CALCULATION OF CO2(AQ), O2(AQ), CH4(AQ) , B(OH)3 ACTIVITY COEFFICIENTS
C
	JC=21
724      ASUM = 0
	BSUM = 0
	CSUM = 0
	DO 725 JA=1,MAXCAT
		ASUM = ASUM + 2*X(JA)*LAM(JA,JC)
725   CONTINUE
	DO 730 JB=11,MAXAN
		BSUM = BSUM + 2*X(JB)*LAM(JB,JC)
730   CONTINUE
	DO 735 JA=1,MAXCAT
	DO 735 JB=11,MAXAN
		CSUM = CSUM +X(JA)*X(JB)*XI(JA,JB,JC)
735   CONTINUE
	GX(JC) = EXP(ASUM+BSUM+CSUM)
	IF(JC.EQ.21)THEN 
		JC=152
		GOTO 724
	END IF
	IF(JC.EQ.152)THEN
		JC=155
		GOTO 724
	END IF
	IF(JC.EQ.155)THEN
		JC=169
		GO TO 724
	END IF
		
	
	

C
C  CALCULATION OF THE PRESSURE DEPENDENCE OF ION ACTIVITY COEFFICIENTS
C
	R = 83.1451
	T=TEMP
	PB1 = 1.01325
	DO 790 J=1,20
		VBAR(J) = 0.0
		V00(J) = 0.0
790	CONTINUE

	DO 800 J=1,MAXCAT
	DO 800 IK=11,MAXAN
		SUMAN(J)=0.0
		SUMCATAN(J) = 0.0
		SUMAC(IK) = 0.0
		SUMANCAT(IK) = 0.0

		V00(J) = V0(J)-K0(J)*(PB-1.01325)
		V00(IK) = V0(IK)-K0(IK)*(PB-1.01325)
		BV0(J,IK) = BV0(J,IK)
		BV1P(J,IK) = BV1(J,IK)-AB1(J,IK)*(PB-1.01325)
		BV2(J,IK) = BV2(J,IK)
		CVP(J,IK) = CV(J,IK)-AB2(J,IK)*(PB-1.01325)
		
		IF(Z(J)*ABS(Z(IK)).EQ.4)THEN
		BPRIMV(J,IK)=BV1P(J,IK)*GPRI1/I+BV2(J,IK)*GPRI2/I
			BV(J,IK)=BV0(J,IK)+BV1P(J,IK)*G1+BV2(J,IK)*G2
     		BPHIV(J,IK)=BV0(J,IK)+BV1P(J,IK)*EXP(-ALPHA1)
     X		+BV2(J,IK)*EXP(-ALPHA2)
		ELSE
			BPRIMV(J,IK)=BV1P(J,IK)*GPRIME/I
			BV(J,IK)=BV0(J,IK)+BV1P(J,IK)*G
			BPHIV(J,IK)=BV0(J,IK)+BV1P(J,IK)*EXP(-ALPHA)
		END IF	
		IF(((J.EQ.9).OR.(J.EQ.10)).AND.(IK.EQ.12))THEN
			BPHIV(J,IK)=BV0(J,IK)+BV1P(J,IK)*EXP(-ALPHA4)+
     x				BV2(J,IK)*EXP(-ALPHA5)
			BV(J,IK)=BV0(J,IK)+BV1P(J,IK)*G4+BV2(J,IK)*G5
			BPRIMV(J,IK)=BV1P(J,IK)*GPR4/I+BV2(J,IK)*GPR5/I
     		END IF
	
800	CONTINUE

	DO 810 J=1,MAXCAT
	DO 810 IK=11,MAXAN
		SUMAN(J)=SUMAN(J)+X(IK)*(BV(J,IK)+(ZZ/2)*CVP(J,IK))
810	CONTINUE
	DO 812 J=1,MAXCAT
	DO 812 IK=11,MAXAN
	DO 812 IJ=1,MAXCAT
		SUMCATAN(J)=SUMCATAN(J)+X(IJ)*X(IK)*(Z(J)**2*
     X           BPRIMV(IJ,IK)+Z(J)*CVP(IJ,IK))
812	CONTINUE
	DO 815 J=1,MAXCAT
		VBAR(J)=V00(J)+(Z(J)**2*AV/4)*(SQRT(I)/(1+1.2*SQRT(I))+
     X2*LOG(1+1.2*SQRT(I))/1.2)+2*R*T*SUMAN(J)+R*T*SUMCATAN(J)
815     CONTINUE
	DO 820 IK=11,MAXAN
	DO 820 J=1,MAXCAT
		SUMAC(IK)=SUMAC(IK)+X(J)*(BV(J,IK)+(ZZ/2)*CVP(J,IK))
820     CONTINUE
	DO 822 IK=11,MAXAN
	DO 822 J=1,MAXCAT
	DO 822 IJ=11,MAXAN
		SUMANCAT(IK)=SUMANCAT(IK)+X(J)*X(IJ)*(Z(IK)**2*BPRIMV
     X(J,IJ)+ABS(Z(IK))*CVP(J,IJ))
822 	CONTINUE
	DO 825 IK=11,MAXAN
		VBAR(IK)=V00(IK)+(Z(IK)**2*AV/4)*(SQRT(I)/(1+1.2*SQRT(I)
     X)+2*LOG(1+1.2*SQRT(I))/1.2)+2*R*T*SUMAC(IK)+R*T*SUMANCAT(IK)
825     CONTINUE
	DO 830 J=1,MAXCAT
		GX(J)=GX(J)*EXP((VBAR(J)-V00(J))*(PB-PB1)/(R*T))
830     CONTINUE
	DO 835 IK=11,MAXAN
		GX(IK)=GX(IK)*EXP((VBAR(IK)-V00(IK))*(PB-PB1)/(R*T))
835     CONTINUE

C
C  CALCULATION OF THE PRESSURE DEPENDENCE OF EQUILIBRIUM CONSTANTS
C

	DO 850 J=1,200
		DELV(J) = 0.0
		DELK(J) = 0.0
850 	CONTINUE
	DELV(13) = V0(5)+V0(13)-V0(30)
	DELK(13) = K0(5)+K0(13)-K0(30)
	DELV(14) = V0(5)+V0(14)-V0(30)-V0(21)
	DELK(14) = K0(5)+K0(14)-K0(30)-K0(21)
	DELV(15) = V0(5)+V0(15)-V0(14)
	DELK(15) = K0(5)+K0(15)-K0(14)
	DELV(16) = V0(5)+V0(12)-V0(16)
	DELK(16) = K0(5)+K0(12)-K0(16)
	DELV(28) = -V0(30)
	DELK(28) = -K0(30)
	DELV (29) = -V0(21)
	DELV(152) = -V0(152)
	DELV(31) = V0(30)-V0(31)
	DELK(31) = K0(30)-K0(31)
	DELV(32) = V0(1)+V0(11)+2*V0(30)-V0(32)
	DELK(32) = K0(1)+K0(11)+2*K0(30)-K0(32)
	DELV(33) = V0(1)+V0(11)-V0(33)
	DELK(33) = K0(1)+K0(11)-K0(33)
	DELV(34) = V0(2)+V0(11)-V0(34)
	DELK(34) = K0(2)+K0(11)-K0(34)
	DELV(35) = V0(3)+2*V0(11)+6*V0(30)-V0(35)
	DELK(35) = K0(3)+2*K0(11)+6*K0(30)-K0(35)
	DELV(36) = V0(4)+2*V0(11)+6*V0(30)-V0(36)
	DELK(36) = K0(4)+2*K0(11)+6*K0(30)-K0(36)
	DELV(37) = V0(4)+2*V0(11)+8*V0(30)-V0(37)
	DELK(37) = K0(4)+2*K0(11)+8*K0(30)-K0(37)
	DELV(38) = V0(4)+2*V0(11)+12*V0(30)-V0(38)
	DELK(38) = K0(4)+2*K0(11)+12*K0(30)-K0(38)
	DELV(39) = V0(2)+V0(4)+3*V0(11)+6*V0(30)-V0(39)
	DELK(39) = K0(2)+K0(4)+3*K0(11)+6*K0(30)-K0(39)
	DELV(40) = V0(3)+2*V0(4)+6*V0(11)+12*V0(30)-V0(40)
	DELK(40) = K0(3)+2*K0(4)+6*K0(11)+12*K0(30)-K0(40)
	DELV(41) = 2*V0(1)+V0(12)+10*V0(30)-V0(41)
	DELK(41) = 2*K0(1)+K0(12)+10*K0(30)-K0(41)
	DELV(42) = 2*V0(1)+V0(12)-V0(42)
	DELK(42) = 2*K0(1)+K0(12)-K0(42)
	DELV(43) = V0(4)+V0(12)+6*V0(30)-V0(43)
	DELK(43) = K0(4)+K0(12)+6*K0(30)-K0(43)
	DELV(44) = V0(4)+V0(12)+7*V0(30)-V0(44)
	DELK(44) = K0(4)+K0(12)+7*K0(30)-K0(44)
	DELV(45) = 2*V0(2)+V0(12)-V0(45)
	DELK(45) = 2*K0(2)+K0(12)-K0(45)
	DELV(46) = 2*V0(2)+V0(4)+2*V0(12)+6*V0(30)-V0(46)
	DELK(46) = 2*K0(2)+K0(4)+2*K0(12)+6*K0(30)-K0(46)
	DELV(47) = 2*V0(1)+V0(4)+2*V0(12)+4*V0(30)-V0(47)
	DELK(47) = 2*K0(1)+K0(4)+2*K0(12)+4*K0(30)-K0(47)
	DELV(48) = V0(3)+V0(12)+2*V0(30)-V0(48)
	DELK(48) = K0(3)+K0(12)+2*K0(30)-K0(48)
	DELV(49) = V0(3)+V0(12)-V0(49)
	DELK(49) = K0(3)+K0(12)-K0(49)
	DELV(50) = V0(4)+V0(12)+11*V0(30)-V0(50)
	DELK(50) = K0(4)+K0(12)+11*K0(30)-K0(50)
	DELV(51) = 2*V0(1)+6*V0(2)+4*V0(12)-V0(51)
	DELK(51) = 2*K0(1)+6*K0(2)+4*K0(12)-K0(51)
	DELV(52) = V0(3)+V0(15)-V0(52)
	DELK(52) = K0(3)+K0(15)-K0(52)
	DELV(53) = V0(4)+V0(15)-V0(53)
	DELK(53) = K0(4)+K0(15)-K0(53)
	DELV(54) = V0(4)+V0(15)+3*V0(30)-V0(54)
	DELK(54) = K0(4)+K0(15)+3*K0(30)-K0(54)
	DELV(55) = V0(4)+V0(15)+5*V0(30)-V0(55)
	DELK(55) = K0(4)+K0(15)+5*K0(30)-K0(55)
	DELV(56) = V0(3)+V0(15)+6*V0(30)-V0(56)
	DELK(56) = K0(3)+K0(15)+6*K0(30)-K0(56)
	DELV(57) = V0(1)+V0(14)-V0(57)
	DELK(57) = K0(1)+K0(14)-K0(57)
	DELV(58) = 2*V0(1)+V0(15)+10*V0(30)-V0(58)
	DELK(58) = 2*K0(1)+K0(15)+10*K0(30)-K0(58)
	DELV(59) = 3*V0(1)+V0(14)+V0(15)+2*V0(30)-V0(59)
	DELK(59) = 3*K0(1)+K0(14)+K0(15)+2*K0(30)-K0(59)
	DELV(60) = 4*V0(4)+3*V0(15)+2*V0(13)+3*V0(30)-V0(60)
	DELK(60) = 4*K0(4)+3*K0(15)+2*K0(13)+3*K0(30)-K0(60)
	DELV(61) = V0(3)+V0(4)+2*V0(15)-V0(61)
	DELK(61) = K0(3)+K0(4)+2*K0(15)-K0(61)
	DELV(62) = 2*V0(1)+V0(15)+7*V0(30)-V0(62)
	DELK(62) = 2*K0(1)+K0(15)+7*K0(30)-K0(62)
	DELV(63) = V0(2)+V0(14)-V0(63)
	DELK(63) = K0(2)+K0(14)-K0(63)
	DELV(64) = V0(3)+V0(15)-V0(64)
	DELK(64) = K0(3)+K0(15)-K0(64)
	DELV(65) = V0(3)+V0(15)-V0(65)
	DELK(65) = K0(3)+K0(15)-K0(65)
	DELV(66) = V0(5)+V0(17)+3*V0(30)-V0(66)
	DELK(66) = K0(5)+K0(17)+3*K0(30)-K0(66)
	DELV(67) = V0(2)+V0(17)-V0(67)
	DELK(67) = K0(2)+K0(17)-K0(67)
	DELV(68) = V0(1)+V0(17)-V0(68)
	DELK(68) = K0(1)+K0(17)-K0(68)
	DELV(69) = V0(5)+V0(11)+3*V0(30)-V0(69)
	DELK(69) = K0(5)+K0(11)+3*K0(30)-K0(69)
	DELV(70) = 2*V0(5)+V0(12)+6.5*V0(30)-V0(70)
	DELK(70) = 2*K0(5)+K0(12)+6.5*K0(30)-K0(70)
	DELV(71) = 2*V0(5)+V0(12)+4*V0(30)-V0(71)
	DELK(71) = 2*K0(5)+K0(12)+4*K0(30)-K0(71)
	DELV(72) = V0(5)+V0(11)+6*V0(30)-V0(72)
	DELK(72) = K0(5)+K0(11)+6*K0(30)-K0(72)
	DELV(73) = 3*V0(1)+V0(12)+V0(17)+2*V0(30)-V0(73)
	DELK(73) = 3*K0(1)+K0(12)+K0(17)+2*K0(30)-K0(73)
	DELV(74) = 0.0
	DELK(74) = 0.0
	DELV(75) = V0(1)+V0(16)+V0(30)-V0(75)
	DELK(75) = K0(1)+K0(16)+K0(30)-K0(75)
	DELV(76) = 0.0
	DELK(76) = 0.0
	DELV(77) = 0.0
	DELK(77) = 0.0
	DELV(78) = 0.0
	DELK(78) = 0.0
	DELV(79) = V0(2)+V0(16)-V0(79)
	DELK(79) = K0(2)+K0(16)-K0(79)
	DELV(80) = V0(4)+V0(12)+V0(30)-V0(80)
	DELK(80) = K0(4)+K0(12)+K0(30)-K0(80)
	DELV(81) = V0(7)+V0(12)+7*V0(30)-V0(81)
	DELK(81) = K0(7)+K0(12)+7*K0(30)-K0(81)
	DELV(82) = V0(7)+V0(12)+V0(30)-V0(82)
	DELK(82) = K0(7)+K0(12)+K0(30)-K0(82)
	DELV(83) = V0(7)+2*V0(11)+6*V0(30)-V0(83)
	DELK(83) = K0(7)+2*K0(11)+6*K0(30)-K0(83)
	DELV(84) = V0(7)+2*V0(11)+4*V0(30)-V0(84)
	DELK(84) = K0(7)+2*K0(11)+4*K0(30)-K0(84)
	DELV(85) = V0(7)+V0(15)-V0(85)
	DELK(85) = K0(7)+K0(15)-K0(85)
	DELV(87) = V0(21)+6*V0(30)-V0(87)
	DELK(87) = K0(21)+6*K0(30)-K0(87)
	DELV(88) = V0(155)+6*V0(30)-V0(88)
	DELK(88) = K0(155)+6*K0(30)-K0(88)
	
C
C HERE ADD THE NEW IRON, ALUMIMUM AND BROMIDE AND SILICON CHEMISTRIES
C
	DELV(89) = V0(9)+3*V0(11)+10*V0(30)-V0(89)
	DELK(89) = K0(9)+3*K0(11)+10*K0(30)-K0(89)
	DELV(90) = V0(9)+3*V0(11)+6*V0(30)-V0(90)
	DELK(90) = K0(9)+3*K0(11)+6*K0(30)-K0(90)
	DELV(91) = V0(9)+2*V0(2)+5*V0(11)+V0(30)-V0(91)
	DELK(91) = K0(9)+2*K0(2)+5*K0(11)+K0(30)-K0(91)
	DELV(92) = 2*V0(9)+3*V0(12)-V0(92)
	DELK(92) = 2*K0(9)+3*K0(12)-K0(92)
	DELV(93) = 2*V0(9)+4*V0(2)+5*V0(12)+14*V0(30)-V0(93)
	DELK(93) = 2*K0(9)+4*K0(2)+5*K0(12)+14*K0(30)-K0(93)
	DELV(94) = 2*V0(2)+V0(7)+2*V0(12)+6*V0(30)-V0(94)
	DELK(94) = 2*K0(2)+K0(7)+2*K0(12)+6*K0(30)-K0(94)
	DELV(95) = 2*V0(1)+V0(7)+2*V0(12)+4*V0(30)-V0(95)
	DELK(95) = 2*K0(1)+K0(7)+2*K0(12)+4*K0(30)-K0(95)
	DELV(96) = 2*V0(9)+3*V0(12)+9*V0(30)-V0(96)
	DELK(96) = 2*K0(9)+3*K0(12)+9*K0(30)-K0(96)
	DELV(97) = 2*V0(5)+2*V0(9)+4*V0(12)+8*V0(30)-V0(97)
	DELK(97) = 2*K0(5)+2*K0(9)+4*K0(12)+8*K0(30)-K0(97)
	DELV(98) = V0(2)+3*V0(9)+2*V0(12)+6*V0(30)-V0(98)-6*V0(5)
	DELK(98) = K0(2)+3*K0(9)+2*K0(12)+6*K0(30)-K0(98)-6*K0(5)
	DELV(99) = V0(1)+3*V0(9)+2*V0(12)+6*V0(30)-V0(99)-6*V0(5)
	DELK(99) = K0(1)+3*K0(9)+2*K0(12)+6*K0(30)-K0(99)-6*K0(5)
	DELV(100) = 3*V0(9)+2*V0(12)+7*V0(30)-V0(100)-5*V0(5)
	DELK(100) = 3*K0(9)+2*K0(12)+7*K0(30)-K0(100)-5*K0(5)
	DELV(101) = 2*V0(9)+3*V0(30)-V0(101)-6*V0(5)
	DELK(101) = 2*K0(9)+3*K0(30)-K0(101)-6*K0(5)
	DELV(102) = V0(9)+2*V0(30)-V0(102)-3*V0(5)
	DELK(102) = K0(9)+2*K0(30)-K0(102)-3*K0(5)
	DELV(103) = V0(9)+2*V0(30)-V0(103)-3*V0(5)
	DELK(103) = K0(9)+2*K0(30)-K0(103)-3*K0(5)
	DELV(104) = V0(9)+0.125*V0(12)+1.75*V0(30)-V0(104)-2.75*V0(5)
	DELK(104) = K0(9)+0.125*K0(12)+1.75*K0(30)-K0(104)-2.75*K0(5)
	DELV(105) = V0(7)+V0(12)+4*V0(30)-V0(105)
	DELK(105) = K0(7)+K0(12)+4*K0(30)-K0(105)
	DELV(106) = 2*V0(9)+3*V0(12)+7*V0(30)-V0(106)
	DELK(106) = 2*K0(9)+3*K0(12)+7*K0(30)-K0(106)
	DELV(107) = V0(7)+4*V0(9)+6*V0(12)+22*V0(30)-V0(107)-2*V0(5)
	DELK(107) = K0(7)+4*K0(9)+6*K0(12)+22*K0(30)-K0(107)-2*K0(5)
	DELV(108) = 5*V0(9)+6*V0(12)+22*V0(30)-V0(108)-3*V0(5)
	DELK(108) = 5*K0(9)+6*K0(12)+22*K0(30)-K0(108)-3*K0(5)
	DELV(109) = V0(7)+2*V0(9)+4*V0(12)+22*V0(30)-V0(109)
	DELK(109) = K0(7)+2*K0(9)+4*K0(12)+22*K0(30)-K0(109)
	DELV(110) = V0(7)+2*V0(9)+4*V0(12)+14*V0(30)-V0(110)
	DELK(110) = K0(7)+2*K0(9)+4*K0(12)+14*K0(30)-K0(110)
	DELV(111) = 2*V0(2)+5*V0(7)+4*V0(9)+12*V0(12)+18*V0(30)-V0(111)
	DELK(111) = 2*K0(2)+5*K0(7)+4*K0(9)+12*K0(12)+18*K0(30)-K0(111)
	DELV(112) = V0(10)+3*V0(11)+6*V0(30)-V0(112)
	DELK(112) = K0(10)+3*K0(11)+6*K0(30)-K0(112)
	DELV(113) = 2*V0(10)+3*V0(12)+17*V0(30)-V0(113)
	DELK(113) = 2*K0(10)+3*K0(12)+17*K0(30)-K0(113)
	DELV(116) = V0(10)+3*V0(30)-V0(116)-3*V0(5)
	DELK(116) = K0(10)+3*K0(30)-K0(116)-3*K0(5)
	DELV(117) = V0(166)-V0(117)-2*V0(30)
	DELK(117) = K0(166)-K0(117)-2*K0(30)
C	DELV(118) =
C	DELK(118) = 
	DELV(119) = V0(2)+3*V0(10)+2*V0(12)+6*V0(30)-V0(119)-6*V0(5)
	DELK(119) = K0(2)+3*K0(10)+2*K0(12)+6*K0(30)-K0(119)-6*K0(5)
	DELV(120) = V0(1)+3*V0(10)+2*V0(12)+6*V0(30)-V0(120)-6*V0(5)
	DELK(120) = K0(1)+3*K0(10)+2*K0(12)+6*K0(30)-K0(120)-6*K0(5)
	DELV(121) = V0(2)+V0(10)+2*V0(12)+12*V0(30)-V0(121)
	DELK(121) = K0(2)+K0(10)+2*K0(12)+12*K0(30)-K0(121)
	DELV(122) = V0(1)+V0(10)+2*V0(12)+12*V0(30)-V0(122)
	DELK(122) = K0(1)+K0(10)+2*K0(12)+12*K0(30)-K0(122)
	DELV(123) = V0(7)+2*V0(10)+4*V0(12)+22*V0(30)-V0(123)
	DELK(123) = K0(7)+2*K0(10)+4*K0(12)+22*K0(30)-K0(123)
	DELV(124) = 2*V0(10)+2*V0(166)+V0(30)-V0(124)-6*V0(5)
	DELK(124) = 2*K0(10)+2*K0(166)+K0(30)-K0(124)-6*K0(5)
	DELV(125) = V0(4)+2*V0(10)+4*V0(12)+22*V0(30)-V0(125)
	DELK(125) = K0(4)+2*K0(10)+4*K0(12)+22*K0(30)-K0(125)
C  NEW PERCHLORATE CHEMISTRY
	DELV(126) = V0(1)+V0(19)+V0(30)-V0(126)
	DELK(126) = K0(1)+K0(19)+K0(30)-K0(126)
	DELV(127) = V0(4)+2*V0(19)+8*V0(30)-V0(127)
	DELK(127) = K0(4)+2*K0(19)+8*K0(30)-K0(127)
	DELV(128) = V0(3)+2*V0(19)+6*V0(30)-V0(128)
	DELK(128) = K0(3)+2*K0(19)+6*K0(30)-K0(128)
	DELV(129) = V0(2)+V0(19)-V0(129)
	DELK(129) = K0(2)+K0(19)-K0(129)
	DELV(130) = V0(4)+2*V0(19)+6*V0(30)-V0(130)
	DELK(130) = K0(4)+2*K0(19)+6*K0(30)-K0(130)
	DELV(131) = V0(1)+V0(19)+2*V0(30)-V0(131)
	DELK(131) = K0(1)+K0(19)+2*K0(30)-K0(131)
		
	DO 860 J=1,200
		K(J)=KV(J)*EXP(((-DELV(J))/(R*T))*(PB-PB1)+DELK(J)
     X/(2*R*T)*(PB-PB1)**2)
860	CONTINUE
	
C THESE STATEMENTS CALCULATE A MIXED HYDRATE SOLUBILITY PRODUCT
C FOR METHANE AND CARBON DIOXIDE HYDRATE

	IF((AX(29).EQ.0.0).OR.(AX(154).EQ.0.0))GO TO 875	
	IF(MIX.EQ.1) THEN
		IF (CH4MF.LE.0.595) THEN
			ANS=1.00+(7.998-0.03021*TEMP)*(1.00-0.595)
		ELSE
			ANS=1.00+(7.998-0.03021*TEMP)*(1.00-CH4MF)
		END IF
	END IF
	IF(ANS.GT.1.0) ANS = 1.0
	
	DK=K(87)*AX(154)*GX(154)/(K(88)*AX(29)*GX(29)*ANS)
		XCO26H2O = 1.0/(DK+1.0)
		XCH46H2O = DK/(DK+1.0)
		K(87) = K(87)*XCO26H2O
		K(88) = K(88)*XCH46H2O*ANS
875	CONTINUE

C  CALCULATION OF THE PRESSURE DEPENDENCE OF WATER ACTIVITY

	SUM = 0.0
	DO 865 J=1,MAXCAT
	DO 865 IK=11,MAXAN
		SUM=SUM+X(J)*X(IK)*(BV(J,IK)+(ZZ/2)*CVP(J,IK))
865	CONTINUE
	VEXMIX=(AV*I/1.2)*LOG(1.0+1.2*SQRT(I))+2*R*T*SUM
	WTSUM = 0
	VOLSUM = 0
	VOLSUM2 = 0
	DO 870 J=1,20
		WTSUM=WTSUM+X(J)*WT(J)
		VOLSUM=VOLSUM+X(J)*V00(J)
		VOLSUM2=VOLSUM2+X(J)*VBAR(J)
870	CONTINUE
    
     	RHO0=18.01528/VH2O
	RHO = (1000+WTSUM)/(1000/RHO0+VOLSUM+VEXMIX)
	VBARH2O=(18.01528/1000)*((1000+WTSUM)/RHO-VOLSUM2)
	AH2O=AH2O*EXP((VBARH2O-VH2O)*(PB-1.01325)/(R*T))
	PHI = -55.50844*LOG(AH2O)/SM
	
C ACTIVITY COEFFICIENT DATA FOR IRON/ALUMINUM HYDROLYSIS PRODUCTS
C  AND SILICA SPECIES BASED ON ANALOGY WITH FERROUS IONS.  
	GX(156) = 1.00
	GX(157) = GX(8)
	GX(158) = GX(7)
	GX(159) = GX(8)
	GX(160) = 1.00
	GX(161) = GX(8)
	GX(162) = GX(7)
	GX(163) = GX(8)
	GX(164) = 1.00
	GX(165) = GX(8)
	GX(166) = 1.00
	GX(167) = GX(8)
	
C	RETURNING CA AND CL TO ORIGINAL VALUES
	X(3) = X(3)-X(172)
	X(11) = X(11)-X(170)

	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE INTERACTION(Z1,Z2,I,A,PHIPHI,PHIPRI,PHIIJ,THETA,
     xAKI,AKII)
     
C  This subroutine calculates the higher-order electrostatic 
C  interaction terms for the Pitzer equations.
	
	REAL I, JX(2,2), JXPRIME(2,2)
	DIMENSION B(0:22), D(0:22),ZA(2), XA(2,2)
	DOUBLE PRECISION AKI(0:20),AKII(0:20)
	     
	B(21) = 0
	B(22) = 0
	D(21) = 0
	D(22) = 0
	ZA(1) = Z1
	ZA(2) = Z2
	
	DO 770 JJ = 1, 2
		DO 760 IJ = 1, 2
			XA(JJ,IJ)=6*ZA(IJ)*ZA(JJ)*A*SQRT(I)
			X=XA(JJ,IJ)
			IF (X .LT. 1) THEN
				ZZ = 4*X**0.20-2.0
				DZ = 0.80*X**(-0.80)
				DO 740 K = 20, 0, -1
					B(K) = ZZ*B(K+1)-B(K+2)+AKI(K)
					D(K) = B(K+1)+ZZ*D(K+1)-D(K+2)
740				CONTINUE
			ELSE
				ZZ = (40.0/9.0)*X**(-0.10)-22.0/9.0
				DZ = (-40.0/90.0)*X**(-1.10)
				DO 750 K = 20, 0, -1
					B(K) = ZZ*B(K+1)-B(K+2)+AKII(K)
					D(K) = B(K+1)+ZZ*D(K+1)-D(K+2)
750				CONTINUE
			END IF
			JX(JJ,IJ) = .25*X-1+.5*(B(0)-B(2))
			JXPRIME(JJ,IJ) = .25+.5*DZ*(D(0)-D(2))
760		CONTINUE
770	CONTINUE
	ETHETA=(Z1*Z2/(4*I))*(JX(1,2)-.5*JX(1,1)-.5*JX(2,2))
      ETHPRI=-ETHETA/I+(Z1*Z2/(8*I**2))*(XA(1,2)*JXPRIME(1,2)-.5*
     x	XA(1,1)*JXPRIME(1,1)-.5*XA(2,2)*JXPRIME(2,2))
      PHIPHI=THETA+ETHETA+I*ETHPRI
	PHIIJ=THETA+ETHETA
	PHIPRI=ETHPRI
	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE PPRINT(PERCENT)
	
C  Subroutine prints the results.

	REAL MOLE, IX, I
	CHARACTER*20 SPECIS(52), SOLID(31:131)

	CHARACTER*50 TITLE
	DIMENSION SUMI(38)
	DOUBLE PRECISION X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DATA SPECIS /'NA','K','CA','MG','H','MGOH','FE(II)','FEOH',
     x'FE(III)','AL','CL','SO4','OH','HCO3','CO3','HSO4','NO3','BR',
     x'CLO4','A','CO2','FECO3','HCL(BAR)','CACO3','MGCO3','HNO3(BAR)',
     X'H2SO4(BAR)','H2O(BAR)','CO2(BAR)','H2O(L)','O2(BAR)','O2',
     X'H2(BAR)','CH4(BAR)','CH4','FEII(OH)2','FEII(OH)3','FEIII(OH)',
     X'FEIII(OH)2','FEIII(OH)3','FEIII(OH)4','AL(OH)','AL(OH)2',
     X'AL(OH)3','AL(OH)4','SI(OH)4','SIO(OH)3','B(OH)4','B(OH)3','F',
     X'HF','SR'/
      DATA SOLID /'ICE','NACL.2H2O','NACL','KCL','CACL2.6H2O',
     x	'MGCL2.6H2O','MGCL2.8H2O','MGCL2.12H2O','KMGCL3.6H2O',
     x	'CACL2.2MGCL2.12H2O','NA2SO4.10H2O','NA2SO4','MGSO4.6H2O',
     x	'MGSO4.7H2O','K2SO4','MGSO4.K2SO4.6H2O','NA2SO4.MGSO4.4H2O',
     x	'CASO4.2H2O','CASO4','MGSO4.11H2O','NA2SO4.3K2SO4',
     X	'CACO3(CALCITE)','MGCO3','MGCO3.3H2O','MGCO3.5H2O',
     X	'CACO3.6H2O','NAHCO3','NA2CO3.10H2O','NAHCO3.NA2CO3.2H2O',
     X      '3MGCO3.MG(OH)2.3H2O','CAMG(CO3)2', 'NA2CO3.7H2O','KHCO3',
     X       'CACO3(ARAGONITE)','CACO3(VATERITE)','HNO3.3H2O','KNO3',
     X'NANO3','HCL.3H2O','H2SO4.6.5H2O','H2SO4.4H2O','HCL.6H2O',
     X'NANO3.NA2SO4.2H2O','NA3H(SO4)2','NAHSO4.H2O','K3H(SO4)2',
     X'K5H3(SO4)4','K8H6(SO4)7.H2O','KHSO4','MGSO4.H2O','FESO4.7H2O',
     X'FESO4.H2O','FECL2.6H2O','FECL2.4H2O','FECO3','FE(OH)3',
     X'CO2.6H2O','CH4.6H2O','FECL3.10H20','FECL3.6H2O','FECL3.2KCL.H20'
     X,'FE2(SO4)3','FE2(SO4)3.2K2SO4.14H2O','K2SO4.FESO4.6H2O'
     X,'NA2SO4.FESO4.4H2O','FE2(SO4)3.9H2O','FE2(SO4)3.H2SO4.8H2O',
     X'KFE3(SO4)2(OH)6','NAFE3(SO4)2(OH)6','H3OFE3(SO4)2(OH)6',
     X'a-FE2O3','a-FEO(OH)','g-FEO(OH)','FEO(OH)3/4(SO4)1/8',
     X'FESO4.4H2O','FE2(SO4)3.7H2O','FE(II)FE(III)4(SO4)6(OH)2.20H2O',
     X'FE(III)5(SO4)6O(OH).20H2O','FE(II)FE(III)2(SO4)4.22H2O',
     X'FE(II)FE(III)2(SO4)4.14H2O','K2FE(II)5FE(III)4(SO4)12.18H2O',
     X'ALCL3.6H2O','AL2(SO4)3.17H2O','NABR','MGBR2','AL(OH)3',
     X'SIO2(QUARTZ)','SIO2(AMORPHOUS)','KAL3(SO4)2(OH)6',
     X'NAAL3(SO4)2(OH)6','KAL(SO4)2.12H2O','NAAL(SO4)2.12H2O',
     X'FESO4.AL2(SO4)3.22H2O','AL2SI2O5(OH)4','MGSO4.AL2(SO4).22H2O',
     X'NACLO4.H2O','MG(CLO4)2.8H2O','CA(CLO4)2.6H2O','KCLO4',
     X'MG(CLO4)2.6H2O','NACLO4.2H2O'/
        GX(22) = 1
	GX(24) = 1
	GX(25) = 1
	CALL PITZER
	
	
	IF(IRON.EQ.2)THEN
		X(5)=AX(5)/GX(5)
	END IF
	
	DO 780 J = 1, 25
		IF(J.EQ.23) GOTO 780
		AX(J) = X(J) * GX(J)
780	CONTINUE
	
	DO J=156,172
		AX(J) = X(J)*GX(J)
	END DO
	DO 782 J = 1,38
		SUMI(J) = 0.0
782   CONTINUE
	WRITE(2,*)
	WRITE(2,785) TITLE
785	FORMAT(A50)
	WRITE (2,*)
       WRITE (2,787) "Temp(K)","Ion.Str.","RHO","Phi","H2O(g)","Ice(g)"
     X,"Press.(bars)"

787	FORMAT (1X, A7, A15, A10, A13, A14, A13,5X,A13)
	WRITE (2,790) TEMP,I,RHO,PHI,X(30),X(31),PB
790	FORMAT (1X, G10.5, 1X, G13.5,G13.7, 4G13.5)
	WRITE (2,*)
	WRITE (2,795) "Solution","Initial","Final","Mass"
795	FORMAT (1X, A8, A13, A11,40X,A10)
	WRITE (2,797) "SPECIES","Conc.","Conc.","Act.Coef.","Activity",
     x	"Moles","Balance"
797	FORMAT (1X, A7, A12, A13, A17, A12, A10,3X,A10)
	DO 798 J=1,25
		IF(J.EQ.23) GOTO 798
		FX(J) = X(J)*X(30)/1000
798	CONTINUE
	DO  J=156,172
		FX(J)=X(J)*X(30)/1000
	END DO
	
	IF(NCAR.EQ.1) THEN
		FX(29)=0.0
		FX(154)=0.0
	END IF
	
	IF (NCAR.EQ.2)THEN
	CALL GAS(29,PB,TEMP,GX(29),ZZZ)
	CPRIME=GX(21)*0.101325/(K(29)*8.314467E-2*TEMP*PB*GX(29)*ZZZ)
		X21=TCAR/(CPRIME+1)
		X29=TCAR-X21
		FX(21) = X21
		FX(29) = X29
	CALL GAS(154,PB,TEMP,GX(154),ZZZ)
	CPRIME=GX(155)*0.101325/(K(155)*8.314467E-2*TEMP*PB*GX(154)
     X*ZZZ)
		X155=TMET/(CPRIME+1)
		X154=TMET-X155
		FX(155)=X155
		FX(154)=X154
	END IF
	
	IF((X(87).EQ.TCAR).AND.(X(87).GT.0.0))THEN
		FX(21)=0.0
		FX(29)=0.0
	END IF
	IF((X(88).EQ.TMET).AND.(X(88).GT.0.0))THEN
		FX(154)=0.0
		FX(155)=0.0
	END IF
	
	FX(30) = X(30)/18.01528
	FX(31) = FX(31)+X(31)/18.01528
	
	IF((NCAR.EQ.1).AND.(MIX.EQ.1))THEN
		TMOLE = X(87)+X(88)
		X(87) = TMOLE*XCO26H2O
		X(88) = TMOLE*XCH46H2O
	END IF
	
	FX(87) = FX(87)+X(87)
	FX(88) = FX(88)+X(88)
	DO 799 J=32,131
		IF((J.EQ.87).OR.(J.EQ.88))GO TO 799
		FX(J) = FX(J)+X(J)*X(30)/1000
799	CONTINUE
      SUMI(1) = FX(1)+FX(32)+FX(33)+2*FX(41)+2*FX(42)+2*FX(47)+2*FX(51)
     X+FX(57)+2*FX(58)+3*FX(59)+2*FX(62)+FX(68)+3*FX(73)+3*FX(74)
     X+FX(75)+2*FX(95)+FX(99)+FX(114)+FX(120)+FX(122)+FX(126)+FX(131)
      SUMI(2) = FX(2)+FX(34)+FX(39)+2*FX(45)+2*FX(46)+6*FX(51)+FX(63)
     X+FX(67)+3*FX(76)+5*FX(77)+8*FX(78)+FX(79)+2*FX(91)+4*FX(93)
     X+2*FX(94)+FX(98)+2*FX(111)+FX(119)+FX(121)+FX(129)
	SUMI(3) = FX(3)+FX(24)+FX(35)+FX(40)+FX(48)+FX(49)+FX(52)+FX(56)
     X+FX(61)+FX(64)+FX(65)+FX(128)
      SUMI(4) = FX(4)+FX(25)+FX(36)+FX(37)+FX(38)+FX(39)+2*FX(40)+FX(43)
     X+FX(44)+FX(46)+FX(47)+FX(50)+FX(53)+FX(54)+FX(55)+4*FX(60)+FX(61)
     X+FX(6)+FX(80)+FX(115)+FX(125)+FX(127)+FX(130)
      SUMI(7) = FX(7)+FX(81)+FX(82)+FX(83)+FX(84)+FX(85)+FX(8)+FX(22)
     X+FX(94)+FX(95)+FX(156)+FX(157)+FX(105)+FX(107)+FX(109)+
     XFX(110)+5*FX(111)+FX(123)
      SUMI(9) = FX(9)+FX(89)+FX(90)+FX(91)+2*FX(92)+2*FX(93)+FX(158)+
     XFX(159)+FX(160)+FX(161)+2*FX(96)+2*FX(97)+3*FX(98)+3*FX(99)+
     X3*FX(100)+FX(86)+2*FX(101)+FX(102)+FX(103)+FX(104)+2*FX(106)+
     X4*(FX(107)+FX(111))+2*(FX(109)+FX(110))+5*FX(108)
      SUMI(10) = FX(10)+FX(162)+FX(163)+FX(164)+FX(165)+FX(112)
     X+2*FX(113)+FX(116)+3*FX(119)+3*FX(120)+FX(121)+FX(122)
     X+2*(FX(123)+FX(124))+2*FX(125)
      SUMI(11) = FX(11)+FX(32)+FX(33)+FX(34)+2*FX(35)+2*FX(36)+2*FX(37)
     X+2*FX(38)+3*FX(39)+6*FX(40)+FX(69)+FX(72)+2*FX(83)+2*FX(84)
     X+3*FX(89)+3*FX(90)+5*FX(91)+3*FX(112)
      SUMI(12) = FX(12)+FX(41)+FX(42)+FX(43)+FX(44)+FX(45)+2*FX(46)
     X+2*FX(47)+FX(48)+FX(49)+FX(50)+4*FX(51)+FX(16)+FX(70)+FX(71)
     X+FX(73)+2*FX(74)+FX(75)+2*FX(76)+4*FX(77)+7*FX(78)+FX(79)+FX(80)
     X+FX(81)+FX(82)+3*FX(92)+5*FX(93)+2*FX(94)+2*FX(95)+3*FX(96)+
     X4*FX(97)+2*(FX(98)+FX(99)+FX(100))+0.125*FX(104)+FX(105)
     X+3*FX(106)+4*(FX(109)+FX(110))+6*(FX(107)+FX(108))+12*FX(111)
     X+3*FX(113)+2*FX(119)+2*FX(120)+2*FX(121)+2*FX(122)+4*FX(123)
     X+4*FX(125)
      SUMI(14) = FX(14)+2*(FX(15)+FX(24)+FX(25)+FX(52)+FX(53)+FX(54)
     X+FX(55)+FX(56)+FX(58)+FX(62))+FX(57)+3*FX(59)+8*FX(60)+4*FX(61)
     X+FX(63) +2*FX(64)+2*FX(65)+2*FX(22)+2*FX(85)+FX(13)+FX(6)+FX(8)+
     XFX(20)
      SUMI(30) = FX(30)+FX(31)+2*FX(32)+6*FX(35)+6*FX(36)+8*
     XFX(37)+12*FX(38)+6*FX(39)+12*FX(40)+10*FX(41)+6*FX(43)+7*FX(44)+
     X6*FX(46)+4*FX(47)+2*FX(48)+11*FX(50)+3*FX(54)+5*FX(55)+6.5*FX(70)+
     X6*FX(56)+10*FX(58)+2*FX(59)+3*FX(60)+7*FX(62)+3*FX(66)+4.0*FX(71)
     X+3*FX(69)+6*FX(72)+2*FX(73)+FX(75)+FX(78)+FX(80)+7*FX(81)+FX(82)
     X+6*FX(83)+4*FX(84)+3*FX(86)+6*FX(87)+6*FX(88)+10*FX(89)
     X+6*FX(90)+FX(91)+14*FX(93)+6*FX(94)+4*FX(95)+9*FX(96)+8*FX(97)+
     X6*FX(98)+6*FX(99)+7*FX(100)+3*FX(101)+2*(FX(102)+FX(103))+
     X1.75*FX(104)+4*FX(105)+7*FX(106)+22*(FX(107)+FX(108)+FX(109))+
     X14*FX(110)+18*FX(111)+6*FX(112)+17*FX(113)+22*FX(123)+12*FX(121)
     X+12*FX(122)+FX(124)+3*FX(116)+6*(FX(119)+FX(120))+22*FX(125)
     X+FX(126)+8*FX(127)+6*FX(128)+6*FX(130)+2*FX(131)
      SUMI(17) = FX(17)+FX(66)+FX(67)+FX(68)+FX(73)
      SUMI(18) = FX(18)+FX(114)+2*FX(115)
      SUMI(19) = FX(19)+FX(126)+2*FX(127)+2*FX(128)+FX(129)+2*FX(130)
     X+FX(131)
	SUMI(5) = FX(5)+FX(16)+FX(66)+2.0*FX(70)+2.0*FX(71)+FX(69)
     X+FX(72)+FX(74)+FX(75)+FX(76)+3*FX(77)+6*FX(78)+FX(79)+2*FX(97)
     X+FX(100)+FX(171)
     	SUMI(21) = FX(21)+FX(87)+FX(29)
	SUMI(35) = FX(154)+FX(155)+FX(88)
	SUMI(36) = FX(166)+FX(167)+FX(117)+FX(118)+2*FX(124)
	SUMI(37) = FX(20) + FX(169)
	SUMI(38) = FX(170)+FX(171)
	IF(NCAR.EQ.1) THEN
		SUMI(21) = 0.0
		SUMI(35) = 0.0
	END IF
	
	SPECIS(1) = "NA"
	DO 810 J = 1, 25
		IF ((IX(J).EQ.0).AND.(FX(J) .EQ. 0)) GOTO 810
		IF ((J.EQ.20).OR.(J.EQ.23)) GOTO 810
	IF ((X(86).GT.0).AND.(J.EQ.14).AND.(IX(14).GT.0))THEN
	WRITE(2,800) SPECIS(J),IX(J),X(J),GX(J),AX(J),FX(J),SUMI(J)
		GOTO 810
	ENDIF
		IF ((J.EQ.5).AND.(ACID.GT.0.0))THEN
	WRITE(2,800)SPECIS(J),IX(J),X(J),GX(J),AX(J),FX(J),SUMI(J)
		GO TO 810
		END IF
		IF ((J.EQ.5).AND.(ACID.EQ.0.0))THEN
	WRITE(2,805)SPECIS(J),IX(J),X(J),GX(J),AX(J),FX(J)
		GO TO 810
		END IF
		
		IF (SUMI(J).EQ.0.0)THEN
		WRITE(2,805)SPECIS(J),IX(J),X(J),GX(J),AX(J),FX(J)
805			FORMAT(1X, A11, 5G13.5)
		ELSE
	    WRITE(2,800) SPECIS(J),IX(J),X(J),GX(J),AX(J),FX(J),SUMI(J)
800		FORMAT(1X, A11, 5G13.5, G12.5)
		ENDIF
810	CONTINUE
	IF(X(172).GT.0)THEN
	GX(172) = GX(3)
	AX(152) = X(172)*GX(172)
	WRITE(2,805)SPECIS(52),IX(172),X(172),GX(172),AX(172),FX(172)
        END IF


	 IF((X(7).GT.0.0).OR.(X(9).GT.0.0).OR.(X(10).GT.0.0)) THEN
	 	DO 813 IJ=156,165
	 		IJJ = IJ-120
			IF(X(IJ).EQ.0) GO TO 813
	WRITE(2,805)SPECIS(IJJ),IX(IJ),X(IJ),GX(IJ),AX(IJ),FX(IJ)
813		CONTINUE	
	END IF
	
	IF(X(166).GT.0.0) THEN
	WRITE(2,800)SPECIS(46),IX(166),X(166),GX(166),AX(166),FX(166),SUMI
     X(36)
    	 WRITE(2,805)SPECIS(47),IX(167),X(167),GX(167),AX(167),FX(167)
    	 END IF
    	 
    	 IF(X(20).GT.0.0) THEN
	WRITE(2,800)SPECIS(48),IX(20),X(20),GX(20),AX(20),FX(20),SUMI
     X(37)
    	 WRITE(2,805)SPECIS(49),IX(169),X(169),GX(169),AX(169),FX(169)
    	 END IF
    	 
	IF(X(170).GT.0.0) THEN
	WRITE(2,800)SPECIS(50),IX(170),X(170),GX(170),AX(170),FX(170),SUMI
     X(38)
    	 WRITE(2,805)SPECIS(51),IX(171),X(171),GX(171),AX(171),FX(171)
    	 END IF

	
	IF (AX(151).GT.0.0) THEN
		X(152) = K(152)*AX(151)/GX(152)
		AX(152) = GX(152)*X(152)
		FX(152) = X(152)*X(30)/1000
	WRITE(2,805)SPECIS(32),IX(152),X(152),GX(152),AX(152),FX(152)
		WRITE(2,812) SPECIS(31), IX(151),AX(151)
		AX(153)=((K(153)*AH2O**2)/AX(151))**0.5
		WRITE(2,812) SPECIS(33),IX(153),AX(153)
	END IF
	
	IF (IX(154).GT.0.0) THEN
		X(155) = K(155)*AX(154)*GX(154)/GX(155)
		AX(155)=X(155)*GX(155)
		FUGACITY=AX(154)*GX(154)
		IF(SUMI(35).EQ.0.0)THEN
			WRITE(2,800)SPECIS(35),IX(155),X(155),GX(155),
     XAX(155),FX(155)
     			GO TO 809
		END IF
	WRITE(2,800)SPECIS(35),IX(155),X(155),GX(155),AX(155),FX(155),
     XSUMI(35)
     	IF(AX(154).EQ.0.0)GOTO 821
809	WRITE(2,805) SPECIS(34),IX(154),AX(154), GX(154),FUGACITY,
     XFX(154)
	END IF

821	IF (AX(29).GT.0.0) THEN
		X(21)=K(29)*AX(29)*GX(29)/GX(21)
		FUGACITY=AX(29)*GX(29)
	WRITE(2,805) SPECIS(29),IX(29),AX(29), GX(29),FUGACITY,FX(29)
	END IF
	

	IF(ACID.GT.0.0)THEN
		IF((AX(23).EQ.0.0).AND.(X(11).GT.0.0))THEN
			CLACID=GX(5)*X(5)*GX(11)*X(11)/K(23)
			WRITE(2,812)SPECIS(23),IX(23),CLACID
			GOTO 825
		ENDIF
		IF(X(11).GT.0.0)WRITE (2,812) SPECIS(23),IX(23),AX(23)
825		IF((AX(26).EQ.0.0).AND.(X(17).GT.0.0)) THEN
			TRACID=GX(5)*X(5)*GX(17)*X(17)/K(26)
			WRITE(2,812)SPECIS(26),IX(26),TRACID
			GOTO 827
		ENDIF
		IF(X(17).GT.0.0)WRITE (2,812) SPECIS(26),IX(26),AX(26)
827		IF((AX(27).EQ.0.0).AND.(X(12).GT.0.0)) THEN
			SULACID=(GX(5)*X(5))**2*GX(12)*X(12)/K(27)
			WRITE(2,812)SPECIS(27),IX(27),SULACID
			GOTO 826
		ENDIF
		IF(X(12).GT.0.0)WRITE(2,812) SPECIS(27),IX(27),AX(27)
	END IF
826	AX(28) = AH2O/K(28)
	IF(AX(28).GT.0.0)WRITE (2,812)SPECIS(28),IX(28),AX(28)
	WRITE (2,812) SPECIS(30), IX(30),AH2O, FX(30),SUMI(30)
812	FORMAT (1X, A11, G12.5, 30X, G10.5,2G12.5)
	

	 
	IF((X(7).GT.0.0).AND.(X(9).GT.0.0)) THEN
	ALOGKT2=13.020-(9680/(2.302585*8.31451))*(1/298.15-1/TEMP)
		PE = ALOGKT2-LOG10(AX(7)/AX(9))
		EHO=ALOGKT2*8.31451*TEMP*2.302585/96484.56
		EH=EHO - 1.98424E-4*TEMP*LOG10(AX(7)/AX(9))
		WRITE(2,900) "REDOX EH =", EH, "REDOX pe =",PE
900		FORMAT(1X, A10, 2X, G10.5,A10,2X,G10.5)
	END IF

	WRITE (2,*)
	WRITE (2,815) "Solid","Equil.","Accum."
815	FORMAT (1X, A5,30X,A7,7X,A7)
	WRITE (2,817) "SPECIES","Moles","Constant","Moles"
817	FORMAT (1X, A7, A21, A16,A11)
	DO 840 J = 31, 131
		MOLE = X(J)*X(30)/1000
		IF (J .EQ. 31) MOLE = X(31) / 18.01528
		IF(J.EQ.87) MOLE=X(87)
		IF(J.EQ.88) MOLE=X(88)
		WRITE (2,830) SOLID(J), MOLE, K(J),FX(J)
830		FORMAT (1X, A20,3G13.5)
840	CONTINUE

	PH = -LOG10(AX(5))
	PHM = -LOG10(X(5))
	PHMM = -LOG10(X(5)+X(16))
	PHMMM = -LOG10(X(5)+X(16)+X(171))
	WRITE(2,*)
	WRITE(2,*)"PRACTICAL SALINITY =" ,S,"ABSOLUTE SALINITY = ",SA
	WRITE(2,*)"pH=",PH,"pHF=",PHM,"pHT=",PHMM,"pH(SWS)=",PHMMM
	
	WRITE (2,*)
	CRIT = 100.0/PERCENT
	WRITE(2,*) "CONVERGENCE CRITERION =", CRIT,"%"
	WRITE (2,*) " Iterations =", ITER
	
325	DIC=X(14)+X(15)+X(21)+X(22)+X(24)+X(25)+X(168)
330	FORMAT(2F12.2,3F12.8)
				
	WRITE (2,*)
	WRITE (2,*)
	
	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE NACL
	
C  Subroutine for NaCl equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,CLT,KPRIME,X,DELTA,AX,KV,K0,K
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	HHALIT = K(32) / AH2O**2
	HALITE = K(33)
	NAT = X(1) + X(32) + X(33)
	CLT = X(11) + X(32) + X(33)
	IF (HHALIT .GT. HALITE) KPRIME = K(33)/(GX(1)*GX(11))
      IF (HALITE .GT. HHALIT) KPRIME = K(32)/(GX(1)*GX(11)*AH2O**2)
	IF (NAT*CLT-KPRIME .GT. 0) GOTO 860
855	X(1) = NAT
	X(11) = CLT
	X(32) = 0
	X(33) = 0
	GOTO 880
860	DECREM = MIN(NAT,CLT)
	DO 870 KA = 2, 5
865		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 855
		X(1) = NAT - DELTA
		X(11) = CLT - DELTA
		IF ((X(1).LT.0.0).OR.(X(11).LT.0.0)) GOTO 869
	CALL PITZER
		HHALIT = K(32) / AH2O**2
		HALITE = K(33)
	      IF (HHALIT .GT. HALITE) KPRIME = K(33)/(GX(1)*GX(11))
	      IF (HALITE .GT. HHALIT) KPRIME = K(32)/(GX(1)*GX(11)*
     x		AH2O**2)
     		IF (X(1)*X(11)-KPRIME .GT. 0) GOTO 865
869		DELTA = DELTA-DECREM*(DEL(KA)-1)
870	CONTINUE
	X(1) = NAT - DELTA
	X(11) = CLT - DELTA
	
	IF (HHALIT .GT. HALITE) THEN
		X(33) = DELTA
		X(32) = 0
	ELSE
		X(32) = DELTA
		X(33) = 0
	END IF

880	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE SYLVITE
	
C  Subroutine for KCl equilibrium.

	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,CLT,KPRIME,X,DELTA,AX,KV,K0,K
	DOUBLE PRECISION AH2O,PHI
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KT = X(2) + X(34)
	CLT = X(11) + X(34)
	KPRIME = K(34) / (GX(2)*GX(11))
	IF (KT*CLT-KPRIME .GT. 0) GOTO 890
885	X(2) = KT
	X(11) = CLT
	X(34) = 0
	GOTO 910
890	DECREM = MIN(KT,CLT)
	DO 900 KA = 2, 5
895		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 885
		X(2) = KT - DELTA
		X(11) = CLT - DELTA
		IF ((X(2).LT.0.0).OR.(X(11).LT.0.0)) GOTO 899
	CALL PITZER
		KPRIME = K(34)/(GX(2)*GX(11))
		IF (X(2)*X(11)-KPRIME .GT. 0) GOTO 895
899		DELTA = DELTA-DECREM*(DEL(KA)-1)
900	CONTINUE
	X(2) = KT-DELTA
	X(11) = CLT-DELTA
	X(34) = DELTA
910	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE ANTARCTICITE
	
C  Subroutine for CaCl2 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION CAT,CLT,KPRIME,X,DELTA,AX,KV,K0,K
	DOUBLE PRECISION AH2O,PHI

	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	CAT = X(3) + X(35)
	CLT = X(11) + 2*X(35)
	KPRIME = K(35)/(GX(3)*GX(11)**2*AH2O**6)
	IF (CAT*CLT**2-KPRIME .GT. 0) GOTO 920
915	X(3) = CAT
	X(11) = CLT
	X(35) = 0
	GOTO 940
920	DECREM = MIN(CAT,CLT)
	DO 930 KA = 2, 5
925		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 915
		X(3) = CAT - DELTA
		X(11) = CLT - 2*DELTA
		IF ((X(3).LT.0.0).OR.(X(11).LT.0.0)) GOTO 929
	CALL PITZER
		KPRIME = K(35)/(GX(3)*GX(11)**2*AH2O**6)
		IF (X(3)*X(11)**2-KPRIME .GT. 0) GOTO 925
929		DELTA = DELTA - DECREM*(DEL(KA)-1)
930	CONTINUE
	X(3) = CAT-DELTA
	X(11) = CLT - 2*DELTA
	X(35) = DELTA
940	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE MGCL2
	
C	Subroutine for MgCl2 equilibrium.

	REAL IX,I
       DOUBLE PRECISION MGT,CLT,KPRIME,X,DELTA,KPRIM1,KPRIM2,KPRIM3,AX,
     XK,KV,K0
     	DOUBLE PRECISION AH2O,PHI

	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
     
	DELTA=0.0
	MGT = X(4)+X(36)+X(37)+X(38)
	CLT = X(11)+2*X(36)+2*X(37)+2*X(38)
	KPRIM1 = K(36)/(GX(4)*GX(11)**2*AH2O**6)
	KPRIM2 = K(37)/(GX(4)*GX(11)**2*AH2O**8)
	KPRIM3 = K(38)/(GX(4)*GX(11)**2*AH2O**12)
	KPRIME=MIN(KPRIM1,KPRIM2,KPRIM3)
	IF (MGT*CLT**2-KPRIME .GT. 0) GOTO 960
950	X(4) = MGT
	X(11) = CLT
	X(36) = 0
	X(37) = 0
	X(38) = 0
	GOTO 990
960	DECREM = MIN(MGT,CLT)
	DO 980 KA = 2, 5
970		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 950
		X(4) = MGT - DELTA
		X(11) = CLT-2*DELTA
		IF ((X(4).LT.0.0).OR.(X(11).LT.0.0)) GOTO 979
	CALL PITZER
		KPRIM1 = K(36)/(GX(4)*GX(11)**2*AH2O**6)
		KPRIM2 = K(37)/(GX(4)*GX(11)**2*AH2O**8)
		KPRIM3 = K(38)/(GX(4)*GX(11)**2*AH2O**12)
		KPRIME=MIN(KPRIM1,KPRIM2,KPRIM3)
     		IF (X(4)*X(11)**2-KPRIME .GT. 0) GOTO 970
979		DELTA = DELTA - DECREM*(DEL(KA)-1)
980	CONTINUE
	X(4) = MGT - DELTA
	X(11) = CLT - 2*DELTA
	IF (KPRIM1 .EQ. KPRIME) THEN
		X(36) = DELTA
		X(37) = 0
		X(38) = 0
	END IF
	IF (KPRIM2 .EQ. KPRIME) THEN 
		X(37) = DELTA
		X(36) = 0
		X(38) = 0
	END IF
	IF (KPRIM3 .EQ. KPRIME) THEN
		X(38) = DELTA
		X(36) = 0
		X(37) = 0
	END IF
990	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE CARNALLITE
	
C  Subroutine for KMgCl3.6H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,MGT,CLT,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI

	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

      
      DELTA=0.0
	KT = X(2) + X(39)
	MGT = X(4) + X(39)
	CLT = X(11) + 3*X(39)
	KPRIME = K(39)/(GX(2)*GX(4)*GX(11)**3*AH2O**6)
	IF (KT*MGT*CLT**3-KPRIME .GT. 0) GOTO 1005
1000	X(2) = KT
	X(11) = CLT
	X(4) = MGT
	X(39) = 0
	GOTO 1030
1005  DECREM = MIN(KT,MGT,CLT)
	DO 1020 KA = 2, 5
1010		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1000
		X(2) = KT - DELTA
		X(4) = MGT - DELTA
		X(11) = CLT - 3*DELTA
	IF((X(2).LT.0.).OR.(X(4).LT.0.).OR.(X(11).LT.0.)) GOTO 1019
	CALL PITZER
		KPRIME = K(39)/(GX(2)*GX(4)*GX(11)**3*AH2O**6)
		IF (X(2)*X(4)*X(11)**3-KPRIME .GT. 0) GOTO 1010
1019		DELTA = DELTA - DECREM*(DEL(KA)-1)
1020	CONTINUE
	X(2) = KT - DELTA
	X(4) = MGT - DELTA
	X(11) = CLT - 3*DELTA
	X(39) = DELTA
1030	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE TACHYHYDRITE
	
C  Subroutine for CaMg2Cl6.12H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

        DOUBLE PRECISION KPRIME,CAT,MGT,CLT,X,DELTA,AX,K,KV,K0
        DOUBLE PRECISION AH2O,PHI
	
     	DELTA=0.0
	CAT = X(3) + X(40)
	MGT = X(4) + 2*X(40)
	CLT = X(11) + 6*X(40)
	KPRIME = K(40)/(GX(3)*GX(4)**2*GX(11)**6*AH2O**12)
	IF (CAT*MGT**2*CLT**6-KPRIME .GT. 0) GOTO 1050
1040	X(3) = CAT
	X(11) = CLT
	X(4) = MGT
	X(40) = 0
	GOTO 1080
1050	DECREM = MIN(CAT,MGT,CLT)
	DO 1070 KA = 2, 5
1060		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1040
		X(3) = CAT - DELTA
		X(4) = MGT - 2*DELTA
		X(11) = CLT - 6*DELTA
	IF((X(3).LT.0.).OR.(X(4).LT.0.).OR.(X(11).LT.0.)) GOTO 1069
	CALL PITZER
		KPRIME = K(40)/(GX(3)*GX(4)**2*GX(11)**6*AH2O**12)
		IF (X(3)*X(4)**2*X(11)**6-KPRIME .GT. 0) GOTO 1060
1069		DELTA = DELTA-DECREM*(DEL(KA)-1)
1070	CONTINUE
	X(3) = CAT - DELTA
	X(4) = MGT - 2*DELTA
	X(11) = CLT - 6*DELTA
	X(40) = DELTA
1080	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE ARCANITE
	
C  Subroutine for K2SO4 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,SO4T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KT = X(2) + 2*X(45)
	SO4T = X(12) + X(45)
	KPRIME = K(45)/(GX(2)**2*GX(12))
	IF (KT**2*SO4T-KPRIME .GT. 0) GOTO 1100
1090	X(2) = KT
	X(12) = SO4T
	X(45) = 0
	GOTO 1130
1100	DECREM = MIN(KT,SO4T)
	DO 1120 KA = 2, 5
1110		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1090
		X(2) = KT - 2*DELTA
		X(12) = SO4T - DELTA
		IF ((X(2).LT.0.0).OR.(X(12).LT.0.0)) GOTO 1119
	CALL PITZER
		KPRIME = K(45)/(GX(2)**2*GX(12))
		IF (X(2)**2*X(12)-KPRIME .GT. 0) GOTO 1110
1119		DELTA = DELTA - DECREM*(DEL(KA)-1)
1120	CONTINUE
	X(2) = KT - 2*DELTA
	X(12) = SO4T - DELTA
	X(45) = DELTA
1130	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE NA2SO4
	
C  Subroutine for Na2SO4 equilibrium.

	REAL MIRAB,IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,SO4T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	NAT = X(1)+2*X(41)+2*X(42)
	SO4T = X(12)+X(41)+X(42)
	MIRAB  = K(41)/AH2O**10
	TENAR = K(42)
	IF (MIRAB .GT. TENAR) THEN
		KPRIME = K(42)/(GX(1)**2*GX(12))
	ELSE
		KPRIME = K(41)/(GX(1)**2*GX(12)*AH2O**10)
	END IF
	IF (NAT**2*SO4T-KPRIME .GT. 0) GOTO 1150
1140	X(1) = NAT
	X(12) = SO4T
	X(41) = 0
	X(42) = 0
	GOTO 1180
1150	DECREM = MIN(NAT,SO4T)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(1) = NAT - 2*DELTA
		X(12) = SO4T - DELTA
		IF ((X(1).LT.0.0).OR.(X(12).LT.0.0)) GOTO 1169
	CALL PITZER
		MIRAB = K(41)/AH2O**10
		TENAR = K(42)
		IF (MIRAB .GT. TENAR) THEN
			KPRIME = K(42)/(GX(1)**2*GX(12))
		ELSE
			KPRIME = K(41)/(GX(1)**2*GX(12)*AH2O**10)
		END IF
		IF (X(1)**2*X(12)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(1) = NAT - 2*DELTA
	X(12) = SO4T - DELTA
	IF (MIRAB .LT. TENAR) THEN 
		X(41) = DELTA
		X(42) = 0
	ELSE
		X(42) = DELTA
		X(41) = 0
	END IF
1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE MGSO4
	
C  Subroutine for MgSO4 equilibrium.

	
	REAL  IX,I,HEXAHY,KIESER
	CHARACTER*50 TITLE
	DOUBLE PRECISION MGT,SO4T,KPRIME,DELTA,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	MGT = X(4)+X(43)+X(44)+X(50)+X(80)
	SO4T = X(12)+X(43)+X(44)+X(50)+X(80)
	HEXAHY = K(43)/(AH2O**6*GX(4)*GX(12))
	EPSOM = K(44) / (AH2O**7*GX(4)*GX(12))
	TWELVE = K(50)/(AH2O**11*GX(4)*GX(12))
	KIESER=K(80)/(AH2O*GX(4)*GX(12))
	KPRIME=MIN(HEXAHY,EPSOM,TWELVE,KIESER)
	IF (MGT*SO4T-KPRIME .GT. 0) GOTO 1200
1190  X(4) = MGT
	X(12) = SO4T
	X(80) = 0
	X(43) =0
	X(44) = 0
	X(50) = 0
	GO TO 1230
	
1200	DECREM = MIN(MGT,SO4T)
	DO 1220 KA = 2, 5
1210		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA.LT.0) GO TO 1190
		X(4) = MGT - DELTA
		X(12) = SO4T - DELTA
		IF((X(4).LT.0.).OR.(X(12).LT.0.))GOTO 1219
		CALL PITZER
		HEXAHY = K(43)/(AH2O**6*GX(4)*GX(12))
		EPSOM = K(44)/(AH2O**7*GX(4)*GX(12))
		TWELVE = K(50)/(AH2O**11*GX(4)*GX(12))
		KIESER=K(80)/(AH2O*GX(4)*GX(12))
		KPRIME=MIN(HEXAHY,EPSOM,TWELVE,KIESER)
		IF (X(4)*X(12)-KPRIME .GT. 0) GOTO 1210
1219		DELTA = DELTA-DECREM*(DEL(KA)-1)
1220	CONTINUE
	X(4) = MGT - DELTA
	X(12) = SO4T - DELTA
	IF (HEXAHY.EQ.KPRIME) THEN
		X(43) = DELTA
		X(44) = 0
		X(50) = 0
		X(80) = 0
	END IF
	IF (EPSOM.EQ.KPRIME) THEN
		X(44) = DELTA
		X(43) = 0
		X(50) = 0
		X(80) = 0
	END IF
	IF (TWELVE.EQ.KPRIME) THEN
		X(50) = DELTA
		X(43) = 0
		X(44) = 0
		X(80) = 0
	END IF
	IF(KIESER.EQ.KPRIME)THEN
		X(80) = DELTA
		X(43) = 0
		X(44) = 0
		X(50) = 0
	END IF
1230	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE PICROMERITE
	
C  Subroutine for K2Mg(SO4)2.6H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION MGT,KT,SO4T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KPRIME = K(46)/(GX(4)*GX(2)**2*GX(12)**2*AH2O**6)
	MGT = X(4) + X(46)
	KT = X(2) + 2*X(46)
	SO4T = X(12) +2*X(46)
	IF (MGT*KT**2*SO4T**2-KPRIME .GT. 0) GOTO 1250
1240	X(4) = MGT
	X(12) = SO4T
	X(2) = KT
	X(46) = 0
	GO TO 1280
1250	DECREM = MIN(MGT,SO4T,KT)
	DO 1270 KA = 2, 5
1260		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1240
		X(4) = MGT - DELTA
		X(12) = SO4T - 2*DELTA
		X(2) = KT - 2*DELTA
	IF((X(4).LT.0.).OR.(X(12).LT.0.).OR.(X(2).LT.0.)) GOTO 1269
	CALL PITZER
		KPRIME = K(46)/(GX(4)*GX(2)**2*GX(12)**2*AH2O**6)
		IF (X(4)*X(2)**2*X(12)**2-KPRIME .GT. 0) GOTO 1260
1269		DELTA = DELTA-DECREM*(DEL(KA)-1)
1270	CONTINUE
	X(4) = MGT - DELTA
	X(12) = SO4T - 2*DELTA
	X(2) = KT - 2*DELTA
	X(46) = DELTA
1280	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE CASO4

C  Subroutine for CaSO4 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION CAT,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	CAT = X(3)+X(48)+X(49)
	SO4T = X(12)+X(48)+X(49)
	GYP = K(48)/AH2O**2
	ANHYD = K(49)
	IF (GYP .LT. ANHYD) THEN
		KPRIME = K(48)/(GX(3)*GX(12)*AH2O**2)
	ELSE
		KPRIME = K(49)/(GX(3)*GX(12))
	END IF
	IF (CAT*SO4T-KPRIME .GT. 0) GOTO 1285
1282  X(3) = CAT
	X(12) = SO4T
	X(48) = 0
	X(49) = 0
	GO TO 1330
1285	DECREM = MIN(CAT,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(3) = CAT - DELTA
		X(12) = SO4T - DELTA
		IF((X(3).LT.0.).OR.(X(12).LT.0.))GOTO 1319
	CALL PITZER
		GYP = K(48)/AH2O**2
		ANHYD = K(49)
		IF (GYP .LT. ANHYD) THEN
			KPRIME = K(48)/(GX(3)*GX(12)*AH2O**2)
		ELSE
			KPRIME = K(49)/(GX(3)*GX(12))
		END IF
		IF (X(3)*X(12)-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(3) = CAT - DELTA
	X(12) = SO4T - DELTA
	IF (GYP .LT. ANHYD) THEN
		X(48) = DELTA
		X(49) = 0
	ELSE
		X(49) = DELTA
		X(48) = 0
	END IF
1330	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE BLOEDITE
	
C  Subroutine for NA2Mg(SO4)2.4H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION MGT,NAT,SO4T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KPRIME = K(47)/(GX(4)*GX(1)**2*GX(12)**2*AH2O**4)
	MGT = X(4) + X(47)
	NAT = X(1) + 2*X(47)
	SO4T = X(12) +2*X(47)
	IF (MGT*NAT**2*SO4T**2-KPRIME .GT. 0) GOTO 1350
1340  X(4) = MGT
	X(1) = NAT
	X(12)=SO4T
	X(47) = 0
	GO TO 1380
1350	DECREM = MIN(MGT,SO4T,NAT)
	DO 1370 KA = 2, 5
1360		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1340
		X(4) = MGT - DELTA
		X(12) = SO4T - 2*DELTA
		X(1) = NAT - 2*DELTA
	IF((X(4).LT.0.).OR.(X(12).LT.0.).OR.(X(1).LT.0.)) GOTO 1369
	CALL PITZER
		KPRIME = K(47)/(GX(4)*GX(1)**2*GX(12)**2*AH2O**4)
		IF (X(4)*X(1)**2*X(12)**2-KPRIME .GT. 0) GOTO 1360
1369		DELTA = DELTA-DECREM*(DEL(KA)-1)
1370	CONTINUE
	X(4) = MGT - DELTA
	X(12) = SO4T - 2*DELTA
	X(1) = NAT - 2*DELTA
	X(47) = DELTA
1380	RETURN
	END
	

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE APHTHITALITE
	
C  Subroutine for NA2SO4.3K2SO4 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,NAT,SO4T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KPRIME = K(51)/(GX(1)**2*GX(2)**6*GX(12)**4)
	NAT = X(1) + 2*X(51)
	KT = X(2) + 6*X(51)
	SO4T = X(12) + 4*X(51)
	IF (KT**6*NAT**2*SO4T**4-KPRIME .GT. 0) GOTO 1450
1440  X(1) = NAT
	X(2) = KT
	X(12) = SO4T
	X(51) = 0
	GO TO 1480
1450	DECREM = MIN(KT,SO4T,NAT)
	DO 1470 KA = 2, 5
1460		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1440
		X(2) = KT - 6*DELTA
		X(12) = SO4T - 4*DELTA
		X(1) = NAT - 2*DELTA
	IF((X(2).LT.0.).OR.(X(12).LT.0.).OR.(X(1).LT.0.)) GOTO 1469
	CALL PITZER
		KPRIME = K(51)/(GX(2)**6*GX(1)**2*GX(12)**4)
		IF (X(2)**6*X(1)**2*X(12)**4-KPRIME .GT. 0) GOTO 1460
1469		DELTA = DELTA-DECREM*(DEL(KA)-1)
1470	CONTINUE
	X(2) = KT - 6*DELTA
	X(12) = SO4T - 4*DELTA
	X(1) = NAT - 2*DELTA
	X(51) = DELTA
1480	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------


	SUBROUTINE CACO3
	
C  Subroutine for CaCO3 equilibrium and pH calculation.
C  Has by-PBss loop to consider Ikaite solubility.  
	
	REAL  IX,I,IKAITE
	CHARACTER*50 TITLE
	DOUBLE PRECISION CAT,KPRIME,X,AX,AA,BA,DA,F,DF,DX,H,K,KV
     X,K0
     	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
      
	
	SCAL=1.0
	CAT = X(3)+X(24)+X(52)+X(56)+X(64)+X(65)
	CALCITE = K(52)/(GX(3)*GX(15)*X(15))
	ARAGON = K(64)/(GX(3)*GX(15)*X(15))	
	VATER = K(65)/(GX(3)*GX(15)*X(15))
	IKAITE = K(56)/(GX(3)*GX(15)*X(15)*AH2O**6)
	KPRIME = MIN(CALCITE,ARAGON,VATER,IKAITE)
	IF (CAT-KPRIME .GT. 0) GOTO 1600
1590	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
	X(3) = CAT-X(24)
	ALK = X(14)+2*X(15)+2*X(52)+2*X(56)+2*X(64)+2*X(65)
	X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
	X(15)=(ALK-X(14))/2.0
	X(52) = 0.0
	X(56) = 0.0
	X(64) = 0.0
	X(65) = 0.0
1595	BALAN = X(1) + X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)
     X-X(17)+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)-X(19)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)-X(20)-X(170)
     X+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      F = BALAN - AA/H - BA/H**2 - CA/H
      DF = AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	X(5) = H
	CALL CACO3IP
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-1,CACO3"
			ALK=X(14)+2*X(15)
			X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
			X(15)=(ALK-X(14))/2.0
			GO TO 1630
		ELSE
			SCAL=0.1
			GOTO 1590
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1595
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1630
	PHINIT = X(5)
	GO TO 1595
1600	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
1605	BALAN = X(1) + X(2) + 2*X(4) - X(11) -2*X(12)+X(6)-X(17)
     X+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
	IF(KPRIME.EQ.CALCITE) DA = 2*K(52)*GX(5)**2/(GX(3)*K(15)*
     XK(14)*AH2O*K(29)*AX(29)*GX(29))
     	IF(KPRIME.EQ.ARAGON) DA = 2*K(64)*GX(5)**2/(GX(3)*K(15)*
     XK(14)*AH2O*K(29)*AX(29)*GX(29))
     	IF(KPRIME.EQ.VATER) DA = 2*K(65)*GX(5)**2/(GX(3)*K(15)*
     XK(14)*AH2O*K(29)*AX(29)*GX(29))
	IF(KPRIME.EQ.IKAITE) DA = 2*K(56)*GX(5)**2/(GX(3)*K(15)*K(14)
     X*AH2O**7*K(29)*AX(29)*GX(29))
      F = DA*H**2 + BALAN - AA/H - BA/H**2 - CA/H
      DF = 2*DA*H + AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	X(5) = H
	CALL CACO3IP
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-2,CACO3"
			GO TO 1630
		ELSE
			SCAL=0.1
			GOTO 1600
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1605
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	CALCITE = K(52)/(GX(3)*GX(15)*X(15))
	ARAGON = K(64)/(GX(3)*GX(15)*X(15))
	VATER = K(65)/(GX(3)*GX(15)*X(15))
	IKAITE = K(56)/(GX(3)*GX(15)*X(15)*AH2O**6)
	KPRIME = MIN(CALCITE,ARAGON,VATER,IKAITE)
	X(3) = KPRIME
      X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1620
	PHINIT = X(5)
	GO TO 1605
1620	AX(5)=X(5)*GX(5)
      IF (KPRIME.EQ.CALCITE) THEN
      	X(24) = K(52)/K(24)
		X(52) = CAT-X(3)-X(24)
		X(56) = 0.0
		X(64) = 0.0
		X(65) = 0.0
	ELSEIF(KPRIME.EQ.ARAGON)THEN
	      X(24) = K(64)/K(24)
		X(64) = CAT-X(3)-X(24)
		X(56) = 0.0
		X(65) = 0.0
		X(52) = 0.0
	ELSEIF(KPRIME.EQ.VATER)THEN
	      X(24) = K(65)/K(24)
		X(65) = CAT-X(3)-X(24)
		X(56) = 0.0
		X(64) = 0.0
		X(52) = 0.0
	ELSEIF(KPRIME.EQ.IKAITE)THEN
		X(24)=K(56)/(K(24)*AH2O**6)
		X(56)=CAT-X(3)-X(24)
		X(52) = 0.0
		X(64) = 0.0
		X(65) = 0.0
	END IF
      IF ((X(52).LT.0).OR.(X(56).LT.0).OR.(X(64).LT.0).OR.(X(65).LT.0))
     XTHEN
		X(3)=CAT
		X(24)=0
		X(52) = 0
		X(56) = 0
		X(64) = 0
		X(65) = 0
		GO TO 1590
	END IF
1630	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE NAHCO3
	
C  Subroutine for sodium bicarbonate-carbonate equilibrium
c  and pH calculation.

	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,KPRIME,X,AX,AA,BA,F,DF,DX,H,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	SCAL=1.0
	NAT = X(1)+X(57)
	KPRIME = K(57)/(GX(1)*GX(14)*X(14))
	IF (NAT-KPRIME .GT. 0) GOTO 1700
1690	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
	X(1) = NAT
	ALK = X(14) + 2*X(15) + X(57)
	X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
	X(15)=(ALK-X(14))/2.0
	X(57) = 0.0
1695	BALAN = X(1) + X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)
     X-X(17)+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      F = BALAN - AA/H - BA/H**2 - CA/H
      DF = AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-1,NAHCO3"
			ALK=X(14)+2*X(15)
			X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
			X(15)=(ALK-X(14))/2.0
			GO TO 1730
		ELSE
			SCAL=0.1
			GOTO 1690
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1695
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1730
	PHINIT = X(5)
	GO TO 1695
1700	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
1705	BALAN = X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)-X(17)
     X+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
	DA=K(57)*GX(5)/(GX(1)*K(14)*K(29)*AH2O*AX(29)*GX(29))
      F = DA*H + BALAN - AA/H - BA/H**2 - CA/H
      DF = DA + AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-2,NAHCO3"
			GO TO 1730
		ELSE
			SCAL=0.1
			GOTO 1700
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1705
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	KPRIME = K(57)/(GX(1)*GX(14)*X(14))
	X(1) = KPRIME
      X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1720
	PHINIT = X(5)
	GO TO 1705
1720	AX(5)=X(5)*GX(5)
	X(57) = NAT-KPRIME
	IF(X(57).LT.0) THEN
		X(1) = NAT
		X(57) = 0.0
		GO TO 1690
	END IF

1730	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE MGCO3
	
C  Subroutine for MGCO3 equilibrium and pH calculation.
 
	
	REAL  IX,I,MAGNES,NESQUE,LANSFORD
	CHARACTER*50 TITLE
	DOUBLE PRECISION MGT,KPRIME,X,AX,AA,BA,F,DF,DX,H,DA,K,KV
     X,K0
     	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	SCAL=1.0
	MGT = X(4)+X(25)+X(53)+X(54)+X(55)+4*X(60)+X(6)
      MAGNES = K(53)/(GX(4)*GX(15)*X(15))
	NESQUE = K(54)/(GX(4)*GX(15)*X(15)*AH2O**3)
	LANSFORD = K(55)/(GX(4)*GX(15)*X(15)*AH2O**5)
      HYDROMAG = (K(60)/(GX(4)**4*GX(15)**3*X(15)**3*GX(13)**2*X(13)**2
     X*AH2O**3))**0.25
      KPRIME = MIN(MAGNES,NESQUE,LANSFORD,HYDROMAG)
	IF (MGT-KPRIME .GT. 0) GOTO 1800
1790	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
	X(4) = MGT-X(25)-X(6)
	ALK = X(14) + 2*X(15) + 2*X(53) + 2*X(54) + 2*X(55) + 10*X(60)
	X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
	X(15)=(ALK-X(14))/2.0
	X(53) = 0.0
	X(54) = 0.0
	X(55) = 0.0
	X(60) = 0.0
1795	BALAN = X(1) + X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)
     X-X(17)+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      F = BALAN - AA/H - BA/H**2 - CA/H
      DF = AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL MGCO3IP
	CALL MGOHIP
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-1,MGCO3"
			ALK=X(14)+2*X(15)
			X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
			X(15)=(ALK-X(14))/2.0
			GO TO 1830
		ELSE
			SCAL=0.1
			GOTO 1790
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1795
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1830
	PHINIT = X(5)
	GO TO 1795
1800	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
1805	BALAN = X(1) + X(2) + 2*X(3) - X(11) -2*X(12)-X(17)+X(6)
     X+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      IF(KPRIME.EQ.MAGNES) DA = 2*K(53)*GX(5)**2/(GX(4)*K(15)*K(14)*AH2O
     X*K(29)*AX(29)*GX(29))
     	IF(KPRIME.EQ.NESQUE) DA = 2*K(54)*GX(5)**2/(GX(4)*K(15)*K(14)*
     XAH2O**4*K(29)*AX(29)*GX(29))
      IF(KPRIME.EQ.LANSFORD) DA = 2*K(55)*GX(5)**2/(GX(4)*K(15)*K(14)*
     XAH2O**6*K(29)*AX(29)*GX(29))
      IF(KPRIME.EQ.HYDROMAG) DA=2*((K(60)*GX(5)**8)/(GX(4)**4*K(15)**3
     X*K(14)**3*K(29)**3*AX(29)**3*GX(29)**3*AH2O**8*K(13)**2))**0.25
      F = DA*H**2 + BALAN - AA/H - BA/H**2 - CA/H
      DF = 2*DA*H + AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	X(5) = H
	CALL MGOHIP
	CALL MGCO3IP
	IF (X(20).GT.0.0)CALL BORON
	IF (X(170).GT.0.0)CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-2,MGCO3"
			GO TO 1830
		ELSE
			SCAL=0.1
			GOTO 1800
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1805
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	MAGNES = K(53)/(GX(4)*GX(15)*X(15))
	NESQUE = K(54)/(GX(4)*GX(15)*X(15)*AH2O**3)
	LANSFORD = K(55)/(GX(4)*GX(15)*X(15)*AH2O**5)
      HYDROMAG = (K(60)/(GX(4)**4*GX(15)**3*X(15)**3*GX(13)**2*X(13)**2
     X*AH2O**3))**0.25
      KPRIME = MIN(MAGNES,NESQUE,LANSFORD,HYDROMAG)
	X(4) = KPRIME
      X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1820
	PHINIT = X(5)
	GO TO 1805
1820	AX(5)=X(5)*GX(5)
	IF(KPRIME.EQ.MAGNES)THEN
		X(25) = K(53)/K(25)
		X(53) = MGT - X(4) - X(25)-X(6)
		X(54) = 0
		X(55) = 0
		X(60) = 0
	END IF
	IF(KPRIME.EQ.NESQUE)THEN
		X(25) = K(54)/(K(25)*AH2O**3)
		X(54) = MGT - X(4) - X(25)-X(6)
		X(53) = 0
		X(55) = 0
		X(60) = 0
	END IF
	IF(KPRIME.EQ.LANSFORD)THEN
		X(25) = K(55)/(AH2O**5*K(25))
		X(55) = MGT - X(4) - X(25)-X(6)
		X(54) = 0
		X(53) = 0
		X(60) = 0
	END IF
	IF(KPRIME.EQ.HYDROMAG)THEN
		X(25) = (GX(4)*X(4)*GX(15)*X(15))/K(25)
		X(60) = (MGT - X(4) - X(25)-X(6))/4.0
		X(54) = 0
		X(55) = 0
		X(53) = 0
	END IF
      IF((X(53).LT.0).OR.(X(54).LT.0).OR.(X(55).LT.0).OR.(X(60).LT.0))
     XTHEN
     		X(4) = MGT
		X(25) = 0
		X(53) = 0
		X(54) = 0
		X(55) = 0
		X(60) = 0
		GO TO 1795
	END IF
1830	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE MGCO3IP
	
C  Subroutine for MGCO3 ionpair equilibrium.

	
	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION MGT,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	MGT = X(4) + X(25)
	CO3T = X(15)+X(25)
	PK = K(25)/(GX(4)*GX(15))
	A = 1.0
	B = -CO3T-MGT-PK
	C = MGT*CO3T
	XX = (-B-SQRT(B**2-4*A*C))/2.0
	X(4) = MGT-XX
	X(15) = CO3T-XX
	X(25) = XX

	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE CACO3IP
	
C  Subroutine for CACO3 ionpair equilibrium.

	
	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION CAT,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	
	CAT = X(3) + X(24)
	CO3T = X(15)+X(24)
	PK = K(24)/(GX(3)*GX(15))
	A = 1.0
	B = -CO3T-CAT-PK
	C = CAT*CO3T
	XX = (-B-SQRT(B**2-4*A*C))/2.0
	X(3) = CAT-XX
	X(15) = CO3T-XX
	X(24) = XX
	
	RETURN
	END
	

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
		SUBROUTINE DOLOMITE
	
C  Subroutine for CaMg(CO3)2 equilibrium and pH calculation.
C  Uses NEWTON-RAPHSON algorithm.  

	
	REAL  IX,I
	INTEGER INDX(4)
	CHARACTER*50 TITLE
	DOUBLE PRECISION CAT,MGT,KPRIME,X,AX,AA,BA,F,DF,DX,H,K,KV
	DOUBLE PRECISION AH2O,PHI
	DOUBLE PRECISION CA,DA,AN(4,4),FN(4),Y(4),K0,EA,BALAN
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

     
	SCAL=1.0
	CAT = X(3)+X(24)+X(61)
	MGT = X(4)+X(25)+X(61)+X(6)
	KPRIME = K(61)/(GX(3)*GX(4)*GX(15)**2*X(15)**2)
	IF (CAT*MGT-KPRIME .GT. 0) GOTO 1900
1890	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
	X(3) = CAT-X(24)
	X(4) = MGT-X(25)-X(6)
	ALK = X(14) + 2*X(15) + 4*X(61)
	X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
	X(15)=(ALK-X(14))/2.0
	X(61) = 0.0
1895	BALAN = X(1) + X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)
     X-X(17)+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      F = BALAN - AA/H - BA/H**2 - CA/H
      DF = AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL CACO3IP
	CALL MGCO3IP
	CALL MGOHIP
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-1,DOLOMITE"
			ALK=X(14)+2*X(15)
			X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
			X(15)=(ALK-X(14))/2.0
			GO TO 1930
		ELSE
			SCAL=0.1
			GOTO 1890
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1895
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1930
	PHINIT = X(5)
	GO TO 1895
1900	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
1905	CALL MGOHIP
	CALL MGCO3IP
	CALL BORON
	CALL FLUORIDE
	Y(1) = X(5)
	Y(2) = X(4)
	Y(3) = X(25)
	Y(4) = X(61)
	X(13) = K(13)*AH2O/(GX(5)*Y(1)*GX(13))
	AA = K(14)*K(29)*AX(29)*GX(29)*AH2O/(GX(5)*GX(14))
	BA = 2*K(15)*K(14)*K(29)*AX(29)*GX(29)*AH2O/(GX(5)**2*GX(15))
	CA = GX(4)*K(15)*K(14)*K(29)*AX(29)*GX(29)*AH2O/(GX(5)**2*K(25))
	DA = 2*K(61)*GX(5)**4/(GX(3)*GX(4)*K(15)**2*K(14)**2
     X*K(29)**2*AX(29)**2*GX(29)**2*AH2O**2)
      EA = GX(3)*K(15)*K(14)*K(29)*AX(29)*GX(29)*AH2O/(GX(5)**2*K(24))
1908  AN(1,1) = 4*DA*Y(1)**3/Y(2) + AA/Y(1)**2 + 2*BA/Y(1)**3
	AN(1,2) = 2.0 - DA*Y(1)**4/Y(2)**2
	AN(1,3) = 0.0
	AN(1,4) = 0.0
	AN(2,1) = 0.0
	AN(2,2) = -1.0
	AN(2,3) = -1.0
	AN(2,4) = -1.0
	AN(3,1) = -2.0*CA*Y(2)/Y(1)**3
	AN(3,2) = CA/Y(1)**2
	AN(3,3) = -1.0
	AN(3,4) = 0.0
	AN(4,1) = -4.0*DA*Y(1)**3/(Y(2)*2.0) - 2.0*EA*DA*Y(1)/(Y(2)*2.0)
	AN(4,2) = DA*Y(1)**4/(2.0*Y(2)**2) + EA*DA*Y(1)**2/(2.0*Y(2)**2)
	AN(4,3) = 0.0
	AN(4,4) = -1.0
	BALAN=X(1)+X(2)-X(11)-2*X(12)+X(6)-X(17)+2*X(7)+X(8)-X(13)
     X+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	FN(1) = BALAN + DA*Y(1)**4/Y(2) + 2*Y(2) - AA/Y(1) - BA/Y(1)**2
	FN(2) = MGT - Y(2) - Y(3) - Y(4)-X(6)
	FN(3) = CA*Y(2)/Y(1)**2 - Y(3)
      FN(4) = CAT-DA*Y(1)**4/(Y(2)*2.0) -EA*DA*Y(1)**2/(2.0*Y(2)) -Y(4)
	DO 1910 II=1,4
		FN(II) = -1.0*FN(II)
1910  CONTINUE
	CALL LUDCMP(AN,4,4,INDX,D)
	CALL LUBKSB(AN,4,4,INDX,FN)
	DO 1912 II=1,4
		Y(II) = Y(II) + FN(II)
1912  CONTINUE
	DO 1914 II=1,4
		PCEN = (FN(II)/Y(II))*1000.0
		PCEN = ABS(PCEN)
		IF(PCEN.GT. 0.1) GO TO 1908
1914  CONTINUE
      IF((Y(1).LT.0).OR.(Y(1).GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-2,DOLOMITE"
			GO TO 1930
		ELSE
			SCAL=0.1
			GOTO 1900
		END IF
	END IF
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*Y(1)*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*Y(1)**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*Y(1)*GX(13))
      X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=Y(1)
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1920
	PHINIT = X(5)
	GO TO 1905
1920	AX(5)=X(5)*GX(5)
	X(4) = Y(2)
	X(25) = Y(3)
      X(61) = Y(4)
	X(3) = DA*Y(1)**4/(Y(2)*2.0)
	X(24) = CAT - X(3) - X(61)
	IF ((X(61).LT.0).OR.(X(3).LT.0).OR.(X(4).LT.0)) THEN
		X(3)=CAT
		X(24)=0
		X(61) = 0
		X(4) = MGT
		X(25) = 0
		GO TO 1890
	ENDIF
	CALL MGOHIP
1930	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
		SUBROUTINE LUDCMP(A,N,NP,INDX,D)
		
C  	THIS SUBROUTINE AND LUBKSB SOLVE THE LINEAR EQUATIONS GENERATED 
C	WITH THE NEWTOM RAPHSON ALGORITHM.  SEE NUMERICAL RECIPES 
C	(P. 35-37 FOR DETAILS).

	PARAMETER (NMAX=4,TINY=1.0E-20)
	DIMENSION INDX(N)
	DOUBLE PRECISION A(NP,NP),VV(NMAX)
	D = 1
	DO 12 I=1,N
		AAMAX=0.0
		DO 11 J=1,N
			IF(ABS(A(I,J)).GT.AAMAX)AAMAX=ABS(A(I,J))
11    	CONTINUE
		IF(AAMAX.EQ.0.0) PAUSE 'SINGULAR MATRIX'
		VV(I) = 1.0/AAMAX
12    CONTINUE
      DO 19 J=1,N
		DO 14 I=1,J-1
			SUM=A(I,J)
			DO 13 K=1,I-1
				SUM=SUM-A(I,K)*A(K,J)
13			CONTINUE
			A(I,J)=SUM
14		CONTINUE
		AAMAX = 0.0
		DO 16 I=J,N
			SUM=A(I,J)
			DO 15 K=1,J-1
				SUM=SUM-A(I,K)*A(K,J)
15    		CONTINUE
		A(I,J)=SUM
		DUM=VV(I)*ABS(SUM)
		IF(DUM.GE.AAMAX) THEN
			IMAX=I
			AAMAX=DUM
		ENDIF
16    	CONTINUE
		IF(J.NE.IMAX)THEN
			DO 17 K=1,N
				DUM=A(IMAX,K)
				A(IMAX,K)=A(J,K)
				A(J,K)=DUM
17    		CONTINUE
		D=-D
		VV(IMAX)=VV(J)
		ENDIF
		INDX(J) = IMAX
		IF(A(J,J).EQ.0.0)A(J,J)=TINY
		IF(J.NE.N)THEN
			DUM=1.0/A(J,J)
			DO 18 I=J+1,N
				A(I,J)=A(I,J)*DUM
18			CONTINUE
      	ENDIF
19 	CONTINUE
	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
		SUBROUTINE LUBKSB(A,N,NP,INDX,B)
		
C  	THIS SUBROUTINE AND LUDCMP SOLVE THE LINEAR EQUATIONS GENERATED 
C	WITH THE NEWTOM RAPHSON ALGORITHM.  SEE NUMERICAL RECIPES 
C	(P. 35-37 FOR DETAILS).

	DIMENSION INDX(N)
	DOUBLE PRECISION A(NP,NP),B(N)
	
	II=0
	DO 12 I=1,N
		LL=INDX(I)
		SUM=B(LL)
		B(LL)=B(I)
		IF(II.NE.0)THEN
			DO 11 J=II,I-1
				SUM=SUM-A(I,J)*B(J)
				
11			CONTINUE
		ELSE IF (SUM.NE.0.0) THEN
			II=I
		ENDIF
		B(I)=SUM
12	CONTINUE
	DO 14 I=N,1,-1
		SUM=B(I)
		IF(I.LT.N)THEN
			DO 13 J=I+1,N
				SUM=SUM-A(I,J)*B(J)
13			CONTINUE
		ENDIF
		B(I)=SUM/A(I,I)
14	CONTINUE
	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	SUBROUTINE NATRON
	
C  Subroutine for sodium bicarbonate-carbonate equilibrium
c  and pH calculation.

	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,KPRIME,X,AX,AA,BA,F,DF,DX,H,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	DOUBLE PRECISION KPRIM1,KPRIM2
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	SCAL=1.0
	NAT = X(1)+2*X(58)+2*X(62)
	KPRIM1 = (K(58)/(GX(1)**2*GX(15)*X(15)*AH2O**10))**0.5
	KPRIM2 = (K(62)/(GX(1)**2*GX(15)*X(15)*AH2O**7))**0.5
	KPRIME = MIN(KPRIM1,KPRIM2)
	IF (NAT-KPRIME .GT. 0) GOTO 1700
1690	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
	X(1) = NAT
	ALK = X(14) + 2*X(15) + 2*X(58) + 2*X(62)
	X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
	X(15)=(ALK-X(14))/2.0
	X(58) = 0.0
	X(62) = 0.0
1695	BALAN = X(1) + X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)
     X-X(17)+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      F = BALAN - AA/H - BA/H**2 - CA/H
      DF = AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-1,NAHCO3"
			ALK=X(14)+2*X(15)
			X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
			X(15)=(ALK-X(14))/2.0
			GO TO 1730
		ELSE
			SCAL=0.1
			GOTO 1690
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1695
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1730
	PHINIT = X(5)
	GO TO 1695
1700	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
1705	BALAN = X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)-X(17)
     X+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
	IF(KPRIME.EQ.KPRIM1) DA=((K(58)*GX(5)**2)/(GX(1)**2*K(14)*K(15)
     X*AH2O**11*AX(29)*GX(29)*K(29)))**0.5
     	IF(KPRIME.EQ.KPRIM2) DA=((K(62)*GX(5)**2)/(GX(1)**2*K(14)*K(15)
     X*AH2O**8*AX(29)*GX(29)*K(29)))**0.5
      F = DA*H + BALAN - AA/H - BA/H**2 - CA/H
      DF = DA + AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-2,NAHCO3"
			GO TO 1730
		ELSE
			SCAL=0.1
			GOTO 1700
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1705
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
      KPRIM1 = (K(58)/(GX(1)**2*GX(15)*X(15)*AH2O**10))**0.5
      KPRIM2 = (K(62)/(GX(1)**2*GX(15)*X(15)*AH2O**7))**0.5
	KPRIME = MIN(KPRIM1,KPRIM2)
	X(1) = KPRIME
      X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1720
	PHINIT = X(5)
	GO TO 1705
1720	AX(5)=X(5)*GX(5)
	IF(KPRIME.EQ.KPRIM1) THEN 
		X(58) = (NAT-KPRIME)/2.0
		X(62) =0.0
	ELSE
		X(62) = (NAT-KPRIME)/2.0
		X(58) = 0.0
	END IF
	IF ((X(58).LT.0).OR.(X(62).LT.0)) THEN
		X(1) = NAT
		X(58) = 0.0
		X(62) = 0.0
		GO TO 1690
	END IF

1730	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
		SUBROUTINE TRONA
	
C  Subroutine for sodium bicarbonate-carbonate equilibrium
C  and pH calculation.

	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,KPRIME,X,AX,AA,BA,F,DF,DX,H,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	SCAL=1.0
	NAT = X(1)+3*X(59)
	KPRIME = (K(59)/(GX(1)**3*GX(14)*X(14)*GX(15)*X(15)*AH2O**2))
     X**0.333333
	IF (NAT-KPRIME .GT. 0) GOTO 1700
1690	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
	X(1) = NAT
	ALK = X(14) + 2*X(15) + 3*X(59)
	X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
	X(15)=(ALK-X(14))/2.0
	X(59) = 0.0
1695	BALAN = X(1) + X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)
     X-X(17)+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      F = BALAN - AA/H - BA/H**2 - CA/H
      DF = AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-1,NAHCO3"
			ALK=X(14)+2*X(15)
			X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
			X(15)=(ALK-X(14))/2.0
			GO TO 1730
		ELSE
			SCAL=0.1
			GOTO 1690
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1695
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1730
	PHINIT = X(5)
	GO TO 1695
1700	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
1705	BALAN = X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)-X(17)
     X+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      DA=((K(59)*GX(5)**3)/(K(14)**2*K(29)**2*
     XAX(29)**2*GX(29)**2*K(15)*AH2O**4*GX(1)**3))**0.333333
      F = DA*H + BALAN - AA/H - BA/H**2 - CA/H
      DF = DA + AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-2,NAHCO3"
			GO TO 1730
		ELSE
			SCAL=0.1
			GOTO 1700
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1705
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	KPRIME = (K(59)/(GX(1)**3*GX(14)*X(14)*GX(15)*X(15)*AH2O**2))
     X**0.333333
	X(1) = KPRIME
      X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1720
	PHINIT = X(5)
	GO TO 1705
1720	AX(5)=X(5)*GX(5)
	X(59) = (NAT-KPRIME)/3.0
	IF(X(59).LT.0) THEN
		X(1) = NAT
		X(59) = 0.0 
		GO TO 1690
	END IF

1730	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	
		SUBROUTINE KHCO3
	
C  Subroutine for potassium bicarbonate-carbonate equilibrium
c  and pH calculation.

	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,KPRIME,X,AX,AA,BA,F,DF,DX,H,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

     
	SCAL=1.0
	KT = X(2)+X(63)
	KPRIME = K(63)/(GX(2)*GX(14)*X(14))
	IF (KT-KPRIME .GT. 0) GOTO 1700
1690	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
	X(2) = KT
	ALK = X(14) + 2*X(15) + X(63)
	X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
	X(15)=(ALK-X(14))/2.0
	X(63) = 0.0
1695	BALAN = X(1) + X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)
     X-X(17)+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      F = BALAN - AA/H - BA/H**2 - CA/H
      DF = AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-1,KHCO3"
			ALK=X(14)+2*X(15)
			X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
			X(15)=(ALK-X(14))/2.0
			GO TO 1730
		ELSE
			SCAL=0.1
			GOTO 1690
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1695
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1730
	PHINIT = X(5)
	GO TO 1695
1700	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
1705	BALAN = X(1) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)-X(17)
     X+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
	DA=K(63)*GX(5)/(GX(2)*K(14)*K(29)*AH2O*AX(29)*GX(29))
      F = DA*H + BALAN - AA/H - BA/H**2 - CA/H
      DF = DA + AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-2,KHCO3"
			GO TO 1730
		ELSE
			SCAL=0.1
			GOTO 1700
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1705
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	KPRIME = K(63)/(GX(2)*GX(14)*X(14))
	X(2) = KPRIME
      X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1720
	PHINIT = X(5)
	GO TO 1705
1720	AX(5)=X(5)*GX(5)
	X(63) = KT-KPRIME
	IF(X(63).LT.0) THEN
		X(2) = KT
		X(63) = 0.0
		GO TO 1690
	END IF

1730	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	SUBROUTINE ACIDITY
	
C SUBROUTINE FOR ESTIMATING THE ACIDITY OF HIGHLY ACID SYSTEMS

	REAL  IX,I,HT
	CHARACTER*50 TITLE
	DOUBLE PRECISION X,AX,AA,BA,CA,DA,F,DF,DX,H,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
	
	SCAL=1.0
	H=X(5)
	IF(H.EQ.0)THEN
		ACID=0
		X(5)=0
		X(13)=0
		GO TO 1620
	END IF
	PHINIT=H
	SO4T=X(12)+X(16)
	BISUL=X(16)
	HT=X(5)+X(16)
											
1595	IF((HT.GT.0.0).AND.(SO4T.GT.0.0)) CALL BISULFATE(SO4T,HT)
	IF(X(20).GT.0)CALL BORON
	IF(X(170).GT.0)CALL FLUORIDE
	CALL PITZER
	BALAN=X(1)+X(2)+2*X(3)+2*X(4)-X(11)-2*X(12)-X(16)-X(17)+X(6)
     X+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)-X(19)+2*X(162)+X(163)-X(165)-X(167)
     X-X(20)-X(170)+2*X(172)-X(16)
	AA = K(23)*AX(23)/(GX(5)*GX(11))
	BA = 2*K(27)*AX(27)/(GX(5)**2*GX(12))
	CA = K(26)*AX(26)/(GX(5)*GX(17))
	DA = K(27)*AX(27)/(K(16)*GX(16)*GX(5))
	F = BALAN + H - (AA+CA+DA)/H - BA/(H**2)
	DF = 1.0 + (AA+CA+DA)/(H**2) + 2*BA/(H**3)
	F = -1.0*F
	DX = F/DF
	H = H+DX*SCAL
	IF(H.EQ.0)THEN
		ACID=0
		X(5)=0
		X(13)=0
		GO TO 1620
	END IF
	IF((H.LT.0).OR.(H.GT.20))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING, ACID",H
			GO TO 1620
		ELSE
			SCAL=0.1
			GOTO 1595
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF(PCEN.GT.1.0) GOTO 1595
	X(5) = H
	X(13)=K(13)*AH2O/(GX(5)*X(5)*GX(13))
	IF(AX(23).GT.0.0)X(11) = AA/H
	IF(AX(27).GT.0.0) THEN
		X(12) = BA/(2*H**2)
		X(16) = DA/H
	END IF
	IF(AX(26).GT.0.0) X(17)=CA/H
	CALL PITZER
	PCEN=(ABS(H-PHINIT))/PHINIT*1000.0
	IF(PCEN.LT.1) GOTO 1610
	PHINIT = X(5)
	GOTO 1595
1610    IF(SO4T.GT.0.0)THEN
		PCEN=(ABS(X(16)-BISUL))/BISUL*1000.0
		IF (PCEN.LT.1.0) GOTO 1620
		BISUL=X(16)
		GOTO 1595
	ENDIF

1620	RETURN
	END
	
C----------------------------------------------------------------------

C----------------------------------------------------------------------
	SUBROUTINE BISULFATE(SO4T,HT)
	
	REAL  IX,I,HT
	CHARACTER*50 TITLE
	DOUBLE PRECISION X,AX,K,KV,K0,A,B,C,XX
	DOUBLE PRECISION AH2O,PHI
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS

      COMMON /T/TITLE
	
	PK=K(16)*GX(16)/(GX(5)*GX(12))
	A=1
	B=-(SO4T+HT+PK)
	C=HT*SO4T
	XX=(-B-SQRT(B**2-4*A*C))/2.0
	X(5)=HT-XX
	X(12) = SO4T-XX
	X(16) = XX
	RETURN
	END
	
C----------------------------------------------------------------------

C----------------------------------------------------------------------

	SUBROUTINE HNO3
	
C  Subroutine for HNO3 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION HT,NO3T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	HT = X(5)+X(66)
	NO3T = X(17)+X(66)
	KPRIME  = K(66)/(GX(5)*GX(17)*AH2O**3)
	IF (HT*NO3T-KPRIME .GT. 0) GOTO 1150
1140	X(5) = HT
	X(17) = NO3T
	X(66) = 0
	GOTO 1180
1150	DECREM = MIN(HT,NO3T)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(5) = HT - DELTA
		X(17) = NO3T - DELTA
		IF ((X(5).LT.0.0).OR.(X(17).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(66)/(GX(5)*GX(17)*AH2O**3)
		IF (X(5)*X(17)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(5) = HT - DELTA
	X(13)=K(13)*AH2O/(GX(5)*X(5)*GX(13))
	X(17) = NO3T - DELTA
	X(66) = DELTA
1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE KNO3
	
C  Subroutine for KNO3 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,NO3T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KT = X(2)+X(67)
	NO3T = X(17)+X(67)
	KPRIME  = K(67)/(GX(2)*GX(17))
	IF (KT*NO3T-KPRIME .GT. 0) GOTO 1150
1140	X(2) = KT
	X(17) = NO3T
	X(67) = 0
	GOTO 1180
1150	DECREM = MIN(KT,NO3T)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(2) = KT - DELTA
		X(17) = NO3T - DELTA
		IF ((X(2).LT.0.0).OR.(X(17).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(67)/(GX(2)*GX(17))
		IF (X(2)*X(17)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(2) = KT - DELTA
	X(17) = NO3T - DELTA
	X(67) = DELTA
1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE NANO3
	
C  Subroutine for NANO3 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,NO3T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	NAT = X(1)+X(68)
	NO3T = X(17)+X(68)
	KPRIME  = K(68)/(GX(1)*GX(17))
	IF (NAT*NO3T-KPRIME .GT. 0) GOTO 1150
1140	X(1) = NAT
	X(17) = NO3T
	X(68) = 0
	GOTO 1180
1150	DECREM = MIN(NAT,NO3T)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(1) = NAT - DELTA
		X(17) = NO3T - DELTA
		IF ((X(1).LT.0.0).OR.(X(17).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(68)/(GX(1)*GX(17))
		IF (X(1)*X(17)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(1) = NAT - DELTA
	X(17) = NO3T - DELTA
	X(68) = DELTA
1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE H2SO4
			
C  Subroutine for H2S04 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION HT,SO4T,KPRIME,X,DELTA,AX,K,KPRIM1,KPRIM2,KV,K0
     	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	HT = X(5)+2*X(70)+2*X(71)
	SO4T = X(12)+X(70)+X(71)
	KPRIM1=K(70)/(GX(5)**2*GX(12)*AH2O**6.5)
	KPRIM2=K(71)/(GX(5)**2*GX(12)*AH2O**4)
	KPRIME  = MIN(KPRIM1,KPRIM2)
	IF (HT**2*SO4T-KPRIME .GT. 0) GOTO 1150
1140	X(5) = HT
	X(12) = SO4T
	X(70) = 0
	X(71) = 0
	GOTO 1180
1150	DECREM = MIN(HT,SO4T)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(5) = HT - 2*DELTA
		X(12) = SO4T - DELTA
		IF ((X(5).LT.0.0).OR.(X(12).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIM1=K(70)/(GX(5)**2*GX(12)*AH2O**6.5)
		KPRIM2=K(71)/(GX(5)**2*GX(12)*AH2O**4)
		KPRIME  = MIN(KPRIM1,KPRIM2)
		IF (X(5)**2*X(12)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(5) = HT - 2*DELTA
	X(12) = SO4T - DELTA
	X(13)=K(13)*AH2O/(GX(5)*X(5)*GX(13))
	IF(KPRIM1.LT.KPRIM2) THEN
		X(70) = DELTA
		X(71) = 0
	ELSE
		X(71) = DELTA
		X(70) = 0
	ENDIF
1180	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	SUBROUTINE HCL
	
C  Subroutine for HCL equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION HT,CLT,KPRIME,X,DELTA,AX,K,KPRIM1,KPRIM2,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	HT = X(5)+X(69)+X(72)
	CLT = X(11)+X(69)+X(72)
	KPRIM1  = K(69)/(GX(5)*GX(11)*AH2O**3)
	KPRIM2  = K(72)/(GX(5)*GX(11)*AH2O**6)
	KPRIME=MIN(KPRIM1,KPRIM2)
	IF (HT*CLT-KPRIME .GT. 0) GOTO 1150
1140	X(5) = HT
	X(11) = CLT
	X(69) = 0
	X(72) = 0
	GOTO 1180
1150	DECREM = MIN(HT,CLT)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(5) = HT - DELTA
		X(11) = CLT - DELTA
		IF ((X(5).LT.0.0).OR.(X(11).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIM1  = K(69)/(GX(5)*GX(11)*AH2O**3)
		KPRIM2  = K(72)/(GX(5)*GX(11)*AH2O**6)
		KPRIME=MIN(KPRIM1,KPRIM2)
		IF (X(5)*X(11)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(5) = HT - DELTA
	X(11) = CLT - DELTA
	X(13)=K(13)*AH2O/(GX(5)*X(5)*GX(13))
	IF(KPRIM1.LT.KPRIM2)THEN
		X(69) = DELTA
		X(72) = 0
	ELSE
		X(72) = DELTA
		X(69) = 0
	ENDIF
1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE MGOHIP
	
C  Subroutine for MGOH ionPBir equilibrium.

	
	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION MGT,KIONPR,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	
	KIONPR = (K(6)*GX(4)*AH2O)/(GX(6)*GX(5)*X(5))
	MGT=X(4)+X(6)
	X(4) = MGT/(KIONPR + 1)
	X(6) = MGT - X(4)
	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE NA3H
	
C  Subroutine for NA3H(SO4)2 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,SO4T,KPRIME,X,DELTA,AX,K,HT,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	NAT = X(1)+3*X(74)
	SO4T = X(12)+2*X(74)
	HT = X(5)+X(74)
	KPRIME  = K(74)/(GX(1)**3*GX(12)**2*GX(5))
	IF (NAT**3*SO4T**2*HT-KPRIME .GT. 0) GOTO 1150
1140	X(1) = NAT
	X(12) = SO4T
	X(5) = HT
	X(74) = 0
	GOTO 1180
1150	DECREM = MIN(NAT,SO4T,HT)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(1) = NAT - 3*DELTA
		X(12) = SO4T - 2*DELTA
		X(5) = HT-DELTA
	IF ((X(1).LT.0.0).OR.(X(12).LT.0.0).OR.(X(5).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(74)/(GX(1)**3*GX(12)**2*GX(5))
		IF (X(1)**3*X(12)**2*X(5)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(1) = NAT - 3*DELTA
	X(12) = SO4T - 2*DELTA
	X(5) = HT-DELTA
	X(74) = DELTA
1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE NAHSO4
	
C  Subroutine for NAHSO4.H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,HSO4T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	NAT = X(1)+X(75)
	HSO4T = X(16)+X(75)
	KPRIME  = K(75)/(GX(1)*GX(16)*AH2O)
	IF (NAT*HSO4T-KPRIME .GT. 0) GOTO 1150
1140	X(1) = NAT
	X(16) = HSO4T
	X(75) = 0
	GOTO 1180
1150	DECREM = MIN(NAT,HSO4T)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(1) = NAT - DELTA
		X(16) = HSO4T - DELTA
		IF ((X(1).LT.0.0).OR.(X(16).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(75)/(GX(1)*GX(16)*AH2O)
		IF (X(1)*X(16)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(1) = NAT - DELTA
	X(16) = HSO4T - DELTA
	X(75) = DELTA
1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE KHSO4
	
C  Subroutine for KHSO4 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,HSO4T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KT = X(2)+X(79)
	HSO4T = X(16)+X(79)
	KPRIME  = K(79)/(GX(2)*GX(16))
	IF (KT*HSO4T-KPRIME .GT. 0) GOTO 1150
1140	X(2) = KT
	X(16) = HSO4T
	X(79) = 0
	GOTO 1180
1150	DECREM = MIN(KT,HSO4T)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(2) = KT - DELTA
		X(16) = HSO4T - DELTA
		IF ((X(2).LT.0.0).OR.(X(16).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(79)/(GX(2)*GX(16))
		IF (X(2)*X(16)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(2) = KT - DELTA
	X(16) = HSO4T - DELTA
	X(79) = DELTA
1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	SUBROUTINE K3H
	
C  Subroutine for K3H(SO4)2 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,SO4T,KPRIME,X,DELTA,AX,K,HT,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KT = X(2)+3*X(76)
	SO4T = X(12)+2*X(76)
	HT = X(5)+X(76)
	KPRIME  = K(76)/(GX(2)**3*GX(12)**2*GX(5))
	IF (KT**3*SO4T**2*HT-KPRIME .GT. 0) GOTO 1150
1140	X(2) = KT
	X(12) = SO4T
	X(5) = HT
	X(76) = 0
	GOTO 1180
1150	DECREM = MIN(KT,SO4T,HT)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(2) = KT - 3*DELTA
		X(12) = SO4T - 2*DELTA
		X(5) = HT-DELTA
	IF ((X(2).LT.0.0).OR.(X(12).LT.0.0).OR.(X(5).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(76)/(GX(2)**3*GX(12)**2*GX(5))
		IF (X(2)**3*X(12)**2*X(5)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(2) = KT - 3*DELTA
	X(12) = SO4T - 2*DELTA
	X(5) = HT-DELTA
	X(76) = DELTA
1180	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	SUBROUTINE K5H3
	
C  Subroutine for K5H3(SO4)4 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,SO4T,KPRIME,X,DELTA,AX,K,HT,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KT = X(2)+5*X(77)
	SO4T = X(12)+4*X(77)
	HT = X(5)+3*X(77)
	KPRIME  = K(77)/(GX(2)**5*GX(12)**4*GX(5)**3)
	IF (KT**5*SO4T**4*HT**3-KPRIME .GT. 0) GOTO 1150
1140	X(2) = KT
	X(12) = SO4T
	X(5) = HT
	X(77) = 0
	GOTO 1180
1150	DECREM = MIN(KT,SO4T,HT)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(2) = KT - 5*DELTA
		X(12) = SO4T - 4*DELTA
		X(5) = HT-3*DELTA
	IF ((X(2).LT.0.0).OR.(X(12).LT.0.0).OR.(X(5).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(77)/(GX(2)**5*GX(12)**4*GX(5)**3)
		IF (X(2)**5*X(12)**4*X(5)**3-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(2) = KT - 5*DELTA
	X(12) = SO4T - 4*DELTA
	X(5) = HT-3*DELTA
	X(77) = DELTA
1180	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	SUBROUTINE K8H6
	
C  Subroutine for K8H6(SO4)7.H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,SO4T,KPRIME,X,DELTA,AX,K,HT,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KT = X(2)+8*X(78)
	SO4T = X(12)+7*X(78)
	HT = X(5)+6*X(78)
	KPRIME  = K(78)/(GX(2)**8*GX(12)**7*GX(5)**6*AH2O )
	IF (KT**8*SO4T**7*HT**6-KPRIME .GT. 0) GOTO 1150
1140	X(2) = KT
	X(12) = SO4T
	X(5) = HT
	X(78) = 0
	GOTO 1180
1150	DECREM = MIN(KT,SO4T,HT)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(2) = KT - 8*DELTA
		X(12) = SO4T - 7*DELTA
		X(5) = HT-6*DELTA
	IF ((X(2).LT.0.0).OR.(X(12).LT.0.0).OR.(X(5).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(78)/(GX(2)**8*GX(12)**7*GX(5)**6*AH2O)
		IF (X(2)**8*X(12)**7*X(5)**6-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(2) = KT - 8*DELTA
	X(12) = SO4T - 7*DELTA
	X(5) = HT-6*DELTA
	X(78) = DELTA
1180	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------


	SUBROUTINE DARAP
	
C  Subroutine for NANO3.NA2SO4.2H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,SO4T,NO3T,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	NAT = X(1)+3*X(73)
	SO4T = X(12)+X(73)
	NO3T = X(17)+X(73)
	KPRIME  = K(73)/(GX(1)**3*GX(12)*GX(17)*AH2O**2)
	IF (NAT**3*SO4T*NO3T-KPRIME .GT. 0) GOTO 1150
1140	X(1) = NAT
	X(12) = SO4T
	X(17) = NO3T
	X(73) = 0
	GOTO 1180
1150	DECREM = MIN(NAT,SO4T,NO3T)
	DO 1170 KA = 2, 5
1160		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1140
		X(1) = NAT - 3*DELTA
		X(12) = SO4T - DELTA
		X(17) = NO3T-DELTA
	IF ((X(1).LT.0.0).OR.(X(12).LT.0.0).OR.(X(17).LT.0.0)) GOTO 1169
	CALL PITZER
		KPRIME  = K(73)/(GX(1)**3*GX(12)*GX(17)*AH2O**2)
		IF (X(1)**3*X(12)*X(17)-KPRIME .GT. 0) GOTO 1160
1169		DELTA = DELTA - DECREM*(DEL(KA)-1)
1170	CONTINUE
	X(1) = NAT - 3*DELTA
	X(12) = SO4T - DELTA
	X(17) = NO3T-DELTA
	X(73) = DELTA
1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FESO4

C  Subroutine for FESO4 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	FET = X(7)+X(81)+X(82)+X(105)
	SO4T = X(12)+X(81)+X(82)+X(105)
	FE7 = K(81)/AH2O**7
	FE4 = K(105)/AH2O**4
	FE1 = K(82)/AH2O
	IF ((FE7 .LT. FE1).AND.(FE7.LT.FE4)) THEN
		KPRIME = K(81)/(GX(7)*GX(12)*AH2O**7)
		GO TO 1280
	END IF
	IF ((FE1.LT.FE4).AND.(FE1.LT.FE7)) THEN
		KPRIME = K(82)/(GX(7)*GX(12)*AH2O)
		GO TO 1280
	ELSE
		KPRIME = K(105)/(GX(7)*GX(12)*AH2O**4)
	END IF
1280	IF (FET*SO4T-KPRIME .GT. 0) GOTO 1285
1282  X(7) = FET
	X(12) = SO4T
	X(81) = 0
	X(82) = 0
	X(105) = 0
	GO TO 1330
1285	DECREM = MIN(FET,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(7) = FET - DELTA
		X(12) = SO4T - DELTA
		IF((X(7).LT.0.).OR.(X(12).LT.0.))GOTO 1319
		CALL PITZER
		FE7 = K(81)/AH2O**7
		FE4 = K(105)/AH2O**4
		FE1 = K(82)/AH2O
		IF ((FE7 .LT. FE1).AND.(FE7.LT.FE4)) THEN
			KPRIME = K(81)/(GX(7)*GX(12)*AH2O**7)
			GO TO 1300
		END IF
		IF ((FE1.LT.FE4).AND.(FE1.LT.FE7)) THEN
			KPRIME = K(82)/(GX(7)*GX(12)*AH2O)
			GO TO 1300
		ELSE
			KPRIME = K(105)/(GX(7)*GX(12)*AH2O**4)
		END IF
1300		IF (X(7)*X(12)-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(7) = FET - DELTA
	X(12) = SO4T - DELTA
	IF ((FE7 .LT. FE1).AND.(FE7.LT.FE4)) THEN
		X(81) = DELTA
		X(82) = 0
		X(105) = 0
		GO TO 1330
	END IF
	IF((FE1.LT.FE4).AND.(FE1.LT.FE7))THEN
		X(82) = DELTA
		X(81) = 0
		X(105) = 0
	ELSE
		X(105) = DELTA
		X(81) = 0
		X(82) = 0
	END IF
1330	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FECL2
	
C  Subroutine for FeCl2 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,CLT,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	FE6 = K(83)/AH2O**6
	FE4 = K(84)/AH2O**4
	FET = X(7) + X(83) + X(84)
	CLT = X(11) + 2*X(83) + 2*X(84)
	IF (FE6 .GT. FE4) KPRIME = K(84)/(GX(7)*(GX(11))**2*AH2O**4)
      IF (FE4 .GT. FE6) KPRIME = K(83)/(GX(7)*(GX(11))**2*AH2O**6)
	IF (FET*(CLT)**2-KPRIME .GT. 0) GOTO 860
855	X(7) = FET
	X(11) = CLT
	X(83) = 0
	X(84) = 0
	GOTO 880
860	DECREM = MIN(FET,CLT)
	DO 870 KA = 2, 5
865		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 855
		X(7) = FET - DELTA
		X(11) = CLT - 2*DELTA
		IF ((X(7).LT.0.0).OR.(X(11).LT.0.0)) GOTO 869
	CALL PITZER
		FE6 = K(83)/AH2O**6
		FE4 = K(84)/AH2O**4
	IF (FE6 .GT. FE4) KPRIME = K(84)/(GX(7)*(GX(11))**2*AH2O**4)
      	IF (FE4 .GT. FE6) KPRIME = K(83)/(GX(7)*(GX(11))**2*AH2O**6)
     		IF (X(7)*(X(11))**2-KPRIME .GT. 0) GOTO 865
869		DELTA = DELTA-DECREM*(DEL(KA)-1)
870	CONTINUE
	X(7) = FET - DELTA
	X(11) = CLT - 2*DELTA
	IF (FE6 .GT. FE4) THEN
		X(84) = DELTA
		X(83) = 0
	ELSE
		X(83) = DELTA
		X(84) = 0
	END IF
880	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------


	SUBROUTINE FECO3
	
C  Subroutine for FeCO3 equilibrium and pH calculation.
	
	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,KPRIME,X,AX,AA,BA,DA,F,DF,DX,H,K,KV
     X,K0
     	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
      
	
	SCAL=1.0
	FET = X(7)+X(8)+X(22)+X(85)
	KPRIME = K(85)/(GX(7)*GX(15)*X(15))
	IF (FET-KPRIME .GT. 0) GOTO 1600
1590	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
	X(7) = FET-X(22)-X(8)
	ALK = X(14) + 2*X(15) + 2*X(85)
	X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
	X(15)=(ALK-X(14))/2.0
	X(85) = 0.0
1595	BALAN = X(1) + X(2) + 2*X(3) + 2*X(4) - X(11) -2*X(12)+X(6)
     X-X(17)+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
      F = BALAN - AA/H - BA/H**2 - CA/H
      DF = AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	X(5) = H
	CALL FECO3IP
	CALL FEOHIP
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-1,FECO3"
			ALK=X(14)+2*X(15)
			X(14)=ALK/(1.0+(2*K(15)*GX(14))/(AX(5)*GX(15)))
			X(15)=(ALK-X(14))/2.0
			GO TO 1630
		ELSE
			SCAL=0.1
			GOTO 1590
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1595
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1630
	PHINIT = X(5)
	GO TO 1595
1600	PHINIT=AX(5)/GX(5)
	H=AX(5)/GX(5)
	X(5)=AX(5)/GX(5)
1605	BALAN = X(1) + X(2) + 2*X(3)+2*X(4) - X(11) -2*X(12)+X(6)-X(17)
     X+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	AA = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*GX(14))
	BA = 2*K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*GX(15))
	CA = K(13)*AH2O/(GX(13)*GX(5))
	DA = 2*K(85)*GX(5)**2/(GX(7)*K(15)*K(14)*AH2O*K(29)
     X*AX(29)*GX(29))
      F = DA*H**2 + BALAN - AA/H - BA/H**2 - CA/H
      DF = 2*DA*H + AA/H**2 + 2*BA/(H**3) + CA/H**2
	F=-1.0*F
	DX = F/DF
	H = H + DX*SCAL
	X(5) = H
	CALL FEOHIP
	CALL FECO3IP
	CALL BORON
	CALL FLUORIDE
      IF((H.LT.0).OR.(H.GT.10))THEN
		IF(SCAL.EQ.0.1) THEN
		WRITE(2,*)"THE H ROUTINE IS NOT CONVERGING-2,FECO3"
			GO TO 1630
		ELSE
			SCAL=0.1
			GOTO 1600
		END IF
	END IF
	PCEN = ABS(DX/H)*1000.0
	IF (PCEN.GT.0.1) GO TO 1605
	X(14) = K(14)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)*H*GX(14))
	X(15)=K(14)*K(15)*K(29)*AH2O*AX(29)*GX(29)/(GX(5)**2*H**2
     X*GX(15))
	X(13) = K(13)*AH2O/(GX(5)*H*GX(13))
	KPRIME = K(85)/(GX(7)*GX(15)*X(15))
	X(7) = KPRIME
      X(21) = K(29)*AX(29)*GX(29)/(GX(21))
	X(5)=H
	AX(5)=X(5)*GX(5)
	CALL PITZER
	PCEN = (ABS(H-PHINIT)/PHINIT)*1000.0
	IF(PCEN.LT.0.1) GO TO 1620
	PHINIT = X(5)
	GO TO 1605
1620	AX(5)=X(5)*GX(5)
	AX(13) = X(13)*GX(13)
	PH = -LOG10(AX(5))
      	X(22) = K(85)/K(22)
	X(85) = FET-X(7)-X(22)-X(8)
        IF (X(85).LT.0) THEN
		X(7)=FET
		X(22)=0
		X(8) = 0
		X(85) = 0
		GO TO 1590
	END IF
1630	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FEOHIP
	
C  Subroutine for FEOH ionPBir equilibrium.

	
	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,KIONPR,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	
	KIONPR = (K(8)*GX(7)*AH2O)/(GX(8)*GX(5)*X(5))
	FET=X(7)+X(8)
	X(7) = FET/(KIONPR + 1)
	X(8) = FET - X(7)
	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FECO3IP
	
C  Subroutine for FECO3 ionPBir equilibrium.

	
	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	
	FET = X(7) + X(22)
	CO3T = X(15)+X(22)
	PK = K(22)/(GX(7)*GX(15))
	A = 1.0
	B = -CO3T-FET-PK
	C = FET*CO3T
	XX = (-B-SQRT(B**2-4*A*C))/2.0
	X(7) = FET-XX
	X(15) = CO3T-XX
	X(22) = XX	

	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FEOH3(ALK)
	
C  Subroutine for FE(OH)3 (redox reaction) equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,KPRIME,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	FET = X(7)+X(8)+X(86)+X(156)+X(157)
	KPRIME  = K(86)*AH2O**10*(GX(7)*FET)**4/(GX(5)*X(5))**8
	KPRIME = 1.0/KPRIME
	IF (AX(151)-KPRIME .GT. 0) GOTO 1150
	CALL FEOHIP
	X(86) = 0
	GOTO 1180
1150	X(7) = 0.0
	X(8) = 0.0
	X(156) = 0.0
	X(157) = 0.0
	X(9) = FET+X(9)

1180	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------


	SUBROUTINE ICE
	
	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION M,MO,H2O,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      	COMMON /T/TITLE


		
		MO = 0
		M = 0
		IF(NCAR.EQ.1)THEN
			H2O = X(30) + X(31) + (X(87)+X(88))*6*18.01528
			NUMBER=131
		ELSE
			H2O = X(30) + X(31)
			NUMBER=131
		END IF
		DO 10 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0)) MO = MO + X(J)
			IF((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 10
			MO = MO + X(J)
10		CONTINUE
		MO=MO+X(152)
		DO 15 J=155,172
			MO=MO+X(J)
15		CONTINUE
		IF (AH2O.GT.K(31)) THEN
		DO 70 KA = 1, 5
20			DO 30 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 30
			X(J) = X(J) * DEL(KA)
30			CONTINUE
			DO 35 J = 152,172
				IF((J.EQ.153).OR.(J.EQ.154))GO TO 35
				X(J)=X(J)*DEL(KA)
35			CONTINUE
			DO 40 J = 32, NUMBER
		IF((NCAR.EQ.2).AND.(J.EQ.87).OR.(J.EQ.88))GO TO 40
				X(J) = X(J) * DEL(KA)
40			CONTINUE
			CALL PITZER
			IF (AH2O .GT. K(31)) GOTO 20
			DO 50 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)/DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 50
			X(J) = X(J) / DEL(KA)
50			CONTINUE
			DO 55 J = 152,172
				IF((J.EQ.153).OR.(J.EQ.154))GO TO 55
				X(J)=X(J)/DEL(KA)
55			CONTINUE
			DO 60 J = 32, NUMBER
		IF((NCAR.EQ.2).AND.(J.EQ.87).OR.(J.EQ.88))GO TO 60
				X(J) = X(J)/DEL(KA)
60			CONTINUE
70		CONTINUE
		
		ELSE
		
		DO 170 KA = 1, 5
120			DO 130 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)/DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 130
			X(J) = X(J) / DEL(KA)
130			CONTINUE
			DO 135 J = 152,172
				IF((J.EQ.153).OR.(J.EQ.154))GO TO 135
				X(J)=X(J)/DEL(KA)
135			CONTINUE
			DO 140 J = 32, NUMBER
		IF((NCAR.EQ.2).AND.(J.EQ.87).OR.(J.EQ.88))GO TO 140
				X(J) = X(J)/DEL(KA)
140			CONTINUE
			CALL PITZER
			IF (K(31) .GT. AH2O) GOTO 120
			DO 150 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 150
			X(J) = X(J) * DEL(KA)
150			CONTINUE
			DO 155 J = 152,172
				IF((J.EQ.153).OR.(J.EQ.154))GO TO 155
				X(J)=X(J)*DEL(KA)
155			CONTINUE
			DO 160 J = 32, NUMBER
		IF((NCAR.EQ.2).AND.(J.EQ.87).OR.(J.EQ.88))GO TO 160
				X(J) = X(J) * DEL(KA)
160			CONTINUE
170		CONTINUE
		ENDIF
		
		DO 80 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))M=M+X(J)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GO TO 80
			M = M + X(J)
80		CONTINUE
		M=M+X(152)
		DO 175 J=155,172
			M=M+X(J)
175		CONTINUE
		X(30) = X(30) * MO / M
		X(31) = H2O - X(30)
		IF(X(31).LT.0.0) THEN
			DO 180 J = 1, 25
		IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*X(30)/H2O
		IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 180
			X(J) = X(J) *X(30)/H2O
180			CONTINUE
			X(152)=X(152)*X(30)/H2O
			DO 185 J=155,172
				X(J)=X(J)*X(30)/H2O
185			CONTINUE
			DO 190 J = 32, NUMBER
				X(J) = X(J) *X(30)/H2O
190			CONTINUE
			X(30) = H2O
			X(31) = 0.0
		END IF
	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE CO26H2O(EQAH2O)
	
	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION M,MO,H2O,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      	COMMON /T/TITLE
	
		IF(NCAR.EQ.2) THEN
			X(87)=TCAR
			K(87) = 999.9
			KV(87) = 999.9
			CO2MF=0.00
			AX(29)=0.0
			AX(21)=0.0
			X(21)=0.0
			X(29)=0.0
			X(30)=X(30)-X(87)*6*18.01528
			DELGM=X(87)*6*18.01528
		IF(MIX.EQ.0)GO TO 210
			X(88)=TMET
			K(88) = 999.8
			KV(88) = 999.8
			CH4MF=0.0
			AX(155)=0.0
			AX(154) = 0.0
			X(154)=0.0
			X(155)=0.0
			X(30)=X(30)-X(88)*6*18.01528
			DELGM=X(88)*6*18.01528
210	DO 220 J = 1, 25
	IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*(X(30)+DELGM)/X(30)
	IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GO TO 220
	X(J) = X(J) * (X(30) + DELGM) / X(30)
220	CONTINUE
	DO 230 J = 32, 131
		IF((J.EQ.87).OR.(J.EQ.88))GO TO 230
		X(J) = X(J) * (X(30) + DELGM) / X(30)
230	CONTINUE
			GO TO 200
		END IF
		
		MO = 0
		M = 0
		H2O = X(30)+6*(X(87)+X(88))*18.01528 + X(31)
		X(31) = 0.0
		X(88) = 0.0
		DO 10 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0)) MO = MO + X(J)
			IF((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 10
			MO = MO + X(J)
10		CONTINUE
		MO=MO+X(152)
		DO 15 J=155,172
			MO=MO+X(J)
15		CONTINUE
		IF (AH2O.GT.EQAH2O) THEN
		DO 70 KA = 1, 5
20			DO 30 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 30
			X(J) = X(J) * DEL(KA)
30			CONTINUE
			X(152)=X(152)*DEL(KA)
			DO 35 J=155,172
				X(J)=X(J)*DEL(KA)
35			CONTINUE
			DO 40 J = 32, 131
				X(J) = X(J) * DEL(KA)
40			CONTINUE

			CALL PITZER
			IF (AH2O .GT. EQAH2O) GOTO 20
			DET = ABS(AH2O-EQAH2O)
			IF(DET.LT.0.000001)GOTO 70
			DO 50 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)/DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 50
			X(J) = X(J) / DEL(KA)
50			CONTINUE
			X(152)=X(152)/DEL(KA)
			DO 55 J=155,172
				X(J)=X(J)/DEL(KA)
55			CONTINUE
			DO 60 J = 32, 131
				X(J) = X(J) / DEL(KA)
60			CONTINUE
70		CONTINUE
		
		ELSE
		
		DO 170 KA = 1, 5
120			DO 130 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)/DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 130
			X(J) = X(J) / DEL(KA)
130			CONTINUE
			X(152)=X(152)/DEL(KA)
			DO 135 J=155,172
				X(J)=X(J)/DEL(KA)
135			CONTINUE
			DO 140 J = 32, 131
				X(J) = X(J) / DEL(KA)
140			CONTINUE
			CALL PITZER
			IF (EQAH2O .GT. AH2O) GOTO 120
			DO 150 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 150
			X(J) = X(J) * DEL(KA)
150			CONTINUE
			X(152)=X(152)*DEL(KA)
			DO 155 J=155,167
				X(J)=X(J)*DEL(KA)
155			CONTINUE
			DO 160 J = 32, 131
				X(J) = X(J) * DEL(KA)
160			CONTINUE
170		CONTINUE
		ENDIF
		
		DO 80 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))M=M+X(J)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GO TO 80
			M = M + X(J)
80		CONTINUE
		M=M+X(152)
		DO 175 J=155,172
			M=M+X(J)
175		CONTINUE
		X(30) = X(30) * MO / M
		X(87) = (H2O - X(30))/(6.0*18.01528)
		IF(X(87).LT.0.0) THEN
			DO 180 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*X(30)/H2O
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 180
			X(J) = X(J) *X(30)/H2O
180			CONTINUE
			X(152)=X(152)*X(30)/H2O
			DO 185	J=155,167
				X(J)=X(J)*X(30)/H2O
185			CONTINUE
			DO 190 J = 32, 131
				X(J) = X(J) *X(30)/H2O
190			CONTINUE
			X(30) = H2O
			X(87) = 0.0
		END IF
200	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	SUBROUTINE GAS(J,PB,T,FI,Z)
	
C  THIS SUBROUTINE CALCULATES THE FUGACITY COEFFICIENT FOR GASES.
	
	DOUBLE PRECISION A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12
        DOUBLE PRECISION ALPHA,BETA,GAMMA
     	REAL TOL,X1,X2,FUNC
	EXTERNAL FUNC
	COMMON /C/ALPHA,BETA,GAMMA,PR,TR,B,C,D,E,F
    
	IF(J.EQ.28) THEN
		TC=647.25
		PC=221.19
		A1=8.6444922D-2
		A2=-3.96918955D-1
		A3=-5.73334886D-2
		A4=-2.93893D-4
		A5=-4.15775512D-3
		A6=1.99496791D-2
		A7=1.18901426D-4
		A8=1.55212063D-4
		A9=-1.06855859D-4
		A10=-4.93197687D-6
		A11=-2.73739155D-6
		A12=2.65571238D-6
		ALPHA=8.96079018D-3
		BETA=4.02
		GAMMA=2.57D-2
	END IF
	IF(J.EQ.29) THEN
		TC=304.20
		PC=73.825
		A1=8.99288497D-2
		A2=-4.94783127D-1
		A3=4.77922245D-2
		A4=1.03808883D-2
		A5=-2.82516861D-2
		A6=9.49887563D-2
		A7=5.20600880D-4
		A8=-2.93540971D-4
		A9=-1.77265112D-3
		A10=-2.51101973D-5
		A11=8.93353441D-5
		A12=7.88998563D-5
		ALPHA=-1.66727022D-2
		BETA=1.398D0
		GAMMA=2.96D-2
	END IF
	IF(J.EQ.154) THEN
		TC=190.60
		PC=46.41
		A1=8.72553928D-2
		A2=-7.52599476D-1
		A3=3.75419887D-1
		A4=1.07291342D-2
		A5=5.49626360D-3
		A6=-1.84772802D-2
		A7=3.18993183D-4
		A8=2.11079375D-4
		A9=2.01682801D-5
		A10=-1.65606189D-5
		A11=1.19614546D-4
		A12=-1.08087289D-4
		ALPHA=4.48262295D-2
		BETA=7.5397D-1
		GAMMA=7.7167D-2
	END IF
	PR=PB/PC
	TR=T/TC
	B=A1+A2/TR**2+A3/TR**3
	C=A4+A5/TR**2+A6/TR**3
	D=A7+A8/TR**2+A9/TR**3
	E=A10+A11/TR**2+A12/TR**3
	F=ALPHA/TR**3
	X1=(TR/PR)*0.001
	X2=(TR/PR)*1000
	TOL = 0.00001

	CALL ZBRENT(FUNC,X1,X2,TOL,ANS)
	
	VR=ANS
	Z=PR*VR/TR
	G=(F/(2*GAMMA))*(BETA+1-(BETA+1+GAMMA/(VR**2))*EXP(-GAMMA/
     XVR**2))
     	FI=EXP(Z-1.0-LOG(Z)+B/VR+C/(2*VR**2)+D/(4*VR**4)+E/(5*VR**5)+G)
	R=0.08314467
	VC=R*TC/PC
	V=VR*VC
	SUM1=B/VR
	SUM2=C/VR**2
	SUM3=D/VR**4
	SUM4=E/VR**5
	SUM5=(F/VR**2)*(BETA+GAMMA/VR**2)*EXP(-GAMMA/VR**2)
	SUM=1.0+B/VR+C/VR**2+D/VR**4+E/VR**5
     X+(F/VR**2)*(BETA+GAMMA/VR**2)*EXP(-GAMMA/VR**2)
     	SUMSUM=1.0+SUM1+SUM2+SUM3+SUM4+SUM5
	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	SUBROUTINE ZBRENT(FUNC,X1,X2,TOL,ANS)
C THIS VERSION OF BRENT MOSTLY WORKS OK, BUT OCCASIONALLY FAILS TO 
C CONVERGE PROPERLY.  SEE P. 354-355 IN PRESS ET AL., 1992.
	
C  THIS SUBROUTINE FINDS THE ROOT OF AN EQUATION.  

	INTEGER ITMAX
	REAL TOL,X1,X2,FUNC,EPS
	EXTERNAL FUNC
	PARAMETER (ITMAX=100,EPS=3.0E-8)
	INTEGER ITER
	REAL A,B,C,D,E,FA,FB,FC,P,Q,R,S,TOL1,XM
	A=X1
	B=X2
	FA=FUNC(A)
	FB=FUNC(B)

	IF(((FA.GT.0.).AND.(FB.GT.0.)).OR.((FA.LT.0.).AND.(FB.LT.0.)))
     X		PAUSE 'ROOT MUST BE BRACKETED FOR ZBRENT'
     	C=B
	FC=FB
	DO 11 ITER=1,ITMAX
	IF(((FB.GT.0.).AND.(FC.GT.0.)).OR.((FB.LT.0.).AND.(FC.LT.0.)))
     XTHEN 
     			C=A
			FC=FA
			D=B-A
			E=D
		END IF
		IF(ABS(FC).LT.ABS(FB)) THEN
			A=B
			B=C
			C=A
			FA=FB
			FB=FC
			FC=FA
		END IF

		TOL1=2.0*EPS*ABS(B)+0.5*TOL
		XM=0.5*(C-B)
		IF(ABS(XM).LE.TOL1.OR.FB.EQ.0.0) THEN
			ANS=B
			RETURN
		END IF
		IF(ABS(E).GE.TOL1.AND.ABS(FA).GT.ABS(FB)) THEN
			S=FB/FA
			IF(A.EQ.C) THEN
				P=2.0*XM*S
				Q=1.0-S
			ELSE
				Q=FA/FC
				R=FB/FC
				P=S*(2.0*XM*Q*(Q-R)-(B-A)*(R-1.0))
				Q=(Q-1.0)*(R-1.0)*(S-1.0)
			END IF
			IF(P.GT.0.0)Q=-Q
			P=ABS(P)
			Z=3.0*XM*Q-ABS(TOL1*Q)
			Y=ABS(E*Q)
			IF(2*P.LT.MIN(Z,Y))
     X THEN			
     				E=D
				D=P/Q
			ELSE
				D=XM
				E=D
			END IF
		ELSE
			D=XM
			E=D
		END IF
		A=B
		FA=FB
		IF(ABS(D).GT.TOL1)THEN
			B=B+D
		ELSE
			B=B+SIGN(TOL1,XM)
		END IF
		FB=FUNC(B)
11	CONTINUE
	PAUSE 'ZBRENT EXCEEDING MAXIMUM ITERATIONS'
	ANS=B
	RETURN
	END 
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	REAL FUNCTION FUNC(XX)
	DOUBLE PRECISION ALPHA,BETA,GAMMA
	COMMON /C/ALPHA,BETA,GAMMA,PR,TR,B,C,D,E,F
	
C  THE EQUATION WHOSE ROOT (XX) IS NEEDED.  
	
     	FUNC=PR*XX/TR-1.0-B/XX-C/XX**2-D/XX**4-E/XX**5-(F/XX**2)
     X*(BETA+GAMMA/XX**2)*EXP(-GAMMA/XX**2)
     
     	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE CH46H2O(EQAH2O)
	
	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION M,MO,H2O,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      	COMMON /T/TITLE

		IF(NCAR.EQ.2) THEN
			X(88)=TMET
			K(88) = 999.8
			KV(88) = 999.8
			CH4MF=0.0
			AX(155)=0.0
			AX(154)=0.0
			X(154)=0.0
			X(155)=0.0
			X(30)=X(30)-X(88)*6*18.01528
			DELGM=X(88)*6*18.01528
		IF(MIX.EQ.0)GO TO 210
			X(87)=TCAR
			K(87) = 999.9
			KV(87) = 999.9
			CO2MF=0.00
			AX(29)=0.0
			AX(21)=0.0
			X(21)=0.0
			X(29)=0.0
			X(30)=X(30)-X(87)*6*18.01528
			DELGM=X(87)*6*18.01528
210	DO 220 J = 1, 25
	IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*(X(30)+DELGM)/X(30)
	IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GO TO 220
	X(J) = X(J) * (X(30) + DELGM) / X(30)
220	CONTINUE
	DO 230 J = 32, 131
		IF ((J.EQ.87).OR.(J.EQ.88)) GO TO 230
		X(J) = X(J) * (X(30) + DELGM) / X(30)
230	CONTINUE
			GO TO 200
		END IF
		
		MO = 0
		M = 0
		H2O = X(30)+6*(X(87)+X(88))*18.01528 + X(31)
		X(31) = 0.0
		X(87) = 0.0
		DO 10 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0)) MO = MO + X(J)
			IF((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 10
			MO = MO + X(J)
10		CONTINUE
		MO=MO+X(152)
		DO 15 J=155,167
			MO=MO+X(J)
15		CONTINUE

		IF (AH2O.GT.EQAH2O) THEN
		DO 70 KA = 1, 5
20			DO 30 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 30
			X(J) = X(J) * DEL(KA)
30			CONTINUE
			X(152)=X(152)*DEL(KA)
			DO 35 J=155,167
				X(J)=X(J)*DEL(KA)
35			CONTINUE
			DO 40 J = 32, 131
				X(J) = X(J) * DEL(KA)
40			CONTINUE
			CALL PITZER
			IF (AH2O .GT. EQAH2O) GOTO 20
			DO 50 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)/DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 50
			X(J) = X(J) / DEL(KA)
50			CONTINUE
			X(152)=X(152)/DEL(KA)
			DO 55 J=155,167
				X(J)=X(J)/DEL(KA)
55			CONTINUE
			DO 60 J = 32, 131
				X(J) = X(J) / DEL(KA)
60			CONTINUE
70		CONTINUE
		
		ELSE
		
		DO 170 KA = 1, 5
120			DO 130 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)/DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 130
			X(J) = X(J) / DEL(KA)
130			CONTINUE
			X(152)=X(152)/DEL(KA)
			DO 135 J=155,167
				X(J)=X(J)/DEL(KA)
135			CONTINUE
			DO 140 J = 32, 131
				X(J) = X(J) / DEL(KA)
140			CONTINUE
			CALL PITZER
			IF (EQAH2O .GT. AH2O) GOTO 120
			DO 150 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*DEL(KA)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 150
			X(J) = X(J) * DEL(KA)
150			CONTINUE
			X(152)=X(152)*DEL(KA)
			DO 155 J=155,167
				X(J)=X(J)*DEL(KA)
155			CONTINUE	
			DO 160 J = 32, 131
				X(J) = X(J) * DEL(KA)
160			CONTINUE
170		CONTINUE
		ENDIF
		
		DO 80 J = 1, 25
			IF((J.EQ.5).AND.(ACID.GT.0.0))M=M+X(J)
			IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GO TO 80
			M = M + X(J)
80		CONTINUE
		M=M+X(152)
		DO 175 J=155,167
			M=M+X(J)
175		CONTINUE
		X(30) = X(30) * MO / M
		X(88) = (H2O - X(30))/(6.0*18.01528)
		IF(X(88).LT.0.0) THEN
			DO 180 J = 1, 25
		IF((J.EQ.5).AND.(ACID.GT.0.0))X(J)=X(J)*X(30)/H2O
		IF ((J.EQ.5).OR.(J.EQ.13).OR.(J.EQ.23)) GOTO 180
			X(J) = X(J) *X(30)/H2O
180			CONTINUE
			X(152)=X(152)*X(30)/H2O
			DO 185 J=155,167
				X(J)=X(J)*X(30)/H2O
185			CONTINUE
			DO 190 J=32,131
				X(J) = X(J)*X(30)/H2O
190			CONTINUE
			X(30) = H2O
			X(88) = 0.0
		END IF		
200	RETURN
	END


C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FECL3
	
C  Subroutine for FeCl3 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,CLT,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	FE10 = K(89)/AH2O**10
	FE6 = K(90)/AH2O**6
	FET = X(9) + X(89) + X(90)
	CLT = X(11) + 3*X(89) + 3*X(90)
	IF (FE10 .GT. FE6) KPRIME = K(90)/(GX(9)*(GX(11))**3*AH2O**6)
      IF (FE6 .GT. FE10) KPRIME = K(89)/(GX(9)*(GX(11))**3*AH2O**10)
	IF (FET*(CLT)**3-KPRIME .GT. 0) GOTO 860
855	X(9) = FET
	X(11) = CLT
	X(89) = 0
	X(90) = 0
	GOTO 880
860	DECREM = MIN(FET,CLT)
	DO 870 KA = 2,5
865		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 855
		X(9) = FET - DELTA
		X(11) = CLT - 3*DELTA
		IF ((X(9).LT.0.0).OR.(X(11).LT.0.0)) GOTO 869
		CALL PITZER
		FE10 = K(89)/AH2O**10
		FE6 = K(90)/AH2O**6
	IF (FE10.GT. FE6) KPRIME = K(90)/(GX(9)*(GX(11))**3*AH2O**6)
      	IF (FE6 .GT. FE10) KPRIME = K(89)/(GX(9)*(GX(11))**3*AH2O**10)
     		IF (X(9)*(X(11))**3-KPRIME .GT. 0) GOTO 865
869		DELTA = DELTA-DECREM*(DEL(KA)-1)
870	CONTINUE
	X(9) = FET - DELTA
	X(11) = CLT - 3*DELTA
	IF (FE10 .GT. FE6) THEN
		X(90) = DELTA
		X(89) = 0
	ELSE
		X(89) = DELTA
		X(90) = 0
	END IF
880	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FECL3KCL
	
C  Subroutine for FECL32KCLH2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

        DOUBLE PRECISION KPRIME,FET,KT,CLT,X,DELTA,AX,K,KV,K0
        DOUBLE PRECISION AH2O,PHI
	
     	DELTA=0.0
	FET = X(9) + X(91)
	KT = X(2) + 2*X(91)
	CLT = X(11) + 5*X(91)
	KPRIME = K(91)/(GX(9)*GX(2)**2*GX(11)**5*AH2O)
	IF (FET*KT**2*CLT**5-KPRIME .GT. 0) GOTO 1050
1040	X(9) = FET
	X(11) = CLT
	X(2) = KT
	X(91) = 0
	GOTO 1080
1050	DECREM = MIN(FET,KT,CLT)
	DO 1070 KA = 2, 5
1060		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1040
		X(9) = FET - DELTA
		X(2) = KT - 2*DELTA
		X(11) = CLT - 5*DELTA
	IF((X(9).LT.0.).OR.(X(2).LT.0.).OR.(X(11).LT.0.)) GOTO 1069
		CALL PITZER
		KPRIME = K(91)/(GX(9)*GX(2)**2*GX(11)**5*AH2O)
		IF (X(9)*X(2)**2*X(11)**5-KPRIME .GT. 0) GOTO 1060
1069		DELTA = DELTA-DECREM*(DEL(KA)-1)
1070	CONTINUE
	X(9) = FET - DELTA
	X(2) = KT - 2*DELTA
	X(11) = CLT - 5*DELTA
	X(91) = DELTA
1080	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------


	SUBROUTINE FE3SO4

C  Subroutine for FE2(SO4)3 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	FET = X(9)+2*X(92)+2*X(96)+2*X(106)
	SO4T = X(12)+3*X(92)+3*X(96)+3*X(106)
	X92 = K(92)/(GX(9)**2*GX(12)**3)
	X96 = K(96)/(GX(9)**2*GX(12)**3*AH2O**9)
	X106 = K(106)/(GX(9)**2*GX(12)**3*AH2O**7)
	KPRIME = MIN(X92,X96,X106)
	IF (FET**2*SO4T**3-KPRIME .GT. 0) GOTO 1285
1282    X(9) = FET
	X(12) = SO4T
	X(92) = 0
	X(96) = 0
	X(106) = 0
	GO TO 1330
1285	DECREM = MIN(FET,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(9) = FET - 2*DELTA
		X(12) = SO4T - 3*DELTA
		IF((X(9).LT.0.).OR.(X(12).LT.0.)) GOTO 1319
		CALL PITZER
		X92 = K(92)/(GX(9)**2*GX(12)**3)
		X96 = K(96)/(GX(9)**2*GX(12)**3*AH2O**9)
		X106 = K(106)/(GX(9)**2*GX(12)**3*AH2O**7)
		KPRIME = MIN(X92,X96,X106)
		IF (X(9)**2*X(12)**3-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(9) = FET - 2*DELTA
	X(12) = SO4T - 3*DELTA
	IF(X92.EQ.KPRIME) THEN
		X(92) = DELTA
		X(96) = 0.0
		X(106) = 0.0
	END IF
	IF(X96.EQ.KPRIME) THEN
		X(96) = DELTA
		X(92) = 0.0
		X(106) = 0.0
	END IF
	IF(X106.EQ.KPRIME) THEN
		X(106) = DELTA
		X(92) = 0.0
		X(96) = 0.0
	END IF
1330	CONTINUE	
	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FE2K4SO4
	
C  Subroutine for FE2(SO4)32K2SO414H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

        DOUBLE PRECISION KPRIME,FET,KT,SO4T,X,DELTA,AX,K,KV,K0
        DOUBLE PRECISION AH2O,PHI
	
     	DELTA=0.0
	FET = X(9) + 2*X(93)
	KT = X(2) + 4*X(93)
	SO4T = X(12) + 5*X(93)
	KPRIME = K(93)/(GX(9)**2*GX(2)**4*GX(12)**5*AH2O**14)
	IF (FET**2*KT**4*SO4T**5-KPRIME .GT. 0) GOTO 1050
1040	X(9) = FET
	X(12) = SO4T
	X(2) = KT
	X(93) = 0
	GOTO 1080
1050	DECREM = MIN(FET,KT,SO4T)
	DO 1070 KA = 2, 5
1060		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1040
		X(9) = FET - 2*DELTA
		X(2) = KT - 4*DELTA
		X(12) = SO4T - 5*DELTA
	IF((X(9).LT.0.).OR.(X(2).LT.0.).OR.(X(12).LT.0.)) GOTO 1069
		CALL PITZER
		KPRIME = K(93)/(GX(9)**2*GX(2)**4*GX(12)**5*AH2O**14)
		IF (X(9)**2*X(2)**4*X(12)**5-KPRIME .GT. 0) GOTO 1060
1069		DELTA = DELTA-DECREM*(DEL(KA)-1)
1070	CONTINUE
	X(9) = FET - 2*DELTA
	X(2) = KT - 4*DELTA
	X(12) = SO4T - 5*DELTA
	X(93) = DELTA
1080	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE K2FESO4
	
C  Subroutine for K2SO4FESO46H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

        DOUBLE PRECISION KPRIME,FET,KT,SO4T,X,DELTA,AX,K,KV,K0
        DOUBLE PRECISION AH2O,PHI
	
     	DELTA=0.0
	FET = X(7) + X(94)
	KT = X(2) + 2*X(94)
	SO4T = X(12) + 2*X(94)
	KPRIME = K(94)/(GX(7)*GX(2)**2*GX(12)**2*AH2O**6)
	IF (FET*KT**2*SO4T**2-KPRIME .GT. 0) GOTO 1050
1040	X(7) = FET
	X(12) = SO4T
	X(2) = KT
	X(94) = 0
	GOTO 1080
1050	DECREM = MIN(FET,KT,SO4T)
	DO 1070 KA = 2, 5
1060		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1040
		X(7) = FET - DELTA
		X(2) = KT - 2*DELTA
		X(12) = SO4T - 2*DELTA
	IF((X(7).LT.0.).OR.(X(2).LT.0.).OR.(X(12).LT.0.)) GOTO 1069
		CALL PITZER
		KPRIME = K(94)/(GX(7)*GX(2)**2*GX(12)**2*AH2O**6)
		IF (X(7)*X(2)**2*X(12)**2-KPRIME .GT. 0) GOTO 1060
1069		DELTA = DELTA-DECREM*(DEL(KA)-1)
1070	CONTINUE
	X(7) = FET - DELTA
	X(2) = KT - 2*DELTA
	X(12) = SO4T - 2*DELTA
	X(94) = DELTA
1080	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE NA2FESO4
	
C  Subroutine for NA2SO4FESO44H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

        DOUBLE PRECISION KPRIME,FET,NAT,SO4T,X,DELTA,AX,K,KV,K0
        DOUBLE PRECISION AH2O,PHI
	
     	DELTA=0.0
	FET = X(7) + X(95)
	NAT = X(1) + 2*X(95)
	SO4T = X(12) + 2*X(95)
	KPRIME = K(95)/(GX(7)*GX(1)**2*GX(12)**2*AH2O**4)
	IF (FET*NAT**2*SO4T**2-KPRIME .GT. 0) GOTO 1050
1040	X(7) = FET
	X(12) = SO4T
	X(1) = NAT
	X(95) = 0
	GOTO 1080
1050	DECREM = MIN(FET,NAT,SO4T)
	DO 1070 KA = 2, 5
1060		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 1040
		X(7) = FET - DELTA
		X(1) = NAT - 2*DELTA
		X(12) = SO4T - 2*DELTA
	IF((X(7).LT.0.).OR.(X(1).LT.0.).OR.(X(12).LT.0.)) GOTO 1069
		CALL PITZER
		KPRIME = K(95)/(GX(7)*GX(1)**2*GX(12)**2*AH2O**4)
		IF (X(7)*X(1)**2*X(12)**2-KPRIME .GT. 0) GOTO 1060
1069		DELTA = DELTA-DECREM*(DEL(KA)-1)
1070	CONTINUE
	X(7) = FET - DELTA
	X(1) = NAT - 2*DELTA
	X(12) = SO4T - 2*DELTA
	X(95) = DELTA
1080	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
		SUBROUTINE FEH
	
C  This subroutine partitions total ferrous and ferric iron complexes
C  based on inputs of either pH or acidity.  

	
	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FEIIT,FEIIIT,X,AX,AA,BA,
     XK,KV,CA,DA,K0,EA,FA,GA,HA
     	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

     

	FEIIT = X(7)+X(8)+X(156)+X(157)
	FEIIIT = X(9)+X(158)+X(159)+X(160)+X(161)
	IF(IRON.EQ.2)THEN
		AX(5) = EXP(-2.302585*PH)
		PHINIT=AX(5)/GX(5)
	END IF
	IF((IRON.EQ.3).OR.(IRON.EQ.4))THEN
		AX(5) = X(5)*GX(5)
		PHINIT=AX(5)
	END IF 

1900	AA = K(8)*GX(7)*AH2O/(GX(8)*AX(5))
	BA = K(156)*GX(7)*AH2O**2/(GX(156)*AX(5)**2)
	CA = K(157)*GX(7)*AH2O**3/(GX(157)*AX(5)**3)
	DA = K(158)*GX(9)*AH2O/(GX(158)*AX(5))
        EA = K(159)*GX(9)*AH2O**2/(GX(159)*AX(5)**2)
	FA = K(160)*GX(9)*AH2O**3/(GX(160)*AX(5)**3)
	GA = K(161)*GX(9)*AH2O**4/(GX(161)*AX(5)**4)
	HA = K(13)*AH2O/(AX(5)*GX(13))
      
        X(7) = FEIIT/(1+AA+BA+CA)
	X(9) = FEIIIT/(1+DA+EA+FA+GA)
	X(8) = AA*X(7)
	X(156) = BA*X(7)
	X(157) = CA*X(7)
	X(158) = DA*X(9)
	X(159) = EA*X(9)
	X(160) = FA*X(9)
	X(161) = GA*X(9)
	X(13) = HA
	CALL PITZER
	IF((IRON.EQ.2).OR.(IRON.EQ.4))THEN
		X(5)=AX(5)/GX(5)
		PCEN = (ABS(X(5)-PHINIT)/PHINIT)*100.0
		IF(PCEN.LT.1.0) GO TO 1930
		PHINIT = X(5)
		GO TO 1900
	END IF
	IF(IRON.EQ.3) THEN 
		AX(5)=X(5)*GX(5)
		PCEN = (ABS(AX(5)-PHINIT)/PHINIT)*100.0
		IF(PCEN.LT.1.0) GO TO 1930
		PHINIT = AX(5)
		GO TO 1900
	END IF

1930	RETURN
	END
C-----------------------------------------------------------------------
	
C-----------------------------------------------------------------------
	SUBROUTINE FE3SO4H

C  Subroutine for FE2(SO4)2H2SO48H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,SO4T,X,KPRIME,AX,K,KV,K0,HT
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    	
	
	DELTA=0.0
	FET = X(9)+2*X(97)
	SO4T = X(12)+4*X(97)
	HT = X(5) + 2*X(97)
	KPRIME = K(97)/(GX(9)**2*GX(12)**4*AH2O**8*GX(5)**2)
	IF (FET**2*SO4T**4*HT**2-KPRIME .GT. 0) GOTO 1285
1282    X(9) = FET
	X(12) = SO4T
	X(5) = HT
	X(97) = 0
	GO TO 1330
1285	DECREM = MIN(FET,SO4T,HT)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(9) = FET - 2*DELTA
		X(12) = SO4T - 4*DELTA
		X(5) = HT - 2*DELTA
		IF((X(9).LT.0.).OR.(X(12).LT.0.).OR.(X(5).LT.0)) 
     X GOTO 1319
		CALL PITZER
	KPRIME = K(97)/(GX(9)**2*GX(12)**4*AH2O**8*GX(5)**2)
		IF (X(9)**2*X(12)**4*X(5)**2-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(9) = FET - 2*DELTA
	X(12) = SO4T - 4*DELTA
	X(5) = HT -2*DELTA
	X(97) = DELTA
1330	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE JAROSITE

C  Subroutine for MFE3(SO4)2(OH)6 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,NAT,FET,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
      
    	CALL PARAMETER
	CALL PITZER
	
    	AP1=GX(1)*X(1)*(GX(9)*X(9))**3*(GX(12)*X(12))**2*AH2O**6
     X/(GX(5)*X(5))**6
     	XNA=AP1/K(99)
	AP5=(GX(9)*X(9))**3*(GX(12)*X(12))**2*AH2O**7
     X/(GX(5)*X(5))**5
     	XH=AP5/K(100)
	AP2=GX(2)*X(2)*(GX(9)*X(9))**3*(GX(12)*X(12))**2*AH2O**6
     X/(GX(5)*X(5))**6
     	XK=AP2/K(98)
	
	IF(XK.EQ.0) GO TO 100
	DELTA=0.0
	FET = X(9)+3*X(98)
	SO4T = X(12)+2*X(98)
	KT = X(2) + X(98)
	KPRIME = K(98)*(GX(5)*X(5))**6/(GX(2)*GX(12)**2*AH2O**6
     X*GX(9)**3)
	IF ((FET**3*SO4T**2*KT-KPRIME) .GT. 0) GOTO 50
40    	X(9) = FET
	X(12) = SO4T
	X(2) = KT
	X(98) = 0
	GO TO 100
50	DECREM = MIN(FET,SO4T,KT)
	DO 60 KA = 2, 5
55		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 40
		X(9) = FET - 3*DELTA
		X(12) = SO4T - 2*DELTA
		X(2) = KT - DELTA
		IF((X(9).LT.0.).OR.(X(12).LT.0.).OR.(X(2).LT.0)) 
     X GOTO 59
		CALL PITZER
	KPRIME = K(98)*(GX(5)*X(5))**6/(GX(2)*GX(12)**2*AH2O**6
     X*GX(9)**3)
		IF (X(9)**3*X(12)**2*X(2)-KPRIME .GT. 0) GOTO 55
59		DELTA = DELTA-DECREM*(DEL(KA)-1)
60	CONTINUE
	X(9) = FET - 3*DELTA
	X(12) = SO4T - 2*DELTA
	X(2) = KT -DELTA
	X(98) = DELTA
	
	
100	IF(XH.EQ.0) GO TO 200
	DELTA=0.0
	FET = X(9)+3*X(100)
	SO4T = X(12)+2*X(100)
	KPRIME = K(100)*(GX(5)*X(5))**5/(GX(12)**2*AH2O**7
     X*GX(9)**3)
	IF ((FET**3*SO4T**2-KPRIME) .GT. 0) GOTO 150
140    	X(9) = FET
	X(12) = SO4T
	X(100) = 0
	GO TO 200
150	DECREM = MIN(FET,SO4T)
	DO 160 KA = 2, 5
155		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 140
		X(9) = FET - 3*DELTA
		X(12) = SO4T - 2*DELTA
		IF((X(9).LT.0.).OR.(X(12).LT.0.)) GOTO 159
		CALL PITZER
	KPRIME = K(100)*(GX(5)*X(5))**5/(GX(12)**2*AH2O**7*GX(9)**3)
		IF (X(9)**3*X(12)**2-KPRIME .GT. 0) GOTO 155
159		DELTA = DELTA-DECREM*(DEL(KA)-1)
160	CONTINUE
	X(9) = FET - 3*DELTA
	X(12) = SO4T - 2*DELTA
	X(100) = DELTA
	
200	IF(XNA.EQ.0) GO TO 300
	DELTA=0.0
	FET = X(9)+3*X(99)
	SO4T = X(12)+2*X(99)
	NAT = X(1) + X(99)
	KPRIME = K(99)*(GX(5)*X(5))**6/(GX(1)*GX(12)**2*AH2O**6
     X*GX(9)**3)
	IF ((FET**3*SO4T**2*NAT-KPRIME) .GT. 0) GOTO 250
240    	X(9) = FET
	X(12) = SO4T
	X(1) = NAT
	X(99) = 0
	GO TO 300
250	DECREM = MIN(FET,SO4T,NAT)
	DO 260 KA = 2, 5
255		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 240
		X(9) = FET - 3*DELTA
		X(12) = SO4T - 2*DELTA
		X(1) = NAT - DELTA
		IF((X(9).LT.0.).OR.(X(12).LT.0.).OR.(X(1).LT.0)) 
     X GOTO 259
		CALL PITZER
	KPRIME = K(99)*(GX(5)*X(5))**6/(GX(1)*GX(12)**2*AH2O**6
     X*GX(9)**3)
		IF (X(9)**3*X(12)**2*X(1)-KPRIME .GT. 0) GOTO 255
259		DELTA = DELTA-DECREM*(DEL(KA)-1)
260	CONTINUE
	X(9) = FET - 3*DELTA
	X(12) = SO4T - 2*DELTA
	X(1) = NAT -DELTA
	X(99) = DELTA
	
300	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FERRICOXIDE
	
C  Subroutine for ferric oxide equilibria.

	
	REAL  IX,I,HEMI,LEPID
	CHARACTER*50 TITLE
	DOUBLE PRECISION FET,SO4T,KPRIME,DELTA,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
     	TJAR = 3*(X(86)+X(102)+X(103))+6*X(101)+2.75*X(104)
	DELTA=0.0
	FET = X(9)+X(86)+2*X(101)+X(102)+X(103)+X(104)
	SO4T = X(12)+0.125*X(104)
	FERRI = K(86)*(GX(5)*X(5))**3/(AH2O**3*GX(9))
	HEMI = (K(101)*(GX(5)*X(5))**6/(AH2O**3*GX(9)**2))**0.5
	GOET = K(102)*(GX(5)*X(5))**3/(AH2O**2*GX(9))
	LEPID= K(103)*(GX(5)*X(5))**3/(AH2O**2*GX(9))
	SCHWER=K(104)*(GX(5)*X(5))**2.75/(GX(9)*(GX(12)*X(12))**0.125
     X*AH2O**1.75)
	KPRIME=MIN(FERRI,HEMI,GOET,LEPID,SCHWER)
	IF (FET-KPRIME .GT. 0) GOTO 1200
1190  	X(9) = FET
	X(12) = SO4T
	X(86) = 0
	X(101) =0
	X(102) = 0
	X(103) = 0
	X(104) = 0
	GO TO 1230

1200	IF(KPRIME.EQ.SCHWER) GO TO 1225
	DECREM = FET
	DO 1220 KA = 2, 5
1210		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA.LT.0) GO TO 1190
		X(9) = FET - DELTA
		IF(X(9).LT.0.) GO TO 1219
		CALL PITZER
		FERRI = K(86)*(GX(5)*X(5))**3/(AH2O**3*GX(9))
		HEMI = (K(101)*(GX(5)*X(5))**6/(AH2O**3*GX(9)**2))**0.5
		GOET = K(102)*(GX(5)*X(5))**3/(AH2O**2*GX(9))
		LEPID= K(103)*(GX(5)*X(5))**3/(AH2O**2*GX(9))
		KPRIME=MIN(FERRI,HEMI,GOET,LEPID)								
		IF (X(9)-KPRIME .GT. 0) GOTO 1210
1219		DELTA = DELTA-DECREM*(DEL(KA)-1)
1220	CONTINUE
	X(9) = FET - DELTA
	IF (FERRI.EQ.KPRIME) THEN
		X(86) = DELTA
		X(101) = 0
		X(102) = 0
		X(103) = 0
	END IF
	IF (HEMI.EQ.KPRIME) THEN
		X(101) = 0.5*DELTA
		X(86) = 0
		X(102) = 0
		X(103) = 0
	END IF
	IF (GOET.EQ.KPRIME) THEN
		X(102) = DELTA
		X(86) = 0
		X(101) = 0
		X(103) = 0
	END IF
	IF(LEPID.EQ.KPRIME)THEN
		X(103) = DELTA
		X(86) = 0
		X(101) = 0
		X(102) = 0
	END IF
	GO TO 1230

C	SCHWERTMANNITE CALCULATIONS
1225	DECREM = MIN(FET,SO4T)
	DO 1228 KA = 2, 5
1226		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA.LT.0) GO TO 1190
		X(9) = FET - DELTA
		X(12) = SO4T-0.125*DELTA
		IF((X(9).LT.0.).OR.(X(12).LT.0)) GOTO 1227
		CALL PITZER
	SCHWER=K(104)*(GX(5)*X(5))**2.75/(GX(9)*(GX(12)*X(12))**0.125
     X*AH2O**1.75)
		IF (X(9)*X(12)**0.125-SCHWER .GT. 0) GOTO 1226
1227		DELTA = DELTA-DECREM*(DEL(KA)-1)
1228	CONTINUE
	X(9) = FET - DELTA
	X(12) = SO4T-0.125*DELTA
	X(104) = DELTA
		
1230 	CONTINUE
	
	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FE3FE2SO4

C  Subroutine for mixed ferric/ferrous sulfate mineral equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FE2T,FE3T,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	FE3T = X(9)+2*X(109)+2*X(110)
	FE2T = X(7)+X(109)+X(110)
	SO4T = X(12)+4*X(109)+4*X(110)
	X109 = K(109)/(GX(9)**2*GX(12)**4*GX(7)*AH2O**22)
	X110 = K(110)/(GX(9)**2*GX(12)**4*GX(7)*AH2O**14)
	KPRIME = MIN(X109,X110)
	IF (FE2T*FE3T**2*SO4T**4-KPRIME .GT. 0) GOTO 1285
1282    X(9) = FE3T
	X(7) = FE2T
	X(12) = SO4T
	X(109) = 0
	X(110) = 0
	GO TO 1330
1285	DECREM = MIN(FE2T,FE3T,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(7) = FE2T-DELTA
		X(9) = FE3T - 2*DELTA
		X(12) = SO4T - 4*DELTA
	IF((X(7).LT.0.).OR.(X(9).LT.0.).OR.(X(12).LT.0.))GOTO 1319
		CALL PITZER
		X109 = K(109)/(GX(9)**2*GX(12)**4*GX(7)*AH2O**22)
		X110 = K(110)/(GX(9)**2*GX(12)**4*GX(7)*AH2O**14)
		KPRIME = MIN(X109,X110)
		IF (X(7)*X(9)**2*X(12)**4-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(7) = FE2T - DELTA
	X(9) = FE3T - 2*DELTA
	X(12) = SO4T - 4*DELTA
	IF(X109.EQ.KPRIME) THEN
		X(109) = DELTA
		X(110) = 0.0
	END IF
	IF(X110.EQ.KPRIME) THEN
		X(110) = DELTA
		X(109) = 0.0
	END IF
	
1330	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE VOLTAITE

C  Subroutine for a mixed ferric/ferrous sulfate mineral.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FE2T,FE3T,KT,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	FE3T = X(9)+4*X(111)
	FE2T = X(7)+5*X(111)
	SO4T = X(12)+12*X(111)
	KT = X(2) + 2*X(111)
	KPRIME=K(111)/(GX(9)**4*GX(12)**12*GX(7)**5*GX(2)**2*AH2O**18)
	IF (KT**2*FE2T**5*FE3T**4*SO4T**12-KPRIME .GT. 0) GOTO 1285
1282    X(9) = FE3T
	X(7) = FE2T
	X(12) = SO4T
	X(2) = KT
	X(111) = 0
	GO TO 1330
1285	DECREM = MIN(KT,FE2T,FE3T,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(2) = KT-2*DELTA
		X(7) = FE2T-5*DELTA
		X(9) = FE3T - 4*DELTA
		X(12) = SO4T - 12*DELTA
       IF((X(2).LT.0.).OR.(X(7).LT.0.).OR.(X(9).LT.0.).OR.(X(12).LT.0.))
     XGOTO 1319
		CALL PITZER
	KPRIME=K(111)/(GX(9)**4*GX(12)**12*GX(7)**5*GX(2)**2*AH2O**18)
	IF (X(2)**2*X(7)**5*X(9)**4*X(12)**12-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(2) = KT-2*DELTA
	X(7) = FE2T - 5*DELTA
	X(9) = FE3T - 4*DELTA
	X(12) = SO4T - 12*DELTA
	X(111) = DELTA
			
1330	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
	SUBROUTINE COPIAPITE

C  Subroutine for a mixed ferric/ferrous sulfate mineral.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FE2T,FE3T,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
    	
	DELTA=0.0
	FE3T = X(9)+4*X(107)
	FE2T = X(7)+X(107)
	SO4T = X(12)+6*X(107)
       KPRIME=K(107)*(X(5)*GX(5))**2/(GX(9)**4*GX(12)**6*GX(7)*AH2O**22)
	IF (FE2T*FE3T**4*SO4T**6-KPRIME .GT. 0) GOTO 1285
1282    X(9) = FE3T
	X(7) = FE2T
	X(12) = SO4T
	X(107) = 0
	GO TO 1330
1285	DECREM = MIN(FE2T,FE3T,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(7) = FE2T-DELTA
		X(9) = FE3T - 4*DELTA
		X(12) = SO4T - 6*DELTA
       IF((X(7).LT.0.).OR.(X(9).LT.0.).OR.(X(12).LT.0.)) GOTO 1319
		CALL PITZER
       KPRIME=K(107)*(GX(5)*X(5))**2/(GX(9)**4*GX(12)**6*GX(7)*AH2O**22)	
	IF (X(7)*X(9)**4*X(12)**6-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(7) = FE2T - DELTA
	X(9) = FE3T - 4*DELTA
	X(12) = SO4T - 6*DELTA
	X(107) = DELTA
	
			
1330	RETURN
	END
C-----------------------------------------------------------------------	
	
C-----------------------------------------------------------------------
	SUBROUTINE FERRICOPIAPITE

C  Subroutine for a ferric sulfate mineral.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION FE3T,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	FE3T = X(9)+5*X(108)
	SO4T = X(12)+6*X(108)
	KPRIME=K(108)*(GX(5)*X(5))**3/(GX(9)**5*GX(12)**6*AH2O**22)
	IF (FE3T**5*SO4T**6-KPRIME .GT. 0) GOTO 1285
1282    X(9) = FE3T
	X(12) = SO4T
	X(108) = 0
	GO TO 1330
1285	DECREM = MIN(FE3T,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(9) = FE3T - 5*DELTA
		X(12) = SO4T - 6*DELTA
       IF((X(9).LT.0.).OR.(X(12).LT.0.)) GOTO 1319
		CALL PITZER
	KPRIME=K(108)*(GX(5)*X(5))**3/(GX(9)**5*GX(12)**6*AH2O**22)	
	IF (X(9)**5*X(12)**6-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(9) = FE3T - 5*DELTA
	X(12) = SO4T - 6*DELTA
	X(108) = DELTA
			
	
1330	RETURN
	END
C-------------------------------------------------------------------

C-------------------------------------------------------------------
		SUBROUTINE OPT2ACIDITY
	
C SUBROUTINE FOR ESTIMATING THE CHARGE BALANCE OF PH SYSTEMS

	REAL  IX,I,HT
	CHARACTER*50 TITLE
	DOUBLE PRECISION X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
	
	
	SO4T=X(12)+X(16)
	BISUL=X(16)
1595	HT=AX(5)/GX(5)+X(16)
	CALL PITZER
																
	CALL BISULFATE(SO4T,HT)
	CALL BORON
	CALL FLUORIDE

	BALAN=X(1)+X(2)+2*X(3)+2*X(4)-X(11)-X(17)+X(6)
     X+2*X(7)+X(8)+3*X(9)+2*X(158)+X(159)-X(157)-X(161)
     X+3*X(10)-X(18)-X(19)+2*X(162)+X(163)-X(165)-X(167)
     X-X(19)-X(20)-X(170)+2*X(172)-X(16)
	Y = BALAN+AX(5)/GX(5)
	Z = 2+(AX(5))/(GX(16)*GX(12)*K(16))
	X(12) = Y/Z
	X(16) = SO4T-X(12)
	
	PCEN=(ABS(X(16)-BISUL))/BISUL*1000.0
	IF (PCEN.LT.1.0) GOTO 1620
	BISUL=X(16)
	GOTO 1595
	

1620	RETURN
	END
	
C----------------------------------------------------------------------

C----------------------------------------------------------------------

		SUBROUTINE ALH
	
C  This subroutine partitions total aluminum complexes
C  based on inputs of either pH or acidity.  

	
	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION ALIIIT,X,AX,
     XK,KV,DA,K0,EA,FA,GA,HA
     	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE

     

	ALIIIT = X(10)+X(162)+X(163)+X(164)+X(165)
	IF(IRON.EQ.2)THEN
		AX(5) = EXP(-2.302585*PH)
		PHINIT=AX(5)/GX(5)
	END IF
	IF((IRON.EQ.3).OR.(IRON.EQ.4))THEN
		AX(5) = X(5)*GX(5)
		PHINIT=AX(5)
	END IF 

1900    DA = K(162)*GX(10)*AH2O/(GX(162)*AX(5))
	EA = K(163)*GX(10)*AH2O**2/(GX(163)*AX(5)**2)
	FA = K(164)*GX(10)*AH2O**3/(GX(164)*AX(5)**3)
	GA = K(165)*GX(10)*AH2O**4/(GX(165)*AX(5)**4)
	HA = K(13)*AH2O/(AX(5)*GX(13))
      
	X(10) = ALIIIT/(1+DA+EA+FA+GA)
	X(162) = DA*X(10)
	X(163) = EA*X(10)
	X(164) = FA*X(10)
	X(165) = GA*X(10)
	X(13) = HA
	CALL PITZER
	IF((IRON.EQ.2).OR.(IRON.EQ.4))THEN
		X(5)=AX(5)/GX(5)
		PCEN = (ABS(X(5)-PHINIT)/PHINIT)*100.0
		IF(PCEN.LT.1.0) GO TO 1930
		PHINIT = X(5)
		GO TO 1900
	END IF
	IF(IRON.EQ.3) THEN 
		AX(5)=X(5)*GX(5)
		PCEN = (ABS(AX(5)-PHINIT)/PHINIT)*100.0
		IF(PCEN.LT.1.0) GO TO 1930
		PHINIT = AX(5)
		GO TO 1900
	END IF

1930	RETURN
	END
C-----------------------------------------------------------------------
	
C-----------------------------------------------------------------------
    
    	SUBROUTINE ALCL3
	
C  Subroutine for ALCl3 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION ALT,CLT,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	ALT = X(10) + X(112)
	CLT = X(11) + 3*X(112)
        KPRIME = K(112)/(GX(10)*(GX(11))**3*AH2O**6)
	IF (ALT*(CLT)**3-KPRIME .GT. 0) GOTO 860
855	X(10) = ALT
	X(11) = CLT
	X(112) = 0
	GOTO 880
860	DECREM = MIN(ALT,CLT)
	DO 870 KA = 2,5
865		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 855
		X(10) = ALT - DELTA
		X(11) = CLT - 3*DELTA
		IF ((X(10).LT.0.0).OR.(X(11).LT.0.0)) GOTO 869
		CALL PITZER
      	KPRIME = K(112)/(GX(10)*(GX(11))**3*AH2O**6)
     		IF (X(10)*(X(11))**3-KPRIME .GT. 0) GOTO 865
869		DELTA = DELTA-DECREM*(DEL(KA)-1)
870	CONTINUE
	X(10) = ALT - DELTA
	X(11) = CLT - 3*DELTA
	X(112) = DELTA
	
880	RETURN
	END
	
C-----------------------------------------------------------------------
     
C-----------------------------------------------------------------------


	SUBROUTINE AL2SO4

C  Subroutine for AL2(SO4)3 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION ALT,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	ALT = X(10)+2*X(113)
	SO4T = X(12)+3*X(113)
	KPRIME = K(113)/(GX(10)**2*GX(12)**3*AH2O**17)
	IF (ALT**2*SO4T**3-KPRIME .GT. 0) GOTO 1285
1282    X(10) =ALT
	X(12) = SO4T
	X(113) = 0
	GO TO 1330
1285	DECREM = MIN(ALT,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(10) = ALT - 2*DELTA
		X(12) = SO4T - 3*DELTA
		IF((X(10).LT.0.).OR.(X(12).LT.0.)) GOTO 1319
		CALL PITZER
		KPRIME = K(113)/(GX(10)**2*GX(12)**3*AH2O**17)
		IF (X(10)**2*X(12)**3-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(10) = ALT - 2*DELTA
	X(12) = SO4T - 3*DELTA
	X(113) = DELTA
1330	CONTINUE	
	RETURN
	END
	
C-----------------------------------------------------------------------
    
C-----------------------------------------------------------------------

	SUBROUTINE NABR
	
C  Subroutine for NaBr equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,CLT,X,AX,KV,K0,K
	DOUBLE PRECISION AH2O,PHI
	DOUBLE PRECISION XTRACE,XMAJOR
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
      
      IF (X(32).EQ.0)THEN
      	IF(X(33).EQ.0)GO TO 880
      END IF
         
      NAT=X(1)+X(32)+X(33)+X(114)
      CLT=X(11)+X(32)+X(33)
      BRT=X(18)+X(114)
  
      	
      	
C SIEMANN-SCHRAMM EQNS. 1,2,4.  USED TO ESTIMATE BR PARTITIONING.  
      WTSUM=0.0
      DO 10 J=1,25
     	 IF((J.EQ.19).OR.(J.EQ.20).OR.(J.EQ.23))GO TO 10
     	 WTSUM=WTSUM+X(J)*WT(J)
10    CONTINUE
      DO J=155,165
      	WTSUM=WTSUM+X(J)*WT(J)
      END DO
      	WTSUM=WTSUM+X(152)*WT(152)+X(30)
      	PERCENTAQ=X(18)*WT(18)*100/WTSUM
       	D=0.172
      	IF(PERCENTAQ.LT.0.134)D=0.1192+0.393807*PERCENTAQ      	
      	PERCENTSS=D*PERCENTAQ
      	A=PERCENTSS
      	B=79.909
      	C=35.453
      	D=22.99
      	XTRACE=(A*C+A*D)/(B*100-A*B+A*C)
      	XMAJOR=1-XTRACE
		Y=3.272487E-2*X(18)/(X(18)+X(11))
      		X(114)=Y*(X(33)+X(32))
      		X(32) = (1.0-Y)*X(32)
      		X(33) =(1.0-Y)*X(33)
      		X(1)=NAT-X(32)-X(33)-X(114)
      		X(11)=CLT-X(32)-X(33)
      		X(18)=BRT-X(114)
      	
880	RETURN
	END
	

C-----------------------------------------------------------------------
    
C-----------------------------------------------------------------------

	SUBROUTINE MGBR2
	
C  Subroutine for MgBr2 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION MGT,CLT,X,AX,KV,K0,K
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
      
      IF(X(36).EQ.0)THEN
      	IF(X(37).EQ.0)THEN
      		IF(X(38).EQ.0)GO TO 880
      	END IF
      END IF
      
      MGT=X(4)+X(36)+X(37)+X(38)+X(115)
      CLT=X(11)+2*(X(36)+X(37)+X(38))
      BRT=X(18)+2*X(115)
      	
C	GMM MODEL
		Y=4.902281E-1*X(18)/(X(18)+X(11))
      		X(115)=Y*(X(36)+X(37)+X(38))
      		X(36) = (1.0-Y)*X(36)
      		X(37) = (1.0-Y)*X(37)
      		X(38) = (1.0-Y)*X(38)
      		X(4)=MGT-X(36)-X(37)-X(38)-X(115)
      		X(11)=CLT-2*(X(36)+X(37)+X(38))
      		X(18)=BRT-2*X(115)
      	
880	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

    	SUBROUTINE GIBBSITE
	
C  Subroutine for AL(OH)3 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION ALT,KPRIME,X,DELTA,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	ALT = X(10) + X(116)
        KPRIME = K(116)*(GX(5)*X(5))**3/(GX(10)*AH2O**3)
	IF (ALT-KPRIME .GT. 0) GOTO 860
855	X(10) = ALT
	IF (X(116).GT.0.0)THEN
		DELTAPARTH = 3*X(116)
		PLUSCHARGE = X(1)+X(2)+2*(X(3)+X(4)+X(7))
		X(1) = X(1) - X(1)*DELTAPARTH/PLUSCHARGE
		X(2) = X(2) - X(2)*DELTAPARTH/PLUSCHARGE
		X(3) = X(3) - X(3)*DELTAPARTH/PLUSCHARGE
		X(4) = X(4) - X(4)*DELTAPARTH/PLUSCHARGE
		X(7) = X(7) - X(7)*DELTAPARTH/PLUSCHARGE
	END IF
	X(116) = 0
	GOTO 880
860	DECREM = ALT
	DO 870 KA = 2,5
865		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 855
		X(10) = ALT - DELTA
		IF (X(10).LT.0.0) GOTO 869
		CALL PITZER
      	KPRIME = K(116)*(GX(5)*X(5))**3/(GX(10)*AH2O**3)
     		IF (X(10)-KPRIME .GT. 0) GOTO 865
869		DELTA = DELTA-DECREM*(DEL(KA)-1)
870	CONTINUE
	X(10) = ALT - DELTA
	X(116) = DELTA
	
880	RETURN
	END
	
C-----------------------------------------------------------------------
     
C-----------------------------------------------------------------------

	SUBROUTINE SILICA

C  Subroutine for SILICA equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION SIT,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	SIT = X(166)+X(167)+X(117)+X(118)
	
	QUARTZ = K(117)*AH2O**2
	AMORPHOUS=K(118)*AH2O**2
	IF (QUARTZ .LT. AMORPHOUS) THEN
		KPRIME = K(117)*AH2O**2
	ELSE
		KPRIME = K(118)*AH2O**2
	END IF
	IF (SIT-KPRIME .GT. 0) GOTO 1285
1282  	X(166)=SIT/(1+(K(166)*GX(166))/(AX(5)*GX(167)))
	X(167) = SIT-X(166)
	X(117) = 0
	X(118) = 0
	GO TO 1330
1285	DECREM = SIT
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(166) = SIT - DELTA
		IF(X(166).LT.0.)GOTO 1319
		AQSIT=X(167)+X(166)
		X(166)=AQSIT/(1+(K(166)*GX(166))/(AX(5)*GX(167)))
		X(167) = AQSIT-X(166)
		CALL PITZER
		QUARTZ = K(117)*AH2O**2
		AMORPHOUS = K(118)*AH2O**2
		IF (QUARTZ .LT. AMORPHOUS) THEN
			KPRIME = K(117)*AH2O**2
		ELSE
			KPRIME = K(118)*AH2O**2
		END IF
		IF (X(166)-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	AQSIT=X(167)+X(166)
	X(166)=AQSIT/(1+(K(166)*GX(166))/(AX(5)*GX(167)))
	X(167) = AQSIT-X(166)
	IF (QUARTZ .LT. AMORPHOUS) THEN
		X(117) = DELTA
		X(118) = 0
	ELSE
		X(118) = DELTA
		X(117) = 0
	END IF
1330	RETURN
	END
	
C-----------------------------------------------------------------------

C----------------------------------------------------------------------
 
 	SUBROUTINE ALUNITE

C  Subroutine for MAL3(SO4)2(OH)6 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,NAT,ALT,SO4T,X,KPRIME,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
      
    	CALL PARAMETER
	CALL PITZER
	
    	AP1=GX(1)*X(1)*(GX(10)*X(10))**3*(GX(12)*X(12))**2*AH2O**6
     X/(GX(5)*X(5))**6
     	XNA=AP1/K(119)
	AP2=GX(2)*X(2)*(GX(10)*X(10))**3*(GX(12)*X(12))**2*AH2O**6
     X/(GX(5)*X(5))**6
     	XK=AP2/K(120)
	
	IF(XK.EQ.0) GO TO 200
	DELTA=0.0
	ALT = X(10)+3*X(119)
	SO4T = X(12)+2*X(119)
	KT = X(2) + X(119)
	KPRIME = K(119)*(GX(5)*X(5))**6/(GX(2)*GX(12)**2*AH2O**6
     X*GX(10)**3)
	IF ((ALT**3*SO4T**2*KT-KPRIME) .GT. 0) GOTO 50
40    	X(10) = ALT
	X(12) = SO4T
	X(2) = KT
	X(119) = 0
	GO TO 200
50	DECREM = MIN(ALT,SO4T,KT)
	DO 60 KA = 2, 5
55		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 40
		X(10) = ALT - 3*DELTA
		X(12) = SO4T - 2*DELTA
		X(2) = KT - DELTA
		IF((X(10).LT.0.).OR.(X(12).LT.0.).OR.(X(2).LT.0)) 
     X GOTO 59
		CALL PITZER
	KPRIME = K(119)*(GX(5)*X(5))**6/(GX(2)*GX(12)**2*AH2O**6
     X*GX(10)**3)
		IF (X(10)**3*X(12)**2*X(2)-KPRIME .GT. 0) GOTO 55
59		DELTA = DELTA-DECREM*(DEL(KA)-1)
60	CONTINUE
	X(10) = ALT - 3*DELTA
	X(12) = SO4T - 2*DELTA
	X(2) = KT -DELTA
	X(119) = DELTA
	
200	IF(XNA.EQ.0) GO TO 300
	DELTA=0.0
	ALT = X(10)+3*X(120)
	SO4T = X(12)+2*X(120)
	NAT = X(1) + X(120)
	KPRIME = K(120)*(GX(5)*X(5))**6/(GX(1)*GX(12)**2*AH2O**6
     X*GX(10)**3)
	IF ((ALT**3*SO4T**2*NAT-KPRIME) .GT. 0) GOTO 250
240    	X(10) = ALT
	X(12) = SO4T
	X(1) = NAT
	X(120) = 0
	GO TO 300
250	DECREM = MIN(ALT,SO4T,NAT)
	DO 260 KA = 2, 5
255		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 240
		X(10) = ALT - 3*DELTA
		X(12) = SO4T - 2*DELTA
		X(1) = NAT - DELTA
		IF((X(10).LT.0.).OR.(X(12).LT.0.).OR.(X(1).LT.0)) 
     X GOTO 259
		CALL PITZER
	KPRIME = K(120)*(GX(5)*X(5))**6/(GX(1)*GX(12)**2*AH2O**6
     X*GX(10)**3)
		IF (X(10)**3*X(12)**2*X(1)-KPRIME .GT. 0) GOTO 255
259		DELTA = DELTA-DECREM*(DEL(KA)-1)
260	CONTINUE
	X(10) = ALT - 3*DELTA
	X(12) = SO4T - 2*DELTA
	X(1) = NAT -DELTA
	X(120) = DELTA
	
300	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
     

	SUBROUTINE ALKSO4

C  Subroutine for KAL(SO4)212H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION ALT,SO4T,X,KPRIME,AX,K,KV,K0,KT
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	ALT = X(10)+X(121)
	SO4T = X(12)+2*X(121)
	KT = X(2)+X(121)
	KPRIME = K(121)/(GX(10)*GX(2)*GX(12)**2*AH2O**12)
	IF (ALT*KT*SO4T**2-KPRIME .GT. 0) GOTO 1285
1282    X(10) =ALT
	X(12) = SO4T
	X(2) = KT
	X(121) = 0
	GO TO 1330
1285	DECREM = MIN(ALT,KT,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(10) = ALT - DELTA
		X(2) = KT - DELTA
		X(12) = SO4T - 2*DELTA
		IF(X(2).LT.0.)GO TO 1319
		IF((X(10).LT.0.).OR.(X(12).LT.0.)) GOTO 1319
		CALL PITZER
		KPRIME = K(121)/(GX(10)*GX(2)*GX(12)**2*AH2O**12)
		IF (X(10)*X(2)*X(12)**2-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(10) = ALT - DELTA
	X(2) = KT-DELTA
	X(12) = SO4T - 2*DELTA
	X(121) = DELTA
1330	CONTINUE	
	RETURN
	END
	
C-----------------------------------------------------------------------
    
C-----------------------------------------------------------------------
     

	SUBROUTINE ALNASO4

C  Subroutine for NAAL(SO4)212H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION ALT,SO4T,X,KPRIME,AX,K,KV,K0,NAT
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	ALT = X(10)+X(122)
	SO4T = X(12)+2*X(122)
	NAT = X(1)+X(122)
	KPRIME = K(122)/(GX(10)*GX(1)*GX(12)**2*AH2O**12)
	IF (ALT*NAT*SO4T**2-KPRIME .GT. 0) GOTO 1285
1282    X(10) =ALT
	X(12) = SO4T
	X(1) = NAT
	X(122) = 0
	GO TO 1330
1285	DECREM = MIN(ALT,NAT,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(10) = ALT - DELTA
		X(1) = NAT - DELTA
		X(12) = SO4T - 2*DELTA
		IF(X(1).LT.0.)GO TO 1319
		IF((X(10).LT.0.).OR.(X(12).LT.0.)) GOTO 1319
		CALL PITZER
		KPRIME = K(122)/(GX(10)*GX(1)*GX(12)**2*AH2O**12)
		IF (X(10)*X(1)*X(12)**2-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(10) = ALT - DELTA
	X(1) = NAT - DELTA
	X(12) = SO4T - 2*DELTA
	X(122) = DELTA
1330	CONTINUE	
	RETURN
	END
	
C-----------------------------------------------------------------------
     
C-----------------------------------------------------------------------
     

	SUBROUTINE ALFESO4

C  Subroutine for FESO4AL2(SO4)322H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION ALT,SO4T,X,KPRIME,AX,K,KV,K0,FET
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	ALT = X(10)+2*X(123)
	SO4T = X(12)+4*X(123)
	FET = X(7)+X(123)
	KPRIME = K(123)/(GX(10)**2*GX(7)*GX(12)**4*AH2O**22)
	IF (ALT**2*FET*SO4T**4-KPRIME .GT. 0) GOTO 1285
1282    X(10) =ALT
	X(12) = SO4T
	X(7) = FET
	X(123) = 0
	GO TO 1330
1285	DECREM = MIN(ALT,FET,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(10) = ALT - 2*DELTA
		X(7) = FET - DELTA
		X(12) = SO4T - 4*DELTA
		IF(X(7).LT.0.)GO TO 1319
		IF((X(10).LT.0.).OR.(X(12).LT.0.)) GOTO 1319
		CALL PITZER
		KPRIME = K(123)/(GX(10)**2*GX(7)*GX(12)**4*AH2O**22)
		IF (X(10)**2*X(7)*X(12)**4-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(10) = ALT - 2*DELTA
	X(7) = FET - DELTA
	X(12) = SO4T - 4*DELTA
	X(123) = DELTA
1330	CONTINUE	
	RETURN
	END
	
C-----------------------------------------------------------------------
    
C-----------------------------------------------------------------------

    	SUBROUTINE KAOLINITE
	
C  Subroutine for AL2SI2O5(OH)4 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION ALT,KPRIME,X,DELTA,AX,K,KV,K0,SIT
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	ALT = X(10) + 2*X(124)
	SIT = X(166) + 2*X(124)
        KPRIME = K(124)*(GX(5)*X(5))**6/(GX(10)**2*GX(166)**2*AH2O)
	IF (ALT**2*SIT**2-KPRIME .GT. 0) GOTO 860
855	X(10) = ALT
	X(166) = SIT
	IF (X(124).GT.0.0)THEN
		DELTAPARTH = 6*X(124)
		PLUSCHARGE = X(1)+X(2)+2*(X(3)+X(4)+X(7))
		X(1) = X(1) - X(1)*DELTAPARTH/PLUSCHARGE
		X(2) = X(2) - X(2)*DELTAPARTH/PLUSCHARGE
		X(3) = X(3) - X(3)*DELTAPARTH/PLUSCHARGE
		X(4) = X(4) - X(4)*DELTAPARTH/PLUSCHARGE
		X(7) = X(7) - X(7)*DELTAPARTH/PLUSCHARGE
	END IF
	X(124) = 0
	GOTO 880
860	DECREM = MIN(ALT,SIT)
	DO 870 KA = 2,5
865		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 855
		X(10) = ALT - 2*DELTA
		X(166) = SIT - 2*DELTA
		IF ((X(10).LT.0.0).OR.(X(166).LT.0.0)) GOTO 869
		CALL PITZER
      	KPRIME = K(124)*(GX(5)*X(5))**6/(GX(10)**2*GX(166)**2*AH2O)
     		IF (X(10)**2*X(166)**2-KPRIME .GT. 0) GOTO 865
869		DELTA = DELTA-DECREM*(DEL(KA)-1)
870	CONTINUE
	X(10) = ALT - 2*DELTA
	X(166) = SIT - 2*DELTA
	X(124) = DELTA
	
880	RETURN
	END
	
C-----------------------------------------------------------------------
     
C-----------------------------------------------------------------------
     

	SUBROUTINE ALMGSO4

C  Subroutine for MGSO4AL2(SO4)322H2O equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION ALT,SO4T,X,KPRIME,AX,K,KV,K0,MGT
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
    
	DELTA=0.0
	ALT = X(10)+2*X(125)
	SO4T = X(12)+4*X(125)
	MGT = X(4)+X(125)
	KPRIME = K(125)/(GX(10)**2*GX(4)*GX(12)**4*AH2O**22)
	IF (ALT**2*MGT*SO4T**4-KPRIME .GT. 0) GOTO 1285
1282    X(10) =ALT
	X(12) = SO4T
	X(4) = MGT
	X(125) = 0
	GO TO 1330
1285	DECREM = MIN(ALT,MGT,SO4T)
	DO 1320 KA = 2, 5
1290		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF(DELTA.LT.0) GO TO 1282
		X(10) = ALT - 2*DELTA
		X(4) = MGT - DELTA
		X(12) = SO4T - 4*DELTA
		IF(X(4).LT.0.)GO TO 1319
		IF((X(10).LT.0.).OR.(X(12).LT.0.)) GOTO 1319
		CALL PITZER
		KPRIME = K(125)/(GX(10)**2*GX(4)*GX(12)**4*AH2O**22)
		IF (X(10)**2*X(4)*X(12)**4-KPRIME .GT. 0) GOTO 1290
1319		DELTA = DELTA-DECREM*(DEL(KA)-1)
1320	CONTINUE
	X(10) = ALT - 2*DELTA
	X(4) = MGT - DELTA
	X(12) = SO4T - 4*DELTA
	X(125) = DELTA
1330	CONTINUE	
	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------     
     
	SUBROUTINE NACLO4
	
C  Subroutine for NaClO4 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION NAT,CLT,KPRIME,X,DELTA,AX,KV,K0,K
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	NAT = X(1) + X(126) + X(131)
	CLT = X(19) + X(126) + X(131)
	KPRIME1 = K(126)/(GX(1)*GX(19)*AH2O)
	KPRIME2 = K(131)/(GX(1)*GX(19)*AH2O**2)
	IF (KPRIME1.LT.KPRIME2) THEN
		KPRIME = KPRIME1
	ELSE
		KPRIME = KPRIME2
	END IF
      	IF (NAT*CLT-KPRIME .GT. 0) GOTO 860
855	X(1) = NAT
	X(19) = CLT
	X(126) = 0
	X(131) = 0
	GOTO 880
860	DECREM = MIN(NAT,CLT)
	DO 870 KA = 2, 5
865		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 855
		X(1) = NAT - DELTA
		X(19) = CLT - DELTA
		IF ((X(1).LT.0.0).OR.(X(19).LT.0.0)) GOTO 869
		call pitzer
		
	      KPRIME1 = K(126)/(GX(1)*GX(19)*AH2O)
	      KPRIME2 = K(131)/(GX(1)*GX(19)*AH2O**2)
	      IF (KPRIME1.LT.KPRIME2) THEN
		KPRIME = KPRIME1
		ELSE
		KPRIME = KPRIME2
		END IF

     		IF (X(1)*X(19)-KPRIME .GT. 0) GOTO 865
869		DELTA = DELTA-DECREM*(DEL(KA)-1)
870	CONTINUE
	X(1) = NAT - DELTA
	X(19) = CLT - DELTA
	IF (KPRIME.EQ.KPRIME1)THEN
		X(126) = DELTA
		X(131) = 0
	ELSE
		X(131) = DELTA
		X(126) = 0
	END IF

880	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE MGCLO4
	
C	Subroutine for Mg(ClO4)2 equilibrium.

	REAL IX,I
      DOUBLE PRECISIONMGT,CLT,KPRIME,KPRIME1,KPRIME2,X,DELTA,AX,K,KV,K0
      	DOUBLE PRECISION AH2O,PHI

	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
     
	DELTA=0.0
	MGT = X(4)+X(127)+X(130)
	CLT = X(19)+2*X(127)+2*X(130)
	KPRIME1 = K(127)/(GX(4)*GX(19)**2*AH2O**8)
	KPRIME2 = K(130)/(GX(4)*GX(19)**2*AH2O**6)
	IF (KPRIME1.LT.KPRIME2) THEN
		KPRIME = KPRIME1
	ELSE
		KPRIME = KPRIME2
	END IF
	IF (MGT*CLT**2-KPRIME .GT. 0) GOTO 960
950	X(4) = MGT
	X(19) = CLT
	X(127) = 0
	X(130) = 0
	GOTO 990
960	DECREM = MIN(MGT,CLT)
	DO 980 KA = 2, 5
970		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 950
		X(4) = MGT - DELTA
		X(19) = CLT-2*DELTA
		IF ((X(4).LT.0.0).OR.(X(19).LT.0.0)) GOTO 979
		call pitzer
			KPRIME1 = K(127)/(GX(4)*GX(19)**2*AH2O**8)
			KPRIME2 = K(130)/(GX(4)*GX(19)**2*AH2O**6)
	IF (KPRIME1.LT.KPRIME2) THEN
		KPRIME = KPRIME1
	ELSE
		KPRIME = KPRIME2
	END IF
     		IF (X(4)*X(19)**2-KPRIME .GT. 0) GOTO 970
979		DELTA = DELTA - DECREM*(DEL(KA)-1)
980	CONTINUE
	X(4) = MGT - DELTA
	X(19) = CLT - 2*DELTA
	IF (KPRIME.EQ.KPRIME1)THEN
		X(127) = DELTA
		X(130) = 0
	ELSE
		X(130) = DELTA
		X(127) = 0
	END IF
990	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
  
  	SUBROUTINE CACLO4
	
C	Subroutine for CA(ClO4)2 equilibrium.

	REAL IX,I
       DOUBLE PRECISION CAT,CLT,KPRIME,X,DELTA,AX,K,KV,K0
       DOUBLE PRECISION AH2O,PHI

	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
     
	DELTA=0.0
	CAT = X(3)+X(128)
	CLT = X(19)+2*X(128)
	KPRIME = K(128)/(GX(3)*GX(19)**2*AH2O**6)
	IF (CAT*CLT**2-KPRIME .GT. 0) GOTO 960
950	X(3) = CAT
	X(19) = CLT
	X(128) = 0
	GOTO 990
960	DECREM = MIN(CAT,CLT)
	DO 980 KA = 2, 5
970		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 950
		X(3) = CAT - DELTA
		X(19) = CLT-2*DELTA
		IF ((X(3).LT.0.0).OR.(X(19).LT.0.0)) GOTO 979
		call pitzer
		KPRIME = K(128)/(GX(3)*GX(19)**2*AH2O**6)
     		IF (X(3)*X(19)**2-KPRIME .GT. 0) GOTO 970
979		DELTA = DELTA - DECREM*(DEL(KA)-1)
980	CONTINUE
	X(3) = CAT - DELTA
	X(19) = CLT - 2*DELTA
	X(128) = DELTA
990	RETURN
	END

C-----------------------------------------------------------------------

C-----------------------------------------------------------------------
   
	SUBROUTINE KCLO4
	
C  Subroutine for KClO4 equilibrium.

	REAL IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION KT,CLT,KPRIME,X,DELTA,AX,KV,K0,K
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	DELTA=0.0
	KT = X(2) + X(129)
	CLT = X(19) + X(129)
	KPRIME = K(129)/(GX(2)*GX(19))
      	IF (KT*CLT-KPRIME .GT. 0) GOTO 860
855	X(2) = KT
	X(19) = CLT
	X(129) = 0
	GOTO 880
860	DECREM = MIN(KT,CLT)
	DO 870 KA = 2, 5
865		DELTA = DELTA+DECREM*(DEL(KA)-1)
		IF (DELTA .LT. 0) GOTO 855
		X(2) = KT - DELTA
		X(19) = CLT - DELTA
		IF ((X(2).LT.0.0).OR.(X(19).LT.0.0)) GOTO 869
		call pitzer
	      KPRIME = K(129)/(GX(2)*GX(19))
     		IF (X(2)*X(19)-KPRIME .GT. 0) GOTO 865
869		DELTA = DELTA-DECREM*(DEL(KA)-1)
870	CONTINUE
	X(2) = KT - DELTA
	X(19) = CLT - DELTA
	X(129) = DELTA
880	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE FLUORIDE
	
	REAL  IX,I,HT
	CHARACTER*50 TITLE
	DOUBLE PRECISION X,AX,K,KV,K0,A,B,C,XX
	DOUBLE PRECISION AH2O,PHI
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS

      COMMON /T/TITLE
	
	GX(170) = GX(11)
	GX(171) = 1.00
	PK=K(170)/(GX(5)*GX(11))
	HT = X(5) + X(171)
	FT = X(170) + X(171)
	A=1
	B=-(FT+HT+PK)
	C=HT*FT
	XX=(-B-SQRT(B**2-4*A*C))/2.0
	X(5)=HT-XX
	X(170) = FT-XX
	X(171) = XX
	
	RETURN
	END
	
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------

	SUBROUTINE BORON
	
C  Subroutine for boron ion equilibrium.

	
	REAL  IX,I
	CHARACTER*50 TITLE
	DOUBLE PRECISION BT,KIONPR,X,AX,K,KV,K0
	DOUBLE PRECISION AH2O,PHI
	
	COMMON /B/ X(200),GX(200),K(200),AH2O,DEL(5),C0(10,11:20),       
     XIX(300),AX(200),TEMP,I,PHI,FX(200),ITER,ACID,C1(10,11:20)
     X,PB,GXV(200),V0(200),KV(200),K0(200),WT(200),RHO,VH2O,YESORNO,
     XCO2MF,AX29I,TCAR,NCAR,ZZZ,TMET,CH4MF,XCO26H2O,XCH46H2O,MIX,
     XAB1(10,11:20),AB2(10,11:20),XXX(21),PSII1,PH,IRON,SA,S,CARBSS
      COMMON /T/TITLE
     
	KIONPR = (K(20)*GX(169)*AH2O)/(GX(20)*GX(5)*X(5))
	BT=X(20)+X(169)
	X(169) = BT/(KIONPR + 1)
	X(20) = BT - X(169)
	RETURN
	END
C-----------------------------------------------------------------------

C-----------------------------------------------------------------------









   





